// for svg output
import processing.pdf.*;

//for timestamps
import java.lang.Object.*;
import java.util.*;

import controlP5.*;

PrintWriter output, uncertaintyO;
String[] poem, poemU;
String[] uncertainty;

int noPoem = 0;
int poemPlease = 0;
int nexistpas = 0;

ControlP5 cp5, cp5_fr;
DropdownList rulesList;

// for window resize
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

import java.awt.*;
import java.awt.geom.*;

int _w, _h, _min_w, _min_h;

int _pronunciations;

boolean _print_pdf = false;
int _pdf_counter = 0;
boolean selWord = false;

//TextView _text_view;
int[] _text_view_origin;
int _text_view_width, _text_view_height;

float[] tabLeft, tabRight; // tab vars
float tabTop, tabBottom;
float tabPad = 10;
//dropdown dropMenu;
int dropi, dropj;
boolean menuOn = false;
String poemFile = "";
String errorMessage = "";
String currUpload = "";

CMUMap _cmuMap;
CMUMap2 _cmuMap2;
pMap _pMap;

//LTS 
LTS lts;

//notation guide
PFrame f;
secondApplet s;

void setup() {
  
  //generate new LTS
  isT = createInput("cmudict04_lts_mod.txt");
  lts = LTS.getInstance(isT);

  _min_w = _min_h = 200;
  _w = 400;
  _h = 800;

  _cmuMap = new CMUMap();
  _cmuMap2 = new CMUMap2();
  _pMap = new pMap();

  // create fonts
  generateFonts();
  
  addExistingRules();

  // set the window dimensions
  _w = 840;
  _h = 640; 
  size( _w, _h );
  
  
  frame.setLocation(0,0);
  //noLoop();
  
  //popout
  f = new PFrame();
  
  makeFields();
  
} 

void generateFonts() {
  _georgia_12 = createFont( "Georgia", 12, true );
  _georgia_14 = createFont( "Georgia", 14, true );
  _georgia_14b = createFont( "Georgia-Bold", 14, true );
  _georgia_16 = createFont( "Georgia", 16, true );
  _georgia_24b = createFont( "Georgia-Bold", 24, true );
  _helvetica_12 = createFont( "Helvetica-Light", 12, true );
  _clairhand_14 = createFont( "ClaireHand-Regular", 14, true );

  _gillsans_16i = createFont( "GillSans-Italic", 16, true );
  _gillsans_20i = createFont( "GillSans-Italic", 20, true );

  //_pixel_font_8 = createFont( "AlBayan-8", 8, false );
  //_pixel_font_bold = createFont( "AlBayan-Bold-8", 8, false );
  _pixel_font_8 = createFont( "LucidaGrande", 8, false );
  
  
}

void draw() {

  background( BACKGROUND_COLOR ); 
  
  drawScene();

  // Poemage label
  textAlign( RIGHT, BOTTOM );
  textFont( _pixel_font_8 );
  //fill( POEMAGE_LABEL_TEXT_COLOR );
  fill(150);
  text( "RhymeDesign v0.1", 80, _h-5 );
  
}

void mouseClicked() {
 int x1 = 520;
 int y1 = 70; 
 int sp = 20;
 for(int i = 0; i < rules.size(); i++){ 
  if(mouseX >= x1+0 && mouseX <= x1+10 && mouseY >= y1+i*sp-4 && mouseY <= y1+i*sp+6){
    rules.remove(i);
  }
 }
 
 if(mouseX >500 && mouseX <= 510 && mouseY >= 407 && mouseY <= 417){
    combineRules = !combineRules;
    println("combine Rules: "+combineRules);
  }
 
}

//draws main interface
void drawScene(){
  color bckg = color(230);
  //color bckg = color(203,224,237);
  textFont( _helvetica_12 );
  textSize(12);
  textAlign(LEFT, TOP);
  pushMatrix();
  translate(20,20);
  stroke(200);
  noFill();
  rect(0,0,450,125);
  fill(bckg);
  rect(0,0,450,20);
  fill(100);
  text("1. Upload Poem",5,5);
  text("Poem File: ",20,50);
  if(nexistpas == 1){
    textSize(11);
    fill(ORANGE);
    String st = "Poems/"+cp5.get(Textfield.class,"poem").getText()+".txt";
    text("The file "+ st + " does not exist...",20,90);
    textSize(12);
  } else if(poemFile.length()>0){
    textSize(11);
    fill(BLUE);
    //String st = "Poems/"+cp5.get(Textfield.class,"poem").getText()+".txt";
    text("Poem uploaded: "+ currUpload,20,90);
    textSize(12);
  }
  //text("Uncertainty File: ",20,80);
  noFill();
  translate(0,150);
  fill(100);
  noFill();
  rect(0,20,450,105);
  fill(bckg);
  rect(0,0,450,20);
  fill(100);
  text("2. Generate Custom Template",5,5);
  if(errorMessage.length() > 0){
    fill(ORANGE);
    text("Error: "+errorMessage,10,60,440,60);
  }
  noFill();
  translate(0,150);
  rect(0,0,450,295);
  fill(bckg);
  rect(0,0,450,20);
  fill(100);
  text("3. Select Existing Template",5,5);
  noFill();
  rect(10,39,427,189);
  popMatrix();
  pushMatrix();
  translate(500,20);
  rect(0,0,315,375);
  fill(bckg);
  rect(0,0,315,20);
  fill(100);
  text("Current Templates",5,5);
  noFill();
  rect(0,height-254,10,10);
  fill(100);
  text("Combine Templates",15,height-255);
  if(combineRules){
    text("\u2713",1,height-255);
  }
  
  text("4. Run Program!",15,height-80);
  if(poemPlease == 1){
    //fill(255,0,0);
    fill(ORANGE);
    text("Please upload a poem",15,height-95);
  }
  noFill();
  translate(20,50);
  textSize(11);
  int sp = 20;
  for(int i = 0; i < rules.size(); i++){
   if(mouseX >= 520+0 && mouseX <= 520+10 && mouseY >= 70+i*sp-4 && mouseY <= 70+i*sp+6){
     fill(200);
   }else{
     noFill();
   }
  rect(0,i*sp-4,10,10);  
  line(0,i*sp-4,10,i*sp+6);
  line(10,i*sp-4,0,i*sp+6);
  fill(100);
  text(rules.get(i).strRule, 20, i*sp-3);
  }
  popMatrix();
}

//submit new rule
public void submit() {
if(!containsRule(cp5.get(Textfield.class,"input").getText())){
if(checkRule(cp5.get(Textfield.class,"input").getText())){
rhymerule rule_tmp = new rhymerule(cp5.get(Textfield.class,"input").getText());
//make sure rule is lega
rules.add(rule_tmp);
}
}
}

//checks that rule is legal
boolean checkRule(String rule){
 if((rule.contains("O") || rule.contains("N") || rule.contains("C")) && (rule.contains("A") || rule.contains("B") || rule.contains("Y")) ){
   errorMessage = "Sorry, rules may not combine syllable(ONC) and visual(ABY) notation";
  return false; 
 }else if((rule.contains("A") || rule.contains("B") || rule.contains("Y")) && rule.contains("-")){
   errorMessage = "Sorry, syllable segmentation (indicated with \"-\") cannot be applied to orthographic representations";
  return false;
 }else if((rule.contains("A") || rule.contains("B") || rule.contains("Y")) && (rule.contains("_{m") | rule.contains("_{v") | rule.contains("_{p"))){
  errorMessage = "For structural rhymes, please use \"_{s}\" ";
  return false; 
 }else if((rule.contains("O") || rule.contains("N") || rule.contains("C")) && rule.contains("_{s}")){
  errorMessage = "For phonetic rhymes, please use a variation of \"_{mvp}\" ";
  return false; 
 }else if((rule.contains("O") || rule.contains("N") || rule.contains("C")) && rule.contains("*")){
  errorMessage = "the symbol \"*\" cannot be applied to syllables"; 
  return false;
 }/*else if((rule.contains("A") || rule.contains("B") || rule.contains("Y")) && rule.contains("\'")){
  errorMessage = "the symbol \" \' \" cannot be applied to orthographic "; 
  return false;
 }*/else{
  errorMessage = "";
  return true; 
 }
}

boolean containsRule(String rr){
 for(int i = 0; i < rules.size(); i++){
  if(rr.equals(rules.get(i).strRule)){
    return true;
  }
 }
return false; 
}

public void upload1() {
clearAll();  
poemFile = cp5.get(Textfield.class,"poem").getText().replaceAll(".txt","");
File f = new File(sketchPath("./Poems/"+poemFile+".txt"));
if(!f.exists()){
 f = new File("../../../../Poems/"+poemFile+".txt"); 
}
if(!f.exists()){
  nexistpas = 1;
}else{
nexistpas = 0;
noPoem = 1;
poem = loadStrings("./Poems/"+poemFile+".txt");
currUpload = "Poems/"+poemFile+".txt";
}
} 

void clearAll(){
 poem = new String[0]; 
 _text_view = null;
 poemFile = "";
 _text_view_origin = new int[0];
}

void loadUncertainty(String _poemFile){
pronNumbers = new int[poem.length*20];
customPron = new String[poem.length*20];
File f = new File(sketchPath("./Poems/"+poemFile+"_uncertainty.txt"));
if (f.exists()) {
  println("uncertainty file exists");
  poemU = loadStrings("./Poems/"+poemFile+"_uncertainty.txt");
  int start = 0;
  int st2 = 0;
  for(int i = 0; i < poemU.length; i++){
    if(poemU[i].length()==0){
     continue; 
    }
    if(start == 0 && poemU[i].charAt(0) == '*'){
     start = 1;
     continue; 
    } else if(start == 1 && poemU[i].charAt(0) == '*'){
      if(st2 == 1){
        return;
      }else{
      start = 0;
      st2 = 1;
      continue;
      } 
    }else if(start == 1){
     if(poemU[i].charAt(0) == '%'){ //skip commented lines
     continue; 
     }else{
      String[] sp = split(poemU[i], ":");
      //println(sp);
      if(sp.length == 2){
      pronNumbers[int(sp[0])] = int(sp[1]);
      }else if(sp.length > 2){
        pronNumbers[int(sp[0])] = int(sp[1]);
        customPron[int(sp[0])] = "";
        customPron[int(sp[0])] = sp[2].replaceAll(" ","_");
        println("custom: "+customPron[int(sp[0])]);
        /*
        for(int c = 2; c < sp.length; c++){  
        if(c > 2){
        customPron[int(sp[0])] += ":";
        }  
        customPron[int(sp[0])] += sp[c].replaceAll(" ","_");
        }*/
      }
     }
    }
    }
  } else {
    //nexistpas = 1;
    println("can't find uncertainty file");
  }
}

public void find_rhymes() {
if(noPoem == 0){
  poemPlease = 1;
  return;  
}else{
 poemPlease = 0; 
}
loadUncertainty(poemFile);
readPoemFile("./Poems/"+poemFile+".txt");
_text_view = new TextView();
_text_view_origin = new int[2];
int m = millis();
_text_view.findRhymes();
int ti = millis()-m;
println("time: "+ti +" "+m);
//String file = poemFile+"_output.txt";//cp5_fr.get(Textfield.class,"input2").getText();
String file = cp5_fr.get(Textfield.class,"input2").getText();
output = createWriter("./Poems/"+file);
uncertaintyO = createWriter("./Poems/"+poemFile+"_uncertainty.txt");
_text_view.printRhymeSets(output);
_text_view.printPoemWithIDs(output, uncertaintyO, file);
output.flush(); // Writes the remaining data to the file
uncertaintyO.flush();
output.close(); // Finishes the file
uncertaintyO.close();
cp5_fr.get(Textfield.class,"input2").setText("output_filename");
File f1 = new File(sketchPath("./Poems/"+cp5_fr.get(Textfield.class,"input2").getText()));
File f2 = new File(sketchPath("./Poems/"+poemFile+"_uncertainty.txt"));
try {
Desktop.getDesktop().open(f1);
} catch (IOException e) { e.printStackTrace(); }
try {
Desktop.getDesktop().open(f2);
} catch (IOException e) { e.printStackTrace(); }
} 

void makeFields(){
  cp5 = new ControlP5(this);
  
  PFont font = createFont("Ariel",11);
  PFont font2 = createFont("helvetica-light",11);
  cp5.setControlFont(new ControlFont(createFont("Ariel", 11), 11));
  
  cp5.addTextfield("input")
     //.setText("...-[ONC'-ONC-ONC]")
     //.setText("...-[O]|[C]'-...")
     //.setText("...[est]*...")
     .setText("[...Y...:...Y...]*&[...Y...]*")
     //.setText("...[A_{s}B_{s}]...")
     .setPosition(40,205)
     .setSize(315,20)
     .setFont(font)
     .setFocus(false)
     .setColor(color(100))
     .setColorForeground(color(200))
     .setColorActive(color(200))
     .setColorBackground(color(255))
     .setColorCursor(color(100))
     ;
   
   cp5.addBang("submit")
     .setPosition(370,205)
     .setSize(80,20)
     .setColorCaptionLabel(color(100))
     .setColorForeground(color(220))
     .setColorActive(color(200))
     .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
     ;  
     
     
     //upload poem
     cp5.addTextfield("poem")
     .setText("Night")
     .setPosition(155,60)
     .setSize(200,20)
     .setFont(font)
     .setFocus(false)
     .setColor(color(100))
     .setColorForeground(color(200))
     .setColorActive(color(200))
     .setColorBackground(color(255))
     .setColorCursor(color(100))
     ;
   
   cp5.addBang("upload1")
     .setPosition(370,60)
     .setSize(80,20)
     .setColorCaptionLabel(color(100))
     .setColorForeground(color(220))
     .setColorActive(color(200))
     .setCaptionLabel("upload")
     .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
     ;  
     
     //find rhymes!
     
     cp5_fr = new ControlP5(this);
     
     cp5_fr.setControlFont(new ControlFont(createFont("Ariel", 11), 11));
  
  cp5_fr.addTextfield("input2")
     .setText("output_filename")
     .setPosition(width-325,height-45)
     .setSize(175,20)
     .setFont(font)
     .setFocus(false)
     .setColor(color(100))
     .setColorForeground(color(200))
     .setColorActive(color(200))
     .setColorBackground(color(255))
     .setColorCursor(color(100))
     ;
   
   cp5_fr.addBang("find_rhymes")
     .setPosition(width-140,height-65)
     .setSize(120,40)
     .setColorCaptionLabel(color(100))
     .setColorForeground(color(220))
     .setColorActive(color(200))
     .setCaptionLabel("Find Rhymes!")
     .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
     ;  
     
     
     //dropdown list
     rulesList = cp5.addDropdownList("existingRulesList")
          .setPosition(32, 360)
          .setSize(425,200)
          .toUpperCase(false) 
          ;
     customize(rulesList);
}

String makeWspace(String orig){
  String res = "";
  //for(int i = 0; i < int(200-textWidth(orig)); i++){
  for(int i = 0; i < 50-orig.length(); i++){
  res += " ";
  }
  return res;
}

void customize(DropdownList ddl) {
  // a convenience function to customize a DropdownList
  ddl.setItemHeight(20);
  ddl.setBarHeight(0);
  ddl.captionLabel().set("");
  ddl.captionLabel().style().marginTop = 3;
  ddl.captionLabel().style().marginLeft = 0;
  ddl.captionLabel().setColor(color(255));
  ddl.valueLabel().style().marginTop = 3;
  for (int i=0;i<existingRules.size();i++) {
    ddl.addItem(existingRules.get(i).name+makeWspace(existingRules.get(i).name)+existingRules.get(i).strRule, i);
    //ddl.addItem(existingRules.get(i).name, i);
    //ddl.addItem("item "+i, i);
  }
  //ddl.scroll(0);
  ddl.setColorBackground(color(255));
  ddl.setColorForeground(color(230));
  ddl.setColorLabel(color(100));
  ddl.setColorActive(color(220));
  ddl.setColorValue(color(220));
  ddl.setBackgroundColor(color(220));
  //ddl.open();
  ddl.setOpen(true);
  ddl.disableCollapse();
}

void controlEvent(ControlEvent theEvent) {
  // DropdownList is of type ControlGroup.
  // A controlEvent will be triggered from inside the ControlGroup class.
  // therefore you need to check the originator of the Event with
  // if (theEvent.isGroup())
  // to avoid an error message thrown by controlP5.
  
  if (theEvent.isGroup()) {
    // check if the Event was triggered from a ControlGroup
    //println("event from group : "+theEvent.getGroup().getValue()+" from "+theEvent.getGroup());
    theEvent.getGroup().setOpen(true);
    if(!rules.contains(existingRules.get(int(theEvent.getGroup().getValue())))){
    rules.add(existingRules.get(int(theEvent.getGroup().getValue())));
    }
    theEvent.getGroup().captionLabel().set("");
  } 
  else if (theEvent.isController()) {
    println("event from controller : "+theEvent.getController().getValue()+" from "+theEvent.getController());
  }
}
