import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.pdf.*; 
import java.lang.Object.*; 
import java.util.*; 
import controlP5.*; 
import java.awt.event.ComponentAdapter; 
import java.awt.event.ComponentEvent; 
import java.awt.*; 
import java.awt.geom.*; 
import java.util.*; 
import java.io.*; 
import java.util.Comparator; 
import java.awt.Frame; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class RhymeDesign extends PApplet {

// for svg output


//for timestamps





PrintWriter output, uncertaintyO;
String[] poem, poemU;
String[] uncertainty;

int noPoem = 0;
int poemPlease = 0;
int nexistpas = 0;

ControlP5 cp5, cp5_fr;
DropdownList rulesList;

// for window resize






int _w, _h, _min_w, _min_h;

int _pronunciations;

boolean _print_pdf = false;
int _pdf_counter = 0;
boolean selWord = false;

//TextView _text_view;
int[] _text_view_origin;
int _text_view_width, _text_view_height;

float[] tabLeft, tabRight; // tab vars
float tabTop, tabBottom;
float tabPad = 10;
//dropdown dropMenu;
int dropi, dropj;
boolean menuOn = false;
String poemFile = "";
String errorMessage = "";
String currUpload = "";

CMUMap _cmuMap;
CMUMap2 _cmuMap2;
pMap _pMap;

//LTS 
LTS lts;

//notation guide
PFrame f;
secondApplet s;

public void setup() {
  
  //generate new LTS
  isT = createInput("cmudict04_lts_mod.txt");
  lts = LTS.getInstance(isT);

  _min_w = _min_h = 200;
  _w = 400;
  _h = 800;

  _cmuMap = new CMUMap();
  _cmuMap2 = new CMUMap2();
  _pMap = new pMap();

  // create fonts
  generateFonts();
  
  addExistingRules();

  // set the window dimensions
  _w = 840;
  _h = 640; 
  size( _w, _h );
  
  
  frame.setLocation(0,0);
  //noLoop();
  
  //popout
  f = new PFrame();
  
  makeFields();
  
} 

public void generateFonts() {
  _georgia_12 = createFont( "Georgia", 12, true );
  _georgia_14 = createFont( "Georgia", 14, true );
  _georgia_14b = createFont( "Georgia-Bold", 14, true );
  _georgia_16 = createFont( "Georgia", 16, true );
  _georgia_24b = createFont( "Georgia-Bold", 24, true );
  _helvetica_12 = createFont( "Helvetica-Light", 12, true );
  _clairhand_14 = createFont( "ClaireHand-Regular", 14, true );

  _gillsans_16i = createFont( "GillSans-Italic", 16, true );
  _gillsans_20i = createFont( "GillSans-Italic", 20, true );

  //_pixel_font_8 = createFont( "AlBayan-8", 8, false );
  //_pixel_font_bold = createFont( "AlBayan-Bold-8", 8, false );
  _pixel_font_8 = createFont( "LucidaGrande", 8, false );
  
  
}

public void draw() {

  background( BACKGROUND_COLOR ); 
  
  drawScene();

  // Poemage label
  textAlign( RIGHT, BOTTOM );
  textFont( _pixel_font_8 );
  //fill( POEMAGE_LABEL_TEXT_COLOR );
  fill(150);
  text( "RhymeDesign v0.1", 80, _h-5 );
  
}

public void mouseClicked() {
 int x1 = 520;
 int y1 = 70; 
 int sp = 20;
 for(int i = 0; i < rules.size(); i++){ 
  if(mouseX >= x1+0 && mouseX <= x1+10 && mouseY >= y1+i*sp-4 && mouseY <= y1+i*sp+6){
    rules.remove(i);
  }
 }
 
 if(mouseX >500 && mouseX <= 510 && mouseY >= 407 && mouseY <= 417){
    combineRules = !combineRules;
    println("combine Rules: "+combineRules);
  }
 
}

//draws main interface
public void drawScene(){
  int bckg = color(230);
  //color bckg = color(203,224,237);
  textFont( _helvetica_12 );
  textSize(12);
  textAlign(LEFT, TOP);
  pushMatrix();
  translate(20,20);
  stroke(200);
  noFill();
  rect(0,0,450,125);
  fill(bckg);
  rect(0,0,450,20);
  fill(100);
  text("1. Upload Poem",5,5);
  text("Poem File: ",20,50);
  if(nexistpas == 1){
    textSize(11);
    fill(ORANGE);
    String st = "Poems/"+cp5.get(Textfield.class,"poem").getText()+".txt";
    text("The file "+ st + " does not exist...",20,90);
    textSize(12);
  } else if(poemFile.length()>0){
    textSize(11);
    fill(BLUE);
    //String st = "Poems/"+cp5.get(Textfield.class,"poem").getText()+".txt";
    text("Poem uploaded: "+ currUpload,20,90);
    textSize(12);
  }
  //text("Uncertainty File: ",20,80);
  noFill();
  translate(0,150);
  fill(100);
  noFill();
  rect(0,20,450,105);
  fill(bckg);
  rect(0,0,450,20);
  fill(100);
  text("2. Generate Custom Template",5,5);
  if(errorMessage.length() > 0){
    fill(ORANGE);
    text("Error: "+errorMessage,10,60,440,60);
  }
  noFill();
  translate(0,150);
  rect(0,0,450,295);
  fill(bckg);
  rect(0,0,450,20);
  fill(100);
  text("3. Select Existing Template",5,5);
  noFill();
  rect(10,39,427,189);
  popMatrix();
  pushMatrix();
  translate(500,20);
  rect(0,0,315,375);
  fill(bckg);
  rect(0,0,315,20);
  fill(100);
  text("Current Templates",5,5);
  noFill();
  rect(0,height-254,10,10);
  fill(100);
  text("Combine Templates",15,height-255);
  if(combineRules){
    text("\u2713",1,height-255);
  }
  
  text("4. Run Program!",15,height-80);
  if(poemPlease == 1){
    //fill(255,0,0);
    fill(ORANGE);
    text("Please upload a poem",15,height-95);
  }
  noFill();
  translate(20,50);
  textSize(11);
  int sp = 20;
  for(int i = 0; i < rules.size(); i++){
   if(mouseX >= 520+0 && mouseX <= 520+10 && mouseY >= 70+i*sp-4 && mouseY <= 70+i*sp+6){
     fill(200);
   }else{
     noFill();
   }
  rect(0,i*sp-4,10,10);  
  line(0,i*sp-4,10,i*sp+6);
  line(10,i*sp-4,0,i*sp+6);
  fill(100);
  text(rules.get(i).strRule, 20, i*sp-3);
  }
  popMatrix();
}

//submit new rule
public void submit() {
if(!containsRule(cp5.get(Textfield.class,"input").getText())){
if(checkRule(cp5.get(Textfield.class,"input").getText())){
rhymerule rule_tmp = new rhymerule(cp5.get(Textfield.class,"input").getText());
//make sure rule is lega
rules.add(rule_tmp);
}
}
}

//checks that rule is legal
public boolean checkRule(String rule){
 if((rule.contains("O") || rule.contains("N") || rule.contains("C")) && (rule.contains("A") || rule.contains("B") || rule.contains("Y")) ){
   errorMessage = "Sorry, rules may not combine syllable(ONC) and visual(ABY) notation";
  return false; 
 }else if((rule.contains("A") || rule.contains("B") || rule.contains("Y")) && rule.contains("-")){
   errorMessage = "Sorry, syllable segmentation (indicated with \"-\") cannot be applied to orthographic representations";
  return false;
 }else if((rule.contains("A") || rule.contains("B") || rule.contains("Y")) && (rule.contains("_{m") | rule.contains("_{v") | rule.contains("_{p"))){
  errorMessage = "For structural rhymes, please use \"_{s}\" ";
  return false; 
 }else if((rule.contains("O") || rule.contains("N") || rule.contains("C")) && rule.contains("_{s}")){
  errorMessage = "For phonetic rhymes, please use a variation of \"_{mvp}\" ";
  return false; 
 }else if((rule.contains("O") || rule.contains("N") || rule.contains("C")) && rule.contains("*")){
  errorMessage = "the symbol \"*\" cannot be applied to syllables"; 
  return false;
 }/*else if((rule.contains("A") || rule.contains("B") || rule.contains("Y")) && rule.contains("\'")){
  errorMessage = "the symbol \" \' \" cannot be applied to orthographic "; 
  return false;
 }*/else{
  errorMessage = "";
  return true; 
 }
}

public boolean containsRule(String rr){
 for(int i = 0; i < rules.size(); i++){
  if(rr.equals(rules.get(i).strRule)){
    return true;
  }
 }
return false; 
}

public void upload1() {
clearAll();  
poemFile = cp5.get(Textfield.class,"poem").getText().replaceAll(".txt","");
File f = new File(sketchPath("./Poems/"+poemFile+".txt"));
if(!f.exists()){
 f = new File("../../../../Poems/"+poemFile+".txt"); 
}
if(!f.exists()){
  nexistpas = 1;
}else{
nexistpas = 0;
noPoem = 1;
poem = loadStrings("./Poems/"+poemFile+".txt");
currUpload = "Poems/"+poemFile+".txt";
}
} 

public void clearAll(){
 poem = new String[0]; 
 _text_view = null;
 poemFile = "";
 _text_view_origin = new int[0];
}

public void loadUncertainty(String _poemFile){
pronNumbers = new int[poem.length*20];
customPron = new String[poem.length*20];
File f = new File(sketchPath("./Poems/"+poemFile+"_uncertainty.txt"));
if (f.exists()) {
  println("uncertainty file exists");
  poemU = loadStrings("./Poems/"+poemFile+"_uncertainty.txt");
  int start = 0;
  int st2 = 0;
  for(int i = 0; i < poemU.length; i++){
    if(poemU[i].length()==0){
     continue; 
    }
    if(start == 0 && poemU[i].charAt(0) == '*'){
     start = 1;
     continue; 
    } else if(start == 1 && poemU[i].charAt(0) == '*'){
      if(st2 == 1){
        return;
      }else{
      start = 0;
      st2 = 1;
      continue;
      } 
    }else if(start == 1){
     if(poemU[i].charAt(0) == '%'){ //skip commented lines
     continue; 
     }else{
      String[] sp = split(poemU[i], ":");
      //println(sp);
      if(sp.length == 2){
      pronNumbers[PApplet.parseInt(sp[0])] = PApplet.parseInt(sp[1]);
      }else if(sp.length > 2){
        pronNumbers[PApplet.parseInt(sp[0])] = PApplet.parseInt(sp[1]);
        customPron[PApplet.parseInt(sp[0])] = "";
        customPron[PApplet.parseInt(sp[0])] = sp[2].replaceAll(" ","_");
        println("custom: "+customPron[PApplet.parseInt(sp[0])]);
        /*
        for(int c = 2; c < sp.length; c++){  
        if(c > 2){
        customPron[int(sp[0])] += ":";
        }  
        customPron[int(sp[0])] += sp[c].replaceAll(" ","_");
        }*/
      }
     }
    }
    }
  } else {
    //nexistpas = 1;
    println("can't find uncertainty file");
  }
}

public void find_rhymes() {
if(noPoem == 0){
  poemPlease = 1;
  return;  
}else{
 poemPlease = 0; 
}
loadUncertainty(poemFile);
readPoemFile("./Poems/"+poemFile+".txt");
_text_view = new TextView();
_text_view_origin = new int[2];
int m = millis();
_text_view.findRhymes();
int ti = millis()-m;
println("time: "+ti +" "+m);
//String file = poemFile+"_output.txt";//cp5_fr.get(Textfield.class,"input2").getText();
String file = cp5_fr.get(Textfield.class,"input2").getText();
output = createWriter("./Poems/"+file);
uncertaintyO = createWriter("./Poems/"+poemFile+"_uncertainty.txt");
_text_view.printRhymeSets(output);
_text_view.printPoemWithIDs(output, uncertaintyO, file);
output.flush(); // Writes the remaining data to the file
uncertaintyO.flush();
output.close(); // Finishes the file
uncertaintyO.close();
cp5_fr.get(Textfield.class,"input2").setText("output_filename");
File f1 = new File(sketchPath("./Poems/"+cp5_fr.get(Textfield.class,"input2").getText()));
File f2 = new File(sketchPath("./Poems/"+poemFile+"_uncertainty.txt"));
try {
Desktop.getDesktop().open(f1);
} catch (IOException e) { e.printStackTrace(); }
try {
Desktop.getDesktop().open(f2);
} catch (IOException e) { e.printStackTrace(); }
} 

public void makeFields(){
  cp5 = new ControlP5(this);
  
  PFont font = createFont("Ariel",11);
  PFont font2 = createFont("helvetica-light",11);
  cp5.setControlFont(new ControlFont(createFont("Ariel", 11), 11));
  
  cp5.addTextfield("input")
     //.setText("...-[ONC'-ONC-ONC]")
     //.setText("...-[O]|[C]'-...")
     //.setText("...[est]*...")
     .setText("[...Y...:...Y...]*&[...Y...]*")
     //.setText("...[A_{s}B_{s}]...")
     .setPosition(40,205)
     .setSize(315,20)
     .setFont(font)
     .setFocus(false)
     .setColor(color(100))
     .setColorForeground(color(200))
     .setColorActive(color(200))
     .setColorBackground(color(255))
     .setColorCursor(color(100))
     ;
   
   cp5.addBang("submit")
     .setPosition(370,205)
     .setSize(80,20)
     .setColorCaptionLabel(color(100))
     .setColorForeground(color(220))
     .setColorActive(color(200))
     .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
     ;  
     
     
     //upload poem
     cp5.addTextfield("poem")
     .setText("Night")
     .setPosition(155,60)
     .setSize(200,20)
     .setFont(font)
     .setFocus(false)
     .setColor(color(100))
     .setColorForeground(color(200))
     .setColorActive(color(200))
     .setColorBackground(color(255))
     .setColorCursor(color(100))
     ;
   
   cp5.addBang("upload1")
     .setPosition(370,60)
     .setSize(80,20)
     .setColorCaptionLabel(color(100))
     .setColorForeground(color(220))
     .setColorActive(color(200))
     .setCaptionLabel("upload")
     .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
     ;  
     
     //find rhymes!
     
     cp5_fr = new ControlP5(this);
     
     cp5_fr.setControlFont(new ControlFont(createFont("Ariel", 11), 11));
  
  cp5_fr.addTextfield("input2")
     .setText("output_filename")
     .setPosition(width-325,height-45)
     .setSize(175,20)
     .setFont(font)
     .setFocus(false)
     .setColor(color(100))
     .setColorForeground(color(200))
     .setColorActive(color(200))
     .setColorBackground(color(255))
     .setColorCursor(color(100))
     ;
   
   cp5_fr.addBang("find_rhymes")
     .setPosition(width-140,height-65)
     .setSize(120,40)
     .setColorCaptionLabel(color(100))
     .setColorForeground(color(220))
     .setColorActive(color(200))
     .setCaptionLabel("Find Rhymes!")
     .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
     ;  
     
     
     //dropdown list
     rulesList = cp5.addDropdownList("existingRulesList")
          .setPosition(32, 360)
          .setSize(425,200)
          .toUpperCase(false) 
          ;
     customize(rulesList);
}

public String makeWspace(String orig){
  String res = "";
  //for(int i = 0; i < int(200-textWidth(orig)); i++){
  for(int i = 0; i < 50-orig.length(); i++){
  res += " ";
  }
  return res;
}

public void customize(DropdownList ddl) {
  // a convenience function to customize a DropdownList
  ddl.setItemHeight(20);
  ddl.setBarHeight(0);
  ddl.captionLabel().set("");
  ddl.captionLabel().style().marginTop = 3;
  ddl.captionLabel().style().marginLeft = 0;
  ddl.captionLabel().setColor(color(255));
  ddl.valueLabel().style().marginTop = 3;
  for (int i=0;i<existingRules.size();i++) {
    ddl.addItem(existingRules.get(i).name+makeWspace(existingRules.get(i).name)+existingRules.get(i).strRule, i);
    //ddl.addItem(existingRules.get(i).name, i);
    //ddl.addItem("item "+i, i);
  }
  //ddl.scroll(0);
  ddl.setColorBackground(color(255));
  ddl.setColorForeground(color(230));
  ddl.setColorLabel(color(100));
  ddl.setColorActive(color(220));
  ddl.setColorValue(color(220));
  ddl.setBackgroundColor(color(220));
  //ddl.open();
  ddl.setOpen(true);
  ddl.disableCollapse();
}

public void controlEvent(ControlEvent theEvent) {
  // DropdownList is of type ControlGroup.
  // A controlEvent will be triggered from inside the ControlGroup class.
  // therefore you need to check the originator of the Event with
  // if (theEvent.isGroup())
  // to avoid an error message thrown by controlP5.
  
  if (theEvent.isGroup()) {
    // check if the Event was triggered from a ControlGroup
    //println("event from group : "+theEvent.getGroup().getValue()+" from "+theEvent.getGroup());
    theEvent.getGroup().setOpen(true);
    if(!rules.contains(existingRules.get(PApplet.parseInt(theEvent.getGroup().getValue())))){
    rules.add(existingRules.get(PApplet.parseInt(theEvent.getGroup().getValue())));
    }
    theEvent.getGroup().captionLabel().set("");
  } 
  else if (theEvent.isController()) {
    println("event from controller : "+theEvent.getController().getValue()+" from "+theEvent.getController());
  }
}



//creating CMU map

class CMUMap {

  Map<String, ArrayList<String>> cmuMap = new HashMap<String, ArrayList<String>>();

  CMUMap() {

    String v2 = "(2)";
    String v3 = "(3)";
    String v4 = "(4)";

    String[] lines = loadStrings("data/syllabifiedCMU_NM.txt");
    String[] values = new String[3];
    String tmp, str;

    for (int i = 0; i < lines.length; i++) {
      String[] pieces = split(lines[i], " ");
      if (pieces[0].indexOf(v2) != -1) {
        //println(pieces[0]);
        tmp = pieces[0].substring(0, pieces[0].length() - 3);
        //str = pieces[1].replaceAll("-", " ");
        cmuMap.get(tmp).add(pieces[1]);
      } 
      else if (pieces[0].indexOf(v3) != -1) {
        tmp = pieces[0].substring(0, pieces[0].length() - 3);
        //str = pieces[1].replaceAll("-", " ");
        //println(tmp);
        cmuMap.get(tmp).add(pieces[1]);
      } 
      else if (pieces[0].indexOf(v4) != -1) {
        tmp = pieces[0].substring(0, pieces[0].length() - 3);
        //str = pieces[1].replaceAll("-", " ");
        //println(tmp);
        cmuMap.get(tmp).add(pieces[1]);
      } 
      else {
        //println(pieces[0]);
        //str = pieces[1].replaceAll("-", " ");
        cmuMap.put(pieces[0], new ArrayList());
        cmuMap.get(pieces[0]).add(pieces[1]);
      }
    }
  }

  public ArrayList<String>  getPhonemes(String word) {
    word = word.toUpperCase();
    if (cmuMap.get(word) == null) {
      return null;
    } 
    else {
      ArrayList<String> phonemeVec = cmuMap.get(word);
      //println("pvec: "+phonemeVec);
      return phonemeVec;
    }
  }

  public String  getFirstPhoneme(String word) {
    String Defs = "", Hom = "";
    //word = word.replaceAll("[.,;:()?-]", "");
    word = word.toUpperCase();
    if (cmuMap.get(word) == null) {
      //println("Skipping: " + word);
      String str = "?";
      return str;
      //return secondSearch(word);
    } else {
      //word = word.replaceAll("[.,;:()?-]", "");
      /*if(homonym(word) == true){
       Hom = " \" ";
       }*/
      ArrayList<String> phonemeVec = cmuMap.get(word);
      _pronunciations = phonemeVec.size();
      String noStress = phonemeVec.get(0); //.replaceAll("[012]", "");
      /*if (_pronunciations > 1) {
        noStress += ":" + _pronunciations;
      }*/
      return noStress + ":" + _pronunciations;
    }
  }
  
  public String  getSecondPhoneme(String word) {
    String Defs = "", Hom = "";
    //word = word.replaceAll("[.,;:()?-]", "");
    word = word.toUpperCase();
    if (cmuMap.get(word) == null) {
      //println("Skipping: " + word);
      String str = "?";
      return str;
      //return secondSearch(word);
    } else {
      //word = word.replaceAll("[.,;:()?-]", "");
      /*if(homonym(word) == true){
       Hom = " \" ";
       }*/
      ArrayList<String> phonemeVec = cmuMap.get(word);
      String noStress = "";
      _pronunciations = phonemeVec.size();
      if(_pronunciations > 1){
      noStress = phonemeVec.get(1); //.replaceAll("[012]", "");
      }else{
        noStress = phonemeVec.get(0);
      }
      /*if (_pronunciations > 1) {
        noStress += ":" + _pronunciations;
      }*/
      return noStress + ":" + _pronunciations;
    }
  }
  
  public String secondSearch2(String word) {
    String noStress = ""; 
    String[] split = splitTokens(word, "(),:;-.'");
    for (int i = 0; i < split.length; i++) {
      if (cmuMap.get(split[i]) == null) {
        println(split[i].substring(split[i].length()-4));
        if (cmuMap.get(split[i].substring(split[i].length()-4)) != null && cmuMap.get(split[i].substring(0, split[i].length()-4)) != null) {
          //if(split[i].substring(split[i].length()-4).equals(MENT)){
          String str1 = split[i].substring(0, split[i].length()-4);
          String str2 = split[i].substring(split[i].length()-4);
          String p1 = getPhonemeVec(str1);
          String p2 = getPhonemeVec(str2);
          println(str1+ " , " + str2);
          println(p1+ "-" + p2);
          noStress += p1+ "-" + p2 + " ";
        } 
        else {
          println(split[i]);
          noStress += "";
        }
      } 
      else {    
        //noStress = getPhonemeVec(split[i]);
        ArrayList<String> phonemeVec = cmuMap.get(split[i]);
        _pronunciations = phonemeVec.size();
        String noStressTmp = phonemeVec.get(0).replaceAll("[012]", "");
        if (_pronunciations > 1) {
          //noStress += noStressTmp + " (" + _pronunciations + ") ";
        } 
        else {
          noStress += noStressTmp + "";
          println(noStress);
        }
      }
    }
    return noStress;
  }

  public String secondSearch(String word) {
    String noStress = ""; 
    //String MENT = "MENT", MENTS = "MENTS", ING = "ING";
    String[] split = splitTokens(word, "(),:;-.'");
    for (int i = 0; i < split.length; i++) {
      if (cmuMap.get(split[i]) == null) {
        println(split[i].substring(split[i].length()-4));
        if (cmuMap.get(split[i].substring(split[i].length()-4)) != null && cmuMap.get(split[i].substring(0, split[i].length()-4)) != null) {
          //if(split[i].substring(split[i].length()-4).equals(MENT)){
          String str1 = split[i].substring(0, split[i].length()-4);
          String str2 = split[i].substring(split[i].length()-4);
          String p1 = getPhonemeVec(str1);
          String p2 = getPhonemeVec(str2);
          println(str1+ " , " + str2);
          println(p1+ "-" + p2);
          noStress += p1+ "-" + p2 + " ";
        } 
        else {
          println(split[i]);
          noStress += "";
        }
      } 
      else {    
        //noStress = getPhonemeVec(split[i]);
        ArrayList<String> phonemeVec = cmuMap.get(split[i]);
        _pronunciations = phonemeVec.size();
        String noStressTmp = phonemeVec.get(0).replaceAll("[012]", "");
        if (_pronunciations > 1) {
          //noStress += noStressTmp + " (" + _pronunciations + ") ";
        } 
        else {
          noStress += noStressTmp + "";
          println(noStress);
        }
      }
    }
    return noStress;
  }

  public String getPhonemeVec(String wrd) {
    ArrayList<String> phonemeVec = cmuMap.get(wrd);
    int _pronunciations = phonemeVec.size();
    String noStress = "";
    String noStressTmp = phonemeVec.get(0).replaceAll("[012]", "");
    if (_pronunciations > 1) {
      //noStress += noStressTmp + " (" + _pronunciations + ") ";
    } 
    else {

      noStress += noStressTmp;
    }
    return noStress;
  }
} //end of CMU class

/////////////////////////////////////just for phonemes!////////////////////combine later

class CMUMap2 {

  Map<String, ArrayList<String>> cmuMap = new HashMap<String, ArrayList<String>>();

  CMUMap2() {

    String v2 = "(1)";
    String v3 = "(2)";
    String v4 = "(3)";

    String[] lines = loadStrings("data/CMUnymsgraphs.txt");
    String[] values = new String[3];
    String tmp, str;

    for (int i = 0; i < lines.length; i++) {
      String[] pieces = split(lines[i], "  ");
      if (pieces[0].indexOf(v2) != -1) {
        tmp = pieces[0].substring(0, pieces[0].length() - 3);
        //str = pieces[1].replaceAll("-", " ");
        //println(tmp);
        cmuMap.get(tmp).add(pieces[1]);
      } 
      else if (pieces[0].indexOf(v3) != -1) {
        tmp = pieces[0].substring(0, pieces[0].length() - 3);
        //str = pieces[1].replaceAll("-", " ");
        //println(tmp);
        cmuMap.get(tmp).add(pieces[1]);
      } 
      else if (pieces[0].indexOf(v4) != -1) {
        tmp = pieces[0].substring(0, pieces[0].length() - 3);
        //str = pieces[1].replaceAll("-", " ");
        //println(tmp);
        cmuMap.get(tmp).add(pieces[1]);
      } 
      else {
        //println(pieces[0]);
        //str = pieces[1].replaceAll("-", " ");
        cmuMap.put(pieces[0], new ArrayList());
        cmuMap.get(pieces[0]).add(pieces[1]);
      }
    }
  }

  public ArrayList<String>  getPhonemes(String word) {
    word = word.toUpperCase();
    if (cmuMap.get(word) == null) {
      return null;
    } 
    else {
      ArrayList<String> phonemeVec = cmuMap.get(word);
      return phonemeVec;
    }
  }

  public String  getFirstPhoneme(String word) {
    String Defs = "", Hom = "";
    word = word.toUpperCase();
    if (cmuMap.get(word) == null) {
      return secondSearch(word);
    } else {
          //word = word.replaceAll("[.,;:()?-]", "");
          /*if(homonym(word) == true){
             Hom = " \" ";
            }*/
          ArrayList<String> phonemeVec = cmuMap.get(word);
          _pronunciations = phonemeVec.size();
          String noStress = phonemeVec.get(0).replaceAll("[012]", "");
          if (_pronunciations > 1) {
            /*if(multiDefs(word) == true){
             Defs = "*";
            }*/
            /*if(homographs(word) == true){
             Defs = "*";
            }*/
            noStress += " (" + _pronunciations + ")";
          }
          return noStress + Defs + Hom;
        }
  }

public String secondSearch(String word){
  String noStress = ""; 
  String MENT = "MENT", MENTS = "MENTS", ING = "ING";
      String[] split = splitTokens(word, "(),:;-.'");
      for (int i = 0; i < split.length; i++) {
        if (cmuMap.get(split[i]) == null) {
          println(split[i].substring(split[i].length()-4));
          if(cmuMap.get(split[i].substring(split[i].length()-4)) != null && cmuMap.get(split[i].substring(0,split[i].length()-4)) != null){
          //if(split[i].substring(split[i].length()-4).equals(MENT)){
            String str1 = split[i].substring(0, split[i].length()-4);
            String str2 = split[i].substring(split[i].length()-4);
            String p1 = getPhonemeVec(str1);
            String p2 = getPhonemeVec(str2);
            println(str1+ " , " + str2);
            println(p1+ "-" + p2);
            noStress += p1+ "-" + p2 + " ";
          } else {
          println(split[i]);
          noStress += "?";
          }
        } else {    
          //noStress = getPhonemeVec(split[i]);
          ArrayList<String> phonemeVec = cmuMap.get(split[i]);
          _pronunciations = phonemeVec.size();
          String noStressTmp = phonemeVec.get(0).replaceAll("[012]", "");
          if (_pronunciations > 1) {
            noStress += noStressTmp + " (" + _pronunciations + ") ";
          } else {
            
             noStress += noStressTmp + "";
          }
        }  
    }
      return noStress;
}

public String getPhonemeVec(String wrd){
   ArrayList<String> phonemeVec = cmuMap.get(wrd);
   int _pronunciations = phonemeVec.size();
   String noStress = "";
   String noStressTmp = phonemeVec.get(0).replaceAll("[012]", "");
   if (_pronunciations > 1) {
            noStress += noStressTmp + " (" + _pronunciations + ") ";
          } else {
            
             noStress += noStressTmp;
          }
  return noStress;
}

} //end of CMU class




// creating Phoneme Map


class pMap {

  Map<String, String> _pMap = new HashMap<String, String>();
  char _type;
  String _phone;
  int stress; 

  pMap() {

    println("creating pMap...");

    String s0 = "1";
    String s1 = "2";
    String s2 = "3";

    String[] lines2 = loadStrings("data/phones.txt");

    for (int i = 0; i < lines2.length; i++) {
      String[] pieces2 = split(lines2[i], "\t");
      _pMap.put(pieces2[0], pieces2[1]);
      //println(pieces2[0] + "  " + pieces2[1]);
    }
  }
  
  public String getPhone(String _phoneme) {

    if (_pMap.get(_phoneme) == null) {
      println(_phoneme+" not found");
      return null;
    } 
    else {
      return _pMap.get(_phoneme);
    }
  }
}


    //Querying Function

    public void QueryCMU(Map<String, ArrayList<String>> cmuMap, Map<String, String> pMap, String word) {
      int syllables;
      word = word.toUpperCase();
      print(word + ":  ");
      ArrayList<String>  phonemeVec = cmuMap.get(word);
      Iterator<String> it = phonemeVec.iterator();
      while (it.hasNext ())
      {
        syllables = 0;
        String s = it.next();
        print(s + "\t( ");
        String[] phones = split(s, " ");
        for (int i = 0; i<phones.length; i++) {
          if (phones[i].indexOf("0") != -1 || phones[i].indexOf("1") != -1 || phones[i].indexOf("2") != -1) {
            String tmp = phones[i].substring(0, phones[i].length() - 1);
            print(pMap.get(tmp) + " ");
            syllables++;
          } 
          else {
            print(pMap.get(phones[i]) + " ");
          }
        }
        println(") , Syllables: " + syllables);
      }
    }
public void readPoemFile( String file ) {

  println( "Reading poem..." );

  // read in the lines
  String[] rows = loadStrings( file );

  int counter = 0;
  String[] cols;

  // assume the first two lines are the title and author, followed by empty line
  String title = rows[0];
  
  String author = rows[1];
  Line[] lines;

    // read in each line as a set of words
    int num_lines = rows.length;// - 3;
    
    idCount = 0;

    _longest_line_length = 0;
    lines = new Line[num_lines];  //maybe add title here...
    for ( int i = 0; i < num_lines; i++ ) {
        cols = splitTokens( rows[i] );
      lines[i] = new Line( cols, i );
      _longest_line_length = max( _longest_line_length, rows[i].length() );
    }
  _poem = new Poem( title, author, lines );
}

//
// COLORS
//
public final int BACKGROUND_COLOR = color( 255 );
public final int POEM_TEXT_COLOR = color( 50 );
public final int POEMAGE_LABEL_TEXT_COLOR = color( 200 );

public final int textcolor = color( 200 );

public final int BLUE = color( 55, 126, 184 );
public final int LT_BLUE = color( 166, 206, 227 );
public final int ORANGE = color( 255, 127, 0);
public final int GREEN = color( 51, 160, 44 );
public final int LT_GREEN = color( 178, 223, 138 );
public final int DRK_GREEN = color( 20, 77, 0 );
public final int RED = color(255, 0, 0);
public final int PINK = color(255, 0, 234);
public final int GREY = color(220);

int[] setColors = {
  BLUE, LT_BLUE, ORANGE, GREEN, LT_GREEN, DRK_GREEN, RED, PINK, GREY
};

int[] myPalette = {
  color(255, 102, 102), /*color(153,51,51),*/color(204, 153, 204), color(102, 204, 51), color(153, 204, 255), color(0, 153, 204), color(0, 102, 153), color(102, 0, 153), color(204, 153, 204)
};
public int BACKGROUND_COLOR_VAR = BACKGROUND_COLOR;

int ctsize;

//
// SIZES
//
public static final int WINDOW_BORDER_WIDTH = 30;


//
// GLOBAL VARIABLES
//
Poem _poem;
int _longest_line_length;
int _title_length;

public static PFont _georgia_12, _georgia_14, _georgia_16;
public static PFont _georgia_14b, _georgia_24b;
public static PFont _gillsans_8;
public static PFont _gillsans_16i, _gillsans_20i;
public static PFont _clairhand_14;
public static PFont _pixel_font_8;
public static PFont _helvetica_12;



HashMap<String, String> phoneMap = new HashMap<String, String>();

int pronunciationNum = 1;
boolean whitespace = true;

boolean includeTitle = true;

int startRow = 3;

float scrollPos = 0;
boolean scroll = false;

float densityThreshold = 30;
float devThreshold = 20;
float regionThreshold = 15;

int cll = 444;

//clusterer _clusterer;
boolean gridOn = true;
boolean meshSegsOn = false;
boolean bundleOn = false;
boolean join = true;
boolean drawAll = false;
boolean colorOn = true;

int degs = 2;
float tightness = 1.1f;
int numClusters = 1;
boolean charsOn = true;
boolean rhymesOn = true;
float sWeight = 1;
boolean delaunay = false;
boolean gridBased = true;
boolean clusterAtNodes = true;

//QuadTree QT;
ArrayList<Boolean> crossings = new ArrayList<Boolean>();
//QuadTree QT2 = null;
boolean newAmb = false;

int hoverSomething = 0;

boolean junk = true;
boolean curves = true;
boolean annotatedGraph = false;
boolean nodesOn = true;
boolean showInteractions = false;
boolean separate = false;
boolean multipleCPts = true;
boolean checkDupes = true;
boolean graphNodesOn = true;
boolean hairball = false;
boolean hairball_c = false;
boolean tCurves = false;
int spline = 0;
float strokeW = 1.25f;
float strokeWOg = 1.25f;
float scale = 1.0f;
boolean setScale = true;
boolean showWords = false;

//for side-by-side
double prevDeg = 500; //if 500, null
int prevState = 0;
double prevTheta = 500;

//ArrayList<pointer> setPointers = new ArrayList<pointer>();

//make the entire _text_view global
TextView _text_view;
//second popup
//PFrame f;
//secondApplet notationView;
float PX, PY;
int graphViewX, graphViewY;
float ct = 0.0f;    //curve tightness

InputStream isT;

int colorScheme = 0;
boolean noloop = true;
boolean itReroute = true;
int ptrCounter = 0;
int reroutes = 0;
int pass = 0;
boolean useBest = true;
boolean adapt = false;

boolean isempty = true;
PVector prevPT = new PVector(0, 0);

ArrayList< ArrayList<Set> > RhymeSets = new ArrayList< ArrayList<Set> >(); 

ArrayList<Word> customWords = new ArrayList<Word>();

int d = 2;

ArrayList<rhymerule> rules = new ArrayList<rhymerule>();
ArrayList<rhymerule> existingRules = new ArrayList<rhymerule>();

//RhymeDesign Globals
boolean combineRules = false;

class rhymerule {
  String name;
  int type = 2; //0 is syll, 1 is chars...if nothing, go with sylls.
  String strRule;
  boolean bimatch = false;
  boolean noMatch = false;
  int crossWrd = 0;
  int bcrossWrd = 0;
  String rule = "";
  int stressedSyll = 0;
  String matchingStr = "";
  String matchingSylls = "";
  String stresses = "";
  int l, r;
  ArrayList<String> sylls = new ArrayList<String>();
  ArrayList<String> syllsNoP = new ArrayList<String>();
  ArrayList<String> phones = new ArrayList<String>();
  ArrayList<String> charClusters = new ArrayList<String>();
  ArrayList< ArrayList<Integer> > ellipses = new ArrayList< ArrayList<Integer> >();
  ArrayList< ArrayList<matchU> > matches = new ArrayList< ArrayList<matchU> >(); //2d for "ors"
  ArrayList< ArrayList<matchU> > bimatches = new ArrayList< ArrayList<matchU> >();
  
  ArrayList< ArrayList<matchU> > currmatches = new ArrayList< ArrayList<matchU> >();
  
  ArrayList<matchU> orSeg = new ArrayList<matchU>(); //temporarily holds "ors"

  String textValue = "";

  rhymerule(String _rule) {
    strRule = _rule;
    //name = "custom "+rules.size();
    processRule3();
    if(comment){
    printRule2();
    }
  }
  rhymerule(String _name, String _rule) {
    strRule = _rule; 
    name = _name;
    processRule3();
    if(comment){
    printRule2();
    }
  }

  public void processRule3() {
    String[] bitmp = split(strRule, '&'); 
    String seg = "";
    int t, stress, mix, ind_b, ind_e, bn, en, numEs, _word;
    boolean struct = false;
    String subt = "";
    if (bitmp.length == 2) {
      bimatch = true;
      if(comment)
      println("bimatch!");
    }
    for (int i = 0; i < bitmp.length; i++) {
      int w = 0;
      boolean advWrd = false;
      String[] segWords = split(bitmp[i], ":"); //iterate through multiple words  
      if(segWords.length > 1 && i == 0){
       println("cross word!");
       crossWrd = segWords.length-1;
      }else if(segWords.length > 1 && i > 0){
       println("b cross word!");
       bcrossWrd = segWords.length-1;
      }   
      boolean segOn = false;
      //for(int w = 0; w < segWords.length; w++){      
      seg = bitmp[i].replaceAll("\\.\\.\\.", ".").replaceAll(" ", "");
      if(comment)
      println(seg);  
      //String[] rSplit = split(seg, '-');
      //String seg2 = seg.replaceAll("[\\[\\]*!|']", "").replaceAll("_\\{.+?\\}", "");
      int c = 0; 
      int B = 0;
      ellipses.clear();
      for(int ii = 0; ii < segWords.length; ii++){
      segWords[ii] = segWords[ii].replaceAll("\\.\\.\\.", ".").replaceAll(" ", "");
      ellipses.add(new ArrayList<Integer>()); 
      c = 0; 
      while (segWords[ii].indexOf (".", c) != -1) {
        c = segWords[ii].indexOf(".", c);
        ellipses.get(ii).add(c);
        c += 1;
      }
      }
      //numEs = ellipses.size();
      int syllnum = 0;
      int charnum = 0;
      //boolean segOn = false;
      boolean orOn = false;  //for [O] | [C]
      boolean addOr = false;
      boolean tildeOn = false; //for ~[C]
      struct = false;
      boolean req = false;  //for O` and C`
      //_word = 0;
      int advancej = 0;
      int wrdB = 0;
      for (int j = 0; j < seg.length (); j++) {
       String[] rSplit = split(segWords[w], '-');
       String seg2 = segWords[w].replaceAll("[\\[\\]*!|']", "").replaceAll("_\\{.+?\\}", "");
       numEs = ellipses.get(w).size();
       
        advancej = 0;
        req = false;
        if(j == 0 && seg.charAt(j) == '!'){
          noMatch = true;
          continue;
        } else if(seg.charAt(j) == ':'){
          w++;
          //next word! reset syllnum / charnum
          syllnum = 0;
          charnum = 0;
          wrdB = j;
          continue;
        } else if (seg.charAt(j) == '[') {
          segOn = true;
          continue;
        } else if (seg.charAt(j) == ']') {
          segOn = false;
          if (orOn) {
            //addOr = true;
            genOrPerms(i);
            orOn = false;
          } 
          if (tildeOn) {
            tildeOn = false;
          }
          continue;
        } else if (seg.charAt(j) == '-') {
          syllnum++;
          continue;
        } else if (seg.charAt(j) == '|') {
          orOn = true;
          continue;
        } else if (seg.charAt(j) == '~' || seg.charAt(j) == '`') {
          //tildeOn = true;
          continue;
        } else if(seg.charAt(j) == '\'' || seg.charAt(j) == '^' || seg.charAt(j) == '*'){
          //this will be taken into account later
          continue; 
        } else {
          t = (seg.charAt(j) == 'O' || seg.charAt(j) == 'N' || seg.charAt(j) == 'C') ? 0 : (seg.charAt(j) == '.') ? 2 : 1;
          if (t == 2){ //ellipse
           String segt = seg.replaceAll("_\\{.+?\\}", "");
            type = (seg.indexOf("A") != -1 || seg.indexOf("B") != -1 || seg.indexOf("Y") != -1 || anylowercase(segt)) ? 1 : 0; //or if lowercase...
            subt = ""+seg.charAt(j);
            struct = false;
            stress = 10;
            if(type == 1 && segOn){
            if (seg.length() > seg.indexOf(']', j)+1) {
              char cht = seg.charAt(seg.indexOf(']', j)+1);
              mix = (cht == '*') ? 1 : 0;
            } else {
              mix = 0;
            }
            } else {
             mix = 10; 
            }
            
          } else if (t == 0) { //sylls!
            type = 0;
            stress = (rSplit[syllnum].indexOf('\'') != -1) ? 1 : (rSplit[syllnum].indexOf('^') != -1) ? 2 : 0 ;
            if ((seg.length()>j+1 && seg.charAt(j+1) == '_') || (seg.length()>j+2 && seg.charAt(j+1) == '`' && seg.charAt(j+1) == '_') ) {
              //extract struct rule
              struct = true;
              //structStr = seg.substring(seg.indexOf('{',j)+1,seg.indexOf('}',j));
              advancej = seg.indexOf('}', j);
              subt = ""+seg.substring(j, seg.indexOf('}', j)+1).replace("`","");
              if(comment)
              println(subt);
            } else {
              if(seg.length()>j+1 && seg.charAt(j+1) == '`' && (seg.charAt(j) == 'O' || seg.charAt(j) == 'C')){
              req = true;
              //advancej = 1;
              }
              struct = false;
              subt = ""+seg.charAt(j);
            }
            mix = 10;
            //subt = ""+seg.charAt(j);
          } else if (t==1) { //chars!
           type = 1;
            stress = 10; 
            if(!segOn){
            mix = 10;
            subt = ""+seg.charAt(j);
            }else{
            if (seg.length() > seg.indexOf(']', j)+1) {
              char cht = seg.charAt(seg.indexOf(']', j)+1);
              mix = (cht == '*') ? 1 : 0;
            } else {
              mix = 0;
            }
            
            int A = ( seg.indexOf(']', j) < seg.indexOf('.', j)) ? seg.indexOf(']', j) : (seg.indexOf('.', j) < 0) ? seg.indexOf(']', j) : seg.indexOf('.', j);
            subt = seg.substring(j, A); //get character rhyme seg, e.g. AABA - will make things easier
            B = subt.replaceAll("_\\{.+?\\}", "").replaceAll("'", "").length();
            advancej = A-1; //skip to end
            //advancej = seg.indexOf('.', j)-1;
          if(comment)  
          println("subt: "+subt + " " + subt.replaceAll("_\\{.+?\\}", ""));

            if (subt.indexOf('_') != -1) { //pass structural rhyme onto match function
              struct = true;
            } else {
              struct = false;
            }
            }
          } else {
            struct = false;
            stress = 10;
            mix = 10;
            subt = "";
          }
          
          ind_b = (t == 0) ? syllnum : charnum;
          ind_e = (t == 0) ? rSplit.length - syllnum - 1 : seg2.length()-charnum-1; //but what about structure.
          if(comment){
          println("b: "+ind_b);
          println("e: "+ind_e);
          }
          
          //for ellipses
          if(t == 2 && type == 0){
              ind_b = syllnum;
              ind_e = rSplit.length - syllnum - 1;
              if(comment)
              println("rsplit: "+subt+ " "+rSplit.length);
          }else if(t == 2 && type == 1){
              ind_b = charnum;
              ind_e = seg2.length()-charnum-1;
          }

          bn = en = 0;
          for (int k = 0; k < ellipses.get(w).size (); k++) {  //just look at outside the braket
            if (ellipses.get(w).get(k) < j-wrdB) {
              bn++;
            } else if (ellipses.get(w).get(k) > j-wrdB) {
              en++;
            }
          }
          
          if (i == 0) {
            if (addOr) {  //generate permutations
              addOr = false; //only want to do once!
              //genOrPerms(i);
              /*for(int l = 0; l < matches.size(); l++){
              matches.get(l).add(new matchU(t, ind_b, ind_e, bn, en, numEs, subt, stress, mix, struct, tildeOn, segOn));
              }*/
            } else if(orOn && segOn){
              orSeg.add(new matchU(t, ind_b, ind_e, bn, en, numEs, subt, stress, mix, struct, tildeOn, segOn, w,req));
            } else {
              //println("adding match "+seg+" t: "+ t +", ind_b: "+ ind_b +", ind_e: "+ ind_e +", bn: "+ bn +", en: "+ en +", sebt: "+ subt +", stress: "+ stress +", mix: "+ mix);
              if(matches.size() == 0){
              matches.add(new ArrayList<matchU>()); 
              }
              for(int l = 0; l < matches.size(); l++){
              matches.get(l).add(new matchU(t, ind_b, ind_e, bn, en, numEs, subt, stress, mix, struct, tildeOn, segOn, w, req));
              }
            }
          } else if (i == 1) {
            if (addOr) { //generate permuations
              addOr = false;
              //genOrPerms(i);
              /*for(int l = 0; l < bimatches.size(); l++){
              bimatches.get(l).add(new matchU(t, ind_b, ind_e, bn, en, numEs, subt, stress, mix, struct, tildeOn, segOn));
              }*/
            }  else if(orOn && segOn){
               orSeg.add(new matchU(t, ind_b, ind_e, bn, en, numEs, subt, stress, mix, struct, tildeOn, segOn, w, req));
            } else {
              if(bimatches.size() == 0){
              bimatches.add(new ArrayList<matchU>());
              }
              for(int l = 0; l < bimatches.size(); l++){ //add to each. 
              bimatches.get(bimatches.size()-1).add(new matchU(t, ind_b, ind_e, bn, en, numEs, subt, stress, mix, struct, tildeOn, segOn, w, req));
              }
            }
          }
        }
        if (advancej > 0) {
          if(comment)
          println(advancej-j + " " + B);
          //charnum += advancej-j+1; //may be wrong
          charnum += B;
          j = advancej;
        } else {
          charnum++;
        }
        
        if(t == 1 && subt.indexOf(":") != -1){ //cross word in mix
          w++;
          charnum = subt.length() - (subt.indexOf(":")+1);
          if(charnum < 0)charnum = 0;
        }
        
      } //seglength
      
      //} //end word match
      
    } //end bimatch loop
  }
  
  public boolean anylowercase(String str){
    boolean res = false;
    for(int i = 0; i < str.length(); i++){
      if(Character.isLowerCase(str.charAt(i)))
      res = true;
    }
    return res;
  }
  
  public void genOrPerms(int i){
    //make "either or both" combinations - e.g. if [ONC]-[O]|N[C] need to generate:
    //[ONC]-[O]NC (either) [ONC]-ON[C] (either) [ONC]-[O]N[C] (both)
    //get "or" segment from OrSeg
    if(i == 0){ //matches
    for(int l = 0; l < matches.size(); l+=3){
     //duplicate twice
     matches.add(l+1, new ArrayList<matchU>());
     matches.add(l+1, new ArrayList<matchU>());
     
     for(int k = 0; k < matches.get(l).size(); k++){
      matches.get(l+1).add(new matchU(matches.get(l).get(k)));
      matches.get(l+2).add(new matchU(matches.get(l).get(k)));
     }
    
     //both
     matches.get(l).addAll(orSeg);
     //only first or
     int go = 0;
     for(int k = 0; k < matches.get(l+1).size(); k++){ //turn last rhymeseg off
      if(matches.get(l+1).get(k).rhymeSeg){
        if(go == 0){
         go = 1; 
         matches.get(l+1).get(k).rhymeSeg = false;
        }else{
        matches.get(l+1).get(k).rhymeSeg = false;
        }
      }else{ //rhymeSegOff
        if(go == 1)
          break;
      }
     }
     matches.get(l+1).addAll(orSeg);
     
     //copy orSeg - must be a better way!
     
     //only second or
     for(int k = 0; k < orSeg.size(); k++){
      matches.get(l+2).add(new matchU(orSeg.get(k)));
      //modify copy
      matches.get(l+2).get(matches.get(l+2).size()-1).rhymeSeg = false;
     }
     //l += 1;
    }
    }else if(i == 1){ //bimatches
      for(int l = 0; l < bimatches.size(); l++){
     //duplicate twice
     bimatches.add(l+1, new ArrayList<matchU>()); 
     bimatches.add(l+1, new ArrayList<matchU>()); 
     
      for(int k = 0; k < bimatches.get(l).size(); k++){
      bimatches.get(l+1).add(new matchU(bimatches.get(l).get(k)));
      bimatches.get(l+2).add(new matchU(bimatches.get(l).get(k)));
     }
     
     //both
     bimatches.get(l).addAll(orSeg);
     //only first or
     int go = 0;
     for(int k = 0; k < bimatches.get(l+1).size(); k++){ //turn last rhymeseg off
      if(bimatches.get(l+1).get(k).rhymeSeg){
        if(go == 0){
         go++; 
        }else{
        bimatches.get(l+1).get(k).rhymeSeg = false;
        }
      }else{ //rhymeSegOff
        if(go == 1)
          break;
      }
     } 
     bimatches.get(l+1).addAll(orSeg);
     //only second or
     for(int k = 0; k < orSeg.size(); k++){
       bimatches.get(l+2).add(new matchU(orSeg.get(k)));
      //modify copy
      bimatches.get(l+2).get(bimatches.get(l+2).size()-1).rhymeSeg = false;
     } 
     l += 2;
    }
    }
    orSeg.clear();
  }

  public void processRule2() {
    //if its a char string, I think we'll need to count the entire thing as one match 
    ArrayList<Integer> ellipses = new ArrayList<Integer>();
    String seg = "";
    int t, ind_b, ind_e, bn, en, stress, mix, numEs, bra, ket, last;
    boolean struct = false;
    String subt = "";
    //String structStr = "";
    //String subtStr;
    //split into diff rhyme segments (e.g. semirhyme)
    String[] bitmp = split(strRule, '&'); 
    if (bitmp.length == 2) {
      bimatch = true;
      if(comment)
      println("bimatch!");
    }
    for (int i = 0; i < bitmp.length; i++) {
      ellipses.clear();
      //println(bitmp[i]);
      seg = bitmp[i].replaceAll("\\.\\.\\.", ".").replaceAll(" ", "");
      //println(seg);
      String[] rSplit = split(bitmp[i], '-');
      //index all ellipses to reference later
      String seg2 = seg.replaceAll("[\\[\\]*]", "");
      int c = 0; 
      while (seg.indexOf (".", c) != -1) {
        c = seg.indexOf(".", c);
        ellipses.add(c);
        c += 3;
      }
      numEs = ellipses.size();
      //println("ellipses: "+ellipses);
      int syllnum = 0;
      int charnum = 0;
      bra = ket = 0;
      boolean segOn = false;
      boolean orOn = false;  //for [O] | [C]
      boolean tildeOn = false; //for ~[C]
      boolean ellipseOn = false;
      boolean ellipseOutOn = false; 
      int lastChar = -1;
      int lastSyll = -1;
      struct = false;
      int advancej = 0;
      //iterate through each character
      for (int j = 0; j < seg.length (); j++) {
        advancej = 0;
        //structStr = "";
        if (seg.charAt(j) == '[') {
          //println("on");
          segOn = true;
          //charnum++;
          //tmpSeg = seg.substring(j+1,seg.indexOf(']',j));
          bra = j;
          ket = (seg.indexOf(']', j) != -1 && seg.indexOf(']', j) > j) ?  seg.indexOf(']', j) : j;
          if (ket == j) {
            println("no close bracket");
          }
          continue;
        } else if (seg.charAt(j) == ']') {
          //println("off");
          segOn = false;
          //tmpSeg = "";
          if (orOn) {
            orOn = false;
          } 
          if (tildeOn) {
            tildeOn = false;
          }
          //charnum++;
          continue;
        } else if (seg.charAt(j) == '-') {
          syllnum++;
          //charnum++;
          continue;
        } else if (seg.charAt(j) == '.') {
          if (segOn) {
            ellipseOn = true;
          } else {
            ellipseOutOn = true;
          }
          continue; //have to figure out how to match ...'s
        } else if (seg.charAt(j) == '|') {
          orOn = true;
          continue;
        } else if (seg.charAt(j) == '~') {
          //tildeOn = true;
          continue;
        }
        if (segOn && (seg.charAt(j) != '\'' && seg.charAt(j) != '^')) {
          //matchU(int t, int ind_b, int ind_e, int _bn, int _en, String subt, int _stress)
          t = (seg.charAt(j) == 'O' || seg.charAt(j) == 'N' || seg.charAt(j) == 'C') ? 0 : (seg.charAt(j) == '.') ? 2 : 1;
          //println("t "+t); 
          if (t == 0) { //sylls!
            type = 0;
            stress = (rSplit[syllnum].indexOf('\'') != -1) ? 1 : (rSplit[syllnum].indexOf('^') != -1) ? 2 : 0 ;
            if (seg.charAt(j+1) == '_') {
              //extract struct rule
              struct = true;
              //structStr = seg.substring(seg.indexOf('{',j)+1,seg.indexOf('}',j));
              advancej = seg.indexOf('}', j);
              subt = ""+seg.substring(j, seg.indexOf('}', j)+1);
              if(comment)
              println(subt);
            } else {
              struct = false;
              subt = ""+seg.charAt(j);
            }
            mix = 10;
            //subt = ""+seg.charAt(j);
          } else if (t==1) { //chars!
            type = 1;
            stress = 10; 
            if (seg.length() > seg.indexOf(']', j)+1) {
              char cht = seg.charAt(seg.indexOf(']', j)+1);
              mix = (cht == '*') ? 1 : 0;
            } else {
              mix = 0;
            }
            //println(j+" "+seg.indexOf(']',j));
            subt = seg.substring(j, seg.indexOf(']', j)); //get character rhyme seg, e.g. AABA - will make things easier
            //println(subt);
            /*if(seg.charAt(j-1) == '.'){
             subt = ""+ seg.charAt(j-1)+subt;
             }*/
            advancej = seg.indexOf(']', j)-1; //skip to end
            //println("Advance "+seg.charAt(advancej));
            if (subt.indexOf('_') != -1) { //pass structural rhyme onto match function
              struct = true;
            } else {
              struct = false;
            }
          } else {
            struct = false;
            stress = 10;
            mix = 10;
            subt = "";
          }
          ind_b = (t == 0) ? syllnum : charnum;
          ind_e = (t == 0) ? rSplit.length - syllnum - 1 : seg2.length()-charnum-1;
          last = (t == 0) ? lastSyll : lastChar;

          bn = en = 0;
          for (int k = 0; k < ellipses.size (); k++) {  //just look at outside the braket
            if (ellipses.get(k) < j /*&& ellipses.get(k) < bra*/) {
              bn++;
            } else if (ellipses.get(k) > j /*&& ellipses.get(k) > ket*/) {
              en++;
            }
          }
          if (i == 0) {
            if (orOn) {  //add to previous segment
              matches.get(matches.size()-1).add(new matchU(t, ind_b, ind_e, bn, en, subt, stress, mix, numEs, struct, tildeOn, last, ellipseOn, ellipseOutOn));
            } else {
              //println("adding match "+seg+" t: "+ t +", ind_b: "+ ind_b +", ind_e: "+ ind_e +", bn: "+ bn +", en: "+ en +", sebt: "+ subt +", stress: "+ stress +", mix: "+ mix);
              matches.add(new ArrayList<matchU>()); 
              matches.get(matches.size()-1).add(new matchU(t, ind_b, ind_e, bn, en, subt, stress, mix, numEs, struct, tildeOn, last, ellipseOn, ellipseOutOn));
            }
          } else if (i == 1) {
            if (orOn) {
              bimatches.get(bimatches.size()-1).add(new matchU(t, ind_b, ind_e, bn, en, subt, stress, mix, numEs, struct, tildeOn, last, ellipseOn, ellipseOutOn));
            } else {
              bimatches.add(new ArrayList<matchU>());
              bimatches.get(bimatches.size()-1).add(new matchU(t, ind_b, ind_e, bn, en, subt, stress, mix, numEs, struct, tildeOn, last, ellipseOn, ellipseOutOn));
            }
          }
        }
        if (advancej > 0) {
          //println(advancej-j);
          charnum += advancej - j+1; //may be wrong
          j = advancej;
        } else {
          charnum++;
        }
        last = charnum;
        lastSyll = syllnum;
        ellipseOn = false;
        ellipseOutOn = false;
      }
    }
  }
  
  public void printMatches(){
    for(int i = 0; i < currmatches.size(); i++){  //2d for "ors"
     for(int j = 0; j < currmatches.get(i).size(); j++){
           print(currmatches.get(i).get(j).subtype+" ("+currmatches.get(i).get(j).index_b+") ("+currmatches.get(i).get(j).index_e+")");
     }
     println("");
    }
  }
  
  public ArrayList<String> getMatches(Syllable[] _syll, char[] _wrd, int wrdNum, int wInd, boolean isbimatch, Word _word){
    ArrayList<String> res = new ArrayList<String>(); //need to find all possible rhyming segments
    ArrayList<String> resTmp = new ArrayList<String>();
    //res.add("");//initiate
    String tmp = "";
    int index = 0;
    boolean wexists = true;
    boolean nexties = false;
    boolean initNext = false;
    //currmatches.clear();
    //wInd for cross-word rhymes
    if(bimatch && wrdNum == 2){ //search bimatch arraylist
     currmatches = bimatches;
    }else{
      currmatches = matches;
    }
    if(comment)
    printMatches();
    //currmatches = matches;
    for(int i = 0; i < currmatches.size(); i++){  //2d for "ors"
    resTmp.clear();
    //printRulei(i);
     for(int j = 0; j < currmatches.get(i).size(); j++){
     tmp = "";  
     wexists = true;
     //println("wrdNum: "+currmatches.get(i).get(j).word);
     //for cross word rhymes
     if(j > 0 && currmatches.get(i).get(j-1).word != currmatches.get(i).get(j).word){
      nexties = true; 
      Word tmpwrd = _word.getNext(currmatches.get(i).get(j).word);
      if(tmpwrd == null){
        //doesn't exist
        wexists = false;
      }else{
        if(comment)println("next word: "+tmpwrd._displayWord);
        wexists = true;
        _syll = tmpwrd.getSylls();
        _wrd = tmpwrd.getLetters();
        initNext = true;
      }
     }else{
      nexties = false; 
     }
     
     
     if((type == 0 || type == 2) && wexists){//sylls
       //build each level
       //println(i+" "+j);
       if(comment){
       println(currmatches.get(i).get(j).subtype);
       }
       //resTmp.add(buildSyll(i,j, res, _syll));
       //resTmp = buildSyll2(i,j, resTmp, _syll);
       resTmp = buildSyll(i,j, resTmp, _syll, wInd, isbimatch, _word, initNext);
       if(initNext == true)initNext = false;
       if(comment){
       println("After match "+i+","+j+" : "+res+" "+resTmp);
       }
     }else if(type == 1 && wexists){ //chars
      if(comment && nexties)println("building char for next: "+Arrays.toString(_wrd));
       resTmp = buildChar2(i,j,resTmp, _wrd, wInd, isbimatch, _word, nexties, initNext);
       if(initNext == true)initNext = false;
     }
    }
    //get rid of duplicates and update res
    res.addAll(resTmp);
    if(comment){
    println("res: "+i+" "+resTmp);
    }
    }
    
    for(int k = 0; k < res.size(); k++){
     //res.set(k, res.get(k).substring(0,res.get(k).indexOf("("))); 
     String tmp2 = res.get(k).substring(0,res.get(k).indexOf("("));
     //mix strings between []
     String sub1 = "";
     String mix1 = "";
     int safe = 0;
     while(tmp2.indexOf("[") != -1){
       sub1 = tmp2.substring(tmp2.indexOf("["), tmp2.indexOf("]")+1);
       //println("s: "+sub1);
       mix1 = sortAlpha(sub1.replaceAll("[\\[\\]]",""));
       //println("m: "+mix1);
       tmp2 = tmp2.replaceFirst("\\[.+?\\]",mix1); 
       //println("tmp2: "+tmp2);
       safe++;
       if(safe > 20){ //safety
        break; 
       }
     }
     
     res.set(k, tmp2); 
    }
    if(comment){
    println("res: "+res);
    }
    return res;
  }
  
  //using this one
  
  public ArrayList<String> buildSyll(int msize, int mnum, ArrayList<String> res, Syllable[] _syll, int wInd, boolean isbimatch, Word _word, boolean initNext){
   //iterate on res.
   //println(wInd);
   int _type =  currmatches.get(msize).get(mnum).type;
   boolean rseg = currmatches.get(msize).get(mnum).rhymeSeg;
   int index;
   int start = 0;
   int stop = 0; 
   String track = "";
   boolean okgo = true;
   if((res.size() == 0 && /*msize == 0 &&*/ mnum == 0)/* || initNext*/){ //initiate
   initNext = false;
   //println("initiating...");
     if(_type == 2){ //ellipse - iterate through entire word. 
     //add zero option
     if(rseg){  //in rhyme segment - add string
          res.add("("+(-1)+")");
      }else{ //no in rhyme seg...just update index
          res.add("("+(-1)+")");
      }
     start = 0;
     stop = 0; 
     track = "";
     for(int j = 0; j < _syll.length; j++){
      stop = j; 
      okgo = true;
      track += _syll[j].getFullSyllStr();
      //check in correct dist...
      if(currmatches.get(msize).get(mnum).bn == 0 && currmatches.get(msize).get(mnum).en == 0 ){
            if(start != currmatches.get(msize).get(mnum).index_b ||  _syll.length - 1 - stop != currmatches.get(msize).get(mnum).index_e){
            if(comment){
              println("ellipse wrong dist "+start+" "+(_syll.length - 1)+" "+stop+" "+currmatches.get(msize).get(mnum).index_b+" "+currmatches.get(msize).get(mnum).index_e);
            }
            okgo = false;  
          }
          }else if(currmatches.get(msize).get(mnum).bn == 0){
            if(start != currmatches.get(msize).get(mnum).index_b ||  (_syll.length - 1) - stop < currmatches.get(msize).get(mnum).index_e-matches.get(msize).get(mnum).en){
             if(comment){
              println("ellipse wrong dist2");
             }
             okgo = false;
            }
          }else if(currmatches.get(msize).get(mnum).en == 0){
            if(stop != currmatches.get(msize).get(mnum).index_e ||  (_syll.length - 1) - start < currmatches.get(msize).get(mnum).index_b - currmatches.get(msize).get(mnum).bn){
            if(comment){
              println("ellipse wrong dist3"); 
            }
            okgo = false;
            }
          }
          
          //if legal
          if(okgo){
      if(rseg){  //in rhyme segment - add string
          res.add(track+"("+j+")");
      }else{ //no in rhyme seg...just update index
          res.add("("+j+")");
      }
      }
     }
     //println(res);
    } else if(_type == 0){ //sylls - this should only have one poss be res. 
      String m = "";
      //check if in same syllable as last - else advance
      int syllInd = 0;
      if(rseg){
        if(_syll.length > syllInd){
          m = currmatches.get(msize).get(mnum).getONC(_syll[syllInd]);
          //println("ONC m: "+m);
          if(m.length() == 0){
          }else{
          //check if correct distance from beg/end
          if(currmatches.get(msize).get(mnum).bn == 0 && currmatches.get(msize).get(mnum).en == 0 ){
            if(syllInd != currmatches.get(msize).get(mnum).index_b ||  _syll.length - 1 - syllInd != currmatches.get(msize).get(mnum).index_e){
             m = ""; 
             if(comment){
            println("wrong dist1 " + syllInd +" "+ currmatches.get(msize).get(mnum).index_b +" "+_syll.length+ " "+currmatches.get(msize).get(mnum).index_e);
            }
            }
          }else if(currmatches.get(msize).get(mnum).bn == 0){
            if(syllInd != currmatches.get(msize).get(mnum).index_b ||  (_syll.length - 1) - syllInd < currmatches.get(msize).get(mnum).index_e-currmatches.get(msize).get(mnum).en){
             m = ""; 
             if(comment){
             println("wrong dist2" + syllInd +" "+ currmatches.get(msize).get(mnum).index_b +" "+_syll.length+ " "+currmatches.get(msize).get(mnum).index_e + " "+currmatches.get(msize).get(mnum).en);
             }  
          }
          }else if(currmatches.get(msize).get(mnum).en == 0){
            if((_syll.length - 1) - syllInd != currmatches.get(msize).get(mnum).index_e ||  syllInd < currmatches.get(msize).get(mnum).index_b - currmatches.get(msize).get(mnum).bn){
             m = ""; 
             if(comment){
             println("wrong dist3" + syllInd +" "+currmatches.get(msize).get(mnum).index_e+" "+_syll.length +" "+ currmatches.get(msize).get(mnum).index_b +" "+ currmatches.get(msize).get(mnum).bn);
             }  
          }
          }
          }
        }else{
        }
        if(m.length() == 0){
          //println("nada - first pass");
          //if match breaks, delete entire string.
          //res.set(i, null);
        } else {
          res.add(m+"("+syllInd+")");
          if(comment){
          println(res);
          }
        }
      }else{
       //just advance.
       res.add("("+syllInd+")");
      }
    }
    //println("again: "+res);
    while(res.remove(null)); //inefficient - but removes deadends
    //println("again: "+res);
   return res;
   }else{ //not initiating
   //println("proceeding...");
   if(comment){
   println("adding to"+res);
   }
   for(int i = 0; i < res.size(); i++){
    if(initNext){
     index = -1;
    }else{ 
    index = Integer.parseInt(res.get(i).replaceAll(".*\\(|\\).*", "")); //for this it's syllable index
    }
    /*if(index == -1){
     index = 0; 
    }*/
    res.set(i, res.get(i).substring(0,res.get(i).indexOf("(")));
    //res.set(i, res.get(i).replaceAll("[\\(\\)]",""));
    //println("res: "+res.get(i));
    if(_type == 2){ //ellipse - iterate through entire word.
     boolean first = true;
     start = index; 
     track = "";
     for(int j = index; j < _syll.length; j++){ //start at index to take no addition into account
      //for no addition
      /*if(j == index){
       if(rseg){
        res.set(i, res.get(i)+"("+j+")");
       }else{
        res.set(i, res.get(i)+"("+j+")");
       } 
        first = false;
        continue;
      }*/
      stop = j; 
      okgo = true;
      if(j > index){
      track += _syll[j].getFullSyllStr(); 
      }
      //check in correct dist...
      if(currmatches.get(msize).get(mnum).en == 0){
            if((_syll.length - 1) - stop != currmatches.get(msize).get(mnum).index_e){
              if(comment){
            println("ellipse wrong dist3 "+track+" "+stop+" "+currmatches.get(msize).get(mnum).index_e); 
              }
            okgo = false;
            }
          }else if((_syll.length - 1) - stop < currmatches.get(msize).get(mnum).index_e-currmatches.get(msize).get(mnum).en || (_syll.length - 1) - start < currmatches.get(msize).get(mnum).index_b - currmatches.get(msize).get(mnum).bn){
        if(comment){
            println("ellipse wrong dist");
        }
        okgo = false;
      }
      /*if(matches.get(msize).get(mnum).bn == 0 && matches.get(msize).get(mnum).en == 0 ){
            if(start != matches.get(msize).get(mnum).index_b ||  _syll.length - 1 - stop != matches.get(msize).get(mnum).index_e){
            println("ellipse wrong dist "+start+" "+(_syll.length - 1)+" "+stop+" "+matches.get(msize).get(mnum).index_b+" "+matches.get(msize).get(mnum).index_e);
            okgo = false;  
          }
          }else if(matches.get(msize).get(mnum).bn == 0){
            if(start != matches.get(msize).get(mnum).index_b ||  (_syll.length - 1) - stop < matches.get(msize).get(mnum).index_e-matches.get(msize).get(mnum).en){
             println("ellipse wrong dist2");
             okgo = false;
            }
          }else if(matches.get(msize).get(mnum).en == 0){
            if(stop != matches.get(msize).get(mnum).index_e ||  (_syll.length - 1) - start < matches.get(msize).get(mnum).index_b - matches.get(msize).get(mnum).bn){
            println("ellipse wrong dist3"); 
            okgo = false;
            }
          }*/
      
      
      if(okgo){
      if(rseg){  //in rhyme segment - add string
        /*if(j == index){
          res.set(i, res.get(i)+"("+j+")");
        }else{*/
          //res.add(i+1,res.get(i).substring(0,res.get(i).indexOf("("))+_syll[j].getFullSyllStr()+"("+j+")");
          if(first){
            res.set(i, res.get(i) + track+"("+j+")");
            first = false;
          }else{
          res.add(i+1,res.get(i).substring(0,res.get(i).indexOf("(")) + track+"("+j+")");
          i++; //advance once array element (to avoid repeats)
          }
       // }
      }else{ //no in rhyme seg...just update index
       /* if(j == index){
          res.set(i, res.get(i)+"("+j+")");
        }else{*/
        if(first){
          res.set(i, res.get(i)+"("+j+")");
          first = false;
        }else{
          res.add(i+1,res.get(i)+"("+j+")");
         i++; //advance once array element (to avoid repeats)
        }
        //}
      }
      }
     }
    }
    if(_type == 0){ //sylls - this should only have one poss be res. 
    //println("nextSyll");
      String m = "";
      //check if in same syllable as last - else advance
      
      int syllInd;
      if(index == -1){
       syllInd = 0; 
      }else{
      syllInd= ( mnum > 0 && currmatches.get(msize).get(mnum-1).index_b == currmatches.get(msize).get(mnum).index_b) ? index : index+1;
      }
      /*if(msize > 0){
      println("syllInd: "+syllInd + " " + index + " "+matches.get(msize-1).get(mnum).index_b+" "+matches.get(msize).get(mnum).index_b);
      }*/
      if(rseg){
        //println(_syll.length+" "+syllInd + " "+index+" "+mnum);//+matches.get(msize).get(mnum-1).index_b+" "+matches.get(msize).get(mnum).index_b);
        if(_syll.length > syllInd){
          m = currmatches.get(msize).get(mnum).getONC(_syll[syllInd]);
          if(comment){
          println("m: "+m);
          }
          //check if correct distance from beg/end
          if(currmatches.get(msize).get(mnum).bn == 0 && currmatches.get(msize).get(mnum).en == 0 ){
            if(syllInd != currmatches.get(msize).get(mnum).index_b ||  _syll.length - 1 - syllInd != currmatches.get(msize).get(mnum).index_e){
             m = ""; 
             if(comment)
             println("wrong dist 1");
            }
          }else if(currmatches.get(msize).get(mnum).bn == 0){
            if(syllInd != currmatches.get(msize).get(mnum).index_b ||  (_syll.length - 1) - syllInd < currmatches.get(msize).get(mnum).index_e-currmatches.get(msize).get(mnum).en){
             m = ""; 
             if(comment){
             println("wrong dist 2");
             }
            }
          }else if(currmatches.get(msize).get(mnum).en == 0){
            if((_syll.length - 1) - syllInd != currmatches.get(msize).get(mnum).index_e ||  syllInd < currmatches.get(msize).get(mnum).index_b - currmatches.get(msize).get(mnum).bn){
             m = ""; 
             if(comment){
             println("wrong dist3 " + syllInd +" "+currmatches.get(msize).get(mnum).index_e+" "+_syll.length +" "+ currmatches.get(msize).get(mnum).index_b +" "+ currmatches.get(msize).get(mnum).bn);
             }  
          }
          }
        }else{
        }
        if(m.length() == 0){
          //if match breaks, delete entire string.
          res.set(i, null);
        } else {
          res.set(i, res.get(i)+m+"("+syllInd+")");
        }
      }else{
       //just advance.
       res.set(i, res.get(i)+"("+syllInd+")");
      }
    }
   }
   }
   while(res.remove(null)); //inefficient - but removes deadends
   //println("again: "+res);
   initNext = false;
   return res;
  }
  
  
  public ArrayList<String> buildSyll2(int msize, int mnum, ArrayList<String> res, Syllable[] _syll){
   //iterate on res.
   int _type =  currmatches.get(msize).get(mnum).type;
   boolean rseg = currmatches.get(msize).get(mnum).rhymeSeg;
   int index;
   int start = 0;
   int stop = 0; 
   String track = "";
   boolean okgo = true;
   if(res.size() == 0 && /*msize == 0 &&*/ mnum == 0){ //initiate
   //println("initiating...");
     if(_type == 2){ //ellipse - iterate through entire word. 
     //add zero option
     if(rseg){  //in rhyme segment - add string
          res.add("("+(-1)+")");
      }else{ //no in rhyme seg...just update index
          res.add("("+(-1)+")");
      }
     start = 0;
     stop = 0; 
     track = "";
     for(int j = 0; j < _syll.length; j++){
      stop = j; 
      okgo = true;
      track += _syll[j].getFullSyllStr();
      //check in correct dist...
      if(currmatches.get(msize).get(mnum).bn == 0 && currmatches.get(msize).get(mnum).en == 0 ){
            if(start != currmatches.get(msize).get(mnum).index_b ||  _syll.length - 1 - stop != currmatches.get(msize).get(mnum).index_e){
            if(comment)
              println("ellipse wrong dist "+start+" "+(_syll.length - 1)+" "+stop+" "+currmatches.get(msize).get(mnum).index_b+" "+currmatches.get(msize).get(mnum).index_e);
            okgo = false;  
          }
          }else if(currmatches.get(msize).get(mnum).bn == 0){
            if(start != currmatches.get(msize).get(mnum).index_b ||  (_syll.length - 1) - stop < currmatches.get(msize).get(mnum).index_e-matches.get(msize).get(mnum).en){
             if(comment)
              println("ellipse wrong dist2");
             okgo = false;
            }
          }else if(currmatches.get(msize).get(mnum).en == 0){
            if(stop != currmatches.get(msize).get(mnum).index_e ||  (_syll.length - 1) - start < currmatches.get(msize).get(mnum).index_b - currmatches.get(msize).get(mnum).bn){
            if(comment)
              println("ellipse wrong dist3"); 
            okgo = false;
            }
          }
          
          //if legal
          if(okgo){
      if(rseg){  //in rhyme segment - add string
          res.add(track+"("+j+")");
      }else{ //no in rhyme seg...just update index
          res.add("("+j+")");
      }
      }
     }
     //println(res);
    } else if(_type == 0){ //sylls - this should only have one poss be res. 
      String m = "";
      //check if in same syllable as last - else advance
      int syllInd = 0;
      if(rseg){
        if(_syll.length > syllInd){
          m = currmatches.get(msize).get(mnum).getONC(_syll[syllInd]);
          //println("ONC m: "+m);
          if(m.length() == 0){
          }else{
          //check if correct distance from beg/end
          if(currmatches.get(msize).get(mnum).bn == 0 && currmatches.get(msize).get(mnum).en == 0 ){
            if(syllInd != currmatches.get(msize).get(mnum).index_b ||  _syll.length - 1 - syllInd != currmatches.get(msize).get(mnum).index_e){
             m = ""; 
            println("wrong dist1 " + syllInd +" "+ currmatches.get(msize).get(mnum).index_b +" "+_syll.length+ " "+currmatches.get(msize).get(mnum).index_e);

            }
          }else if(currmatches.get(msize).get(mnum).bn == 0){
            if(syllInd != currmatches.get(msize).get(mnum).index_b ||  (_syll.length - 1) - syllInd < currmatches.get(msize).get(mnum).index_e-currmatches.get(msize).get(mnum).en){
             m = ""; 
             println("wrong dist2" + syllInd +" "+ currmatches.get(msize).get(mnum).index_b +" "+_syll.length+ " "+currmatches.get(msize).get(mnum).index_e + " "+currmatches.get(msize).get(mnum).en);
            }
          }else if(currmatches.get(msize).get(mnum).en == 0){
            if((_syll.length - 1) - syllInd != currmatches.get(msize).get(mnum).index_e ||  syllInd < currmatches.get(msize).get(mnum).index_b - currmatches.get(msize).get(mnum).bn){
             m = ""; 
             println("wrong dist3" + syllInd +" "+currmatches.get(msize).get(mnum).index_e+" "+_syll.length +" "+ currmatches.get(msize).get(mnum).index_b +" "+ currmatches.get(msize).get(mnum).bn);
            }
          }
          }
        }else{
        }
        if(m.length() == 0){
          //println("nada - first pass");
          //if match breaks, delete entire string.
          //res.set(i, null);
        } else {
          res.add(m+"("+syllInd+")");
          println(res);
        }
      }else{
       //just advance.
       //res.add("("+syllInd+")");
      }
    }
    //println("again: "+res);
    while(res.remove(null)); //inefficient - but removes deadends
    //println("again: "+res);
   return res;
   }else{ //not initiating
   //println("proceeding...");
   println("adding to"+res);
   for(int i = 0; i < res.size(); i++){
    index = Integer.parseInt(res.get(i).replaceAll(".*\\(|\\).*", "")); //for this it's syllable index
    res.set(i, res.get(i).substring(0,res.get(i).indexOf("(")));
    //res.set(i, res.get(i).replaceAll("[\\(\\)]",""));
    //println("res: "+res.get(i));
    if(_type == 2){ //ellipse - iterate through entire word.
     boolean first = true;
     start = index; 
     track = "";
     for(int j = index; j < _syll.length; j++){ //start at index to take no addition into account
      //for no addition
      /*if(j == index){
       if(rseg){
        res.set(i, res.get(i)+"("+j+")");
       }else{
        res.set(i, res.get(i)+"("+j+")");
       } 
        first = false;
        continue;
      }*/
      stop = j; 
      okgo = true;
      if(j > index){
      track += _syll[j].getFullSyllStr(); 
      }
      //check in correct dist...
      if(currmatches.get(msize).get(mnum).en == 0){
            if((_syll.length - 1) - stop != currmatches.get(msize).get(mnum).index_e){
            if(comment)
              println("ellipse wrong dist3 "+track+" "+stop+" "+currmatches.get(msize).get(mnum).index_e); 
            okgo = false;
            }
          }else if((_syll.length - 1) - stop < currmatches.get(msize).get(mnum).index_e-currmatches.get(msize).get(mnum).en || (_syll.length - 1) - start < currmatches.get(msize).get(mnum).index_b - currmatches.get(msize).get(mnum).bn){
        if(comment)
            println("ellipse wrong dist");
        okgo = false;
      }
      /*if(matches.get(msize).get(mnum).bn == 0 && matches.get(msize).get(mnum).en == 0 ){
            if(start != matches.get(msize).get(mnum).index_b ||  _syll.length - 1 - stop != matches.get(msize).get(mnum).index_e){
            println("ellipse wrong dist "+start+" "+(_syll.length - 1)+" "+stop+" "+matches.get(msize).get(mnum).index_b+" "+matches.get(msize).get(mnum).index_e);
            okgo = false;  
          }
          }else if(matches.get(msize).get(mnum).bn == 0){
            if(start != matches.get(msize).get(mnum).index_b ||  (_syll.length - 1) - stop < matches.get(msize).get(mnum).index_e-matches.get(msize).get(mnum).en){
             println("ellipse wrong dist2");
             okgo = false;
            }
          }else if(matches.get(msize).get(mnum).en == 0){
            if(stop != matches.get(msize).get(mnum).index_e ||  (_syll.length - 1) - start < matches.get(msize).get(mnum).index_b - matches.get(msize).get(mnum).bn){
            println("ellipse wrong dist3"); 
            okgo = false;
            }
          }*/
      
      
      if(okgo){
      if(rseg){  //in rhyme segment - add string
        /*if(j == index){
          res.set(i, res.get(i)+"("+j+")");
        }else{*/
          //res.add(i+1,res.get(i).substring(0,res.get(i).indexOf("("))+_syll[j].getFullSyllStr()+"("+j+")");
          if(first){
            res.set(i, res.get(i) + track+"("+j+")");
            first = false;
          }else{
          res.add(i+1,res.get(i).substring(0,res.get(i).indexOf("(")) + track+"("+j+")");
          i++; //advance once array element (to avoid repeats)
          }
       // }
      }else{ //no in rhyme seg...just update index
       /* if(j == index){
          res.set(i, res.get(i)+"("+j+")");
        }else{*/
        if(first){
          res.set(i, res.get(i)+"("+j+")");
          first = false;
        }else{
          res.add(i+1,res.get(i)+"("+j+")");
         i++; //advance once array element (to avoid repeats)
        }
        //}
      }
      }
     }
    }
    if(_type == 0){ //sylls - this should only have one poss be res. 
    //println("nextSyll");
      String m = "";
      //check if in same syllable as last - else advance
      
      int syllInd;
      if(index == -1){
       syllInd = 0; 
      }else{
      syllInd= ( mnum > 0 && currmatches.get(msize).get(mnum-1).index_b == currmatches.get(msize).get(mnum).index_b) ? index : index+1;
      }
      /*if(msize > 0){
      println("syllInd: "+syllInd + " " + index + " "+matches.get(msize-1).get(mnum).index_b+" "+matches.get(msize).get(mnum).index_b);
      }*/
      if(rseg){
        //println(_syll.length+" "+syllInd + " "+index+" "+mnum);//+matches.get(msize).get(mnum-1).index_b+" "+matches.get(msize).get(mnum).index_b);
        if(_syll.length > syllInd){
          m = currmatches.get(msize).get(mnum).getONC(_syll[syllInd]);
          println("m: "+m);
          //check if correct distance from beg/end
          if(currmatches.get(msize).get(mnum).bn == 0 && currmatches.get(msize).get(mnum).en == 0 ){
            if(syllInd != currmatches.get(msize).get(mnum).index_b ||  _syll.length - 1 - syllInd != currmatches.get(msize).get(mnum).index_e){
             m = ""; 
             if(comment)
             println("wrong dist 1");
            }
          }else if(currmatches.get(msize).get(mnum).bn == 0){
            if(syllInd != currmatches.get(msize).get(mnum).index_b ||  (_syll.length - 1) - syllInd < currmatches.get(msize).get(mnum).index_e-currmatches.get(msize).get(mnum).en){
             m = ""; 
             if(comment)
             println("wrong dist 2");
            }
          }else if(currmatches.get(msize).get(mnum).en == 0){
            if((_syll.length - 1) - syllInd != currmatches.get(msize).get(mnum).index_e ||  syllInd < currmatches.get(msize).get(mnum).index_b - currmatches.get(msize).get(mnum).bn){
             m = ""; 
             if(comment)
             println("wrong dist3 " + syllInd +" "+currmatches.get(msize).get(mnum).index_e+" "+_syll.length +" "+ currmatches.get(msize).get(mnum).index_b +" "+ currmatches.get(msize).get(mnum).bn);
            }
          }
        }else{
        }
        if(m.length() == 0){
          //if match breaks, delete entire string.
          res.set(i, null);
        } else {
          res.set(i, res.get(i)+m+"("+syllInd+")");
        }
      }else{
       //just advance.
       res.set(i, res.get(i)+"("+syllInd+")");
      }
    }
   }
   }
   while(res.remove(null)); //inefficient - but removes deadends
   //println("again: "+res);
   return res;
  }
  
  
  public ArrayList<String> buildChar2(int msize, int mnum, ArrayList<String> res, char[] _wrd, int wInd, boolean isbimatch, Word _word, boolean nexties, boolean initNext){
   //nexties = false;
   //initNext = false;
    //iterate on res.
   //println(String.valueOf(_wrd));
   int _type =  currmatches.get(msize).get(mnum).type;
   boolean rseg = currmatches.get(msize).get(mnum).rhymeSeg;
   //for mixing
   String begMix = (rseg && currmatches.get(msize).get(mnum).mix == 1 && ((mnum > 0 && currmatches.get(msize).get(mnum-1).mix != 1) || (mnum == 0))) ? "[" : "";
   String endMix = (rseg && currmatches.get(msize).get(mnum).mix == 1 && ((mnum < currmatches.get(msize).size()-1 && currmatches.get(msize).get(mnum+1).mix != 1) || (mnum == currmatches.get(msize).size()-1))) ? "]" : "";
   int index;
   int start = 0;
   int stop = 0; 
   String track = "";
   boolean okgo = true;
   int firstA = 100;
   int firstB = 100;
   
   //calc first consonant + first vowel
   
   for(int g = 0; g < _wrd.length; g++){
     String s = ""+_wrd[g];
     if("aeiouy".indexOf(s.toLowerCase()) != -1){
      firstA = g;
      break; 
     }
   }
   
   for(int g = 0; g < _wrd.length; g++){
     String s = ""+_wrd[g];
     if("bcdfghjklmnpqrstvwxyz".indexOf(s.toLowerCase()) != -1){
      firstB = g;
      break; 
     }
   }
   
   if((res.size() == 0 && mnum == 0) /*|| initNext*/){ //initiate
   if(comment){
   println("initiating...");
   }
   if(initNext){println("next word :"+ _word.getDisplayWord());}
   //initNext = false; do this at the end
     if(_type == 2){ //ellipse - iterate through entire word. 
     //add zero option
     if(rseg){  //in rhyme segment - add string
          if(initNext){
            for(int i = 0; i < res.size(); i++){
              String tmpRes = res.get(i).substring(0,res.get(i).indexOf("("));
              res.set(i, tmpRes+begMix+"("+(-1)+")"+endMix);
            }
          }else{
          res.add(begMix+"("+(-1)+")"+endMix);
          }
      }else{ //no in rhyme seg...just update index
          if(initNext){
            for(int i = 0; i < res.size(); i++){
              String tmpRes = res.get(i).substring(0,res.get(i).indexOf("("));
              res.set(i, tmpRes+"("+(-1)+")");
            }
          }else{
          res.add("("+(-1)+")");
         }
      }
     start = 0;
     stop = 0; 
     track = "";
     for(int j = 0; j < _wrd.length; j++){
      stop = j; 
      okgo = true;
      track += _wrd[j];
      //check in correct dist...
      if(currmatches.get(msize).get(mnum).bn == 0 && currmatches.get(msize).get(mnum).en == 0 ){
            if(start != currmatches.get(msize).get(mnum).index_b ||  _wrd.length - 1 - stop != currmatches.get(msize).get(mnum).index_e){
            if(comment)
              println("ellipse wrong dist "+start+" "+(_wrd.length - 1)+" "+stop+" "+currmatches.get(msize).get(mnum).index_b+" "+currmatches.get(msize).get(mnum).index_e);
            okgo = false;  
          }
          }else if(currmatches.get(msize).get(mnum).bn == 0){
            if(start != currmatches.get(msize).get(mnum).index_b ||  (_wrd.length - 1) - stop < currmatches.get(msize).get(mnum).index_e-currmatches.get(msize).get(mnum).en){
             if(comment)
              println("ellipse wrong dist2");
             okgo = false;
            }
          }else if(currmatches.get(msize).get(mnum).en == 0){
            if(stop != currmatches.get(msize).get(mnum).index_e ||  (_wrd.length - 1) - start < currmatches.get(msize).get(mnum).index_b - currmatches.get(msize).get(mnum).bn){
            if(comment)
              println("ellipse wrong dist3"); 
            okgo = false;
            }
          }
          
          //if legal
          if(okgo){
      if(rseg){  //in rhyme segment - add string
          if(initNext){
            for(int i = 0; i < res.size(); i++){
            
            }
          }else{
          res.add(begMix+track+endMix+"("+j+")");
          }
      }else{ //no in rhyme seg...just update index
          if(initNext){
            
          }else{
          res.add("("+j+")");
         }
      }
      }
     }
     //println(res);
    } else if(_type == 1){ //chars
      String m = "";
      int charInd = 0;
      if(rseg){
        if(_wrd.length > charInd){
          m = currmatches.get(msize).get(mnum).getCluster2(_wrd, charInd, firstA, firstB); //gives the starting point
          if(m.length() == 0){
          }else{
          //check if correct distance from beg/end
          if(currmatches.get(msize).get(mnum).bn == 0 && currmatches.get(msize).get(mnum).en == 0 ){
            if(charInd != currmatches.get(msize).get(mnum).index_b ||  _wrd.length - 1 - charInd != currmatches.get(msize).get(mnum).index_e){
             m = ""; 
            if(comment)
            println("wrong dist1 " + charInd +" "+ currmatches.get(msize).get(mnum).index_b +" "+_wrd.length+ " "+currmatches.get(msize).get(mnum).index_e);

            }
          }else if(currmatches.get(msize).get(mnum).bn == 0){
            if(charInd != currmatches.get(msize).get(mnum).index_b ||  (_wrd.length - 1) - charInd < currmatches.get(msize).get(mnum).index_e-currmatches.get(msize).get(mnum).en){
             m = ""; 
             if(comment)
             println("wrong dist2" + charInd +" "+ currmatches.get(msize).get(mnum).index_b +" "+_wrd.length+ " "+currmatches.get(msize).get(mnum).index_e + " "+currmatches.get(msize).get(mnum).en);
            }
          }else if(currmatches.get(msize).get(mnum).en == 0){
            if((_wrd.length - 1) - charInd != currmatches.get(msize).get(mnum).index_e ||  charInd < currmatches.get(msize).get(mnum).index_b - currmatches.get(msize).get(mnum).bn){
             m = ""; 
             if(comment)
             println("wrong dist3" + charInd +" "+currmatches.get(msize).get(mnum).index_e+" "+_wrd.length +" "+ currmatches.get(msize).get(mnum).index_b +" "+ currmatches.get(msize).get(mnum).bn);
            }
          }
          }
        }else{
        }
        if(m.length() == 0){
        } else {
          if(initNext){
            
          }else{
          res.add(begMix+m+endMix+"("+(charInd+m.length()-1)+")");
          }
          if(comment){
          println(res);
          }
        }
      }else{
       //just advance.
       //res.add("("+syllInd+")");
       int ch2 = charInd + currmatches.get(msize).get(mnum).subtype.length()-1;
       if(initNext){
         
       }else{
       res.add("("+(charInd + ch2)+")");
       }
      }
    }
    //println("again: "+res);
    while(res.remove(null)); //inefficient - but removes deadends
    //println("again: "+res);
   initNext = false;
   return res;
   }else{ //not initiating
   if(comment){
   println("proceeding...");
   println("adding to"+res);
   }
   for(int i = 0; i < res.size(); i++){
     if(initNext){
       index = -1;
     }else{
      index = Integer.parseInt(res.get(i).replaceAll(".*\\(|\\).*", "")); //for this it's syllable index
     }
    if(index == -1){
      //index = 0;
      if(comment){
      println("res: "+res);
      }
    }
    //println(index);
    //res.set(i, res.get(i).substring(0,res.get(i).indexOf("(")));
    String tmpRes = res.get(i).substring(0,res.get(i).indexOf("("));
    if(comment)
    println("tmp: "+tmpRes);
    //res.set(i, res.get(i).replaceAll("[\\(\\)]",""));
    //println("res: "+res.get(i));
    if(_type == 2){ //ellipse - iterate through entire word.
     boolean first = true;
     //start = (nexties)? 0 : index; 
     start = index; 
     track = "";
     for(int j = index; j < _wrd.length; j++){ //start at index to take no addition into account
      stop = j; 
      okgo = true;
      if(j > index){
      track += _wrd[j]; 
      }
      //check in correct dist...
      if(currmatches.get(msize).get(mnum).en == 0){
            if((_wrd.length - 1) - stop != currmatches.get(msize).get(mnum).index_e){
              if(comment){
            println("ellipse wrong dist3 "+track+" "+stop+" "+currmatches.get(msize).get(mnum).index_e); 
              }
            okgo = false;
            }
          }else if((_wrd.length - 1) - stop < currmatches.get(msize).get(mnum).index_e-currmatches.get(msize).get(mnum).en || (_wrd.length - 1) - start < currmatches.get(msize).get(mnum).index_b - currmatches.get(msize).get(mnum).bn){
        if(comment){
            println("ellipse wrong dist");
        }
        okgo = false;
      }
      
      if(okgo){
      if(rseg){  //in rhyme segment - add string
          if(first){
            res.set(i, tmpRes+begMix+track+ endMix+"("+j+")");
            first = false;
          }else{
          //println("track: "+track);  
          res.add(i+1,tmpRes+begMix+ track+ endMix+"("+j+")");
          i++; //advance once array element (to avoid repeats)
          }
      }else{ //not in rhyme seg...just update index
        if(first){
          res.set(i, res.get(i).substring(0,res.get(i).indexOf("("))+"("+j+")");
          first = false;
        }else{
          res.add(i+1,res.get(i).substring(0,res.get(i).indexOf("("))+"("+j+")");
         i++; //advance once array element (to avoid repeats)
        }
      }
      }
     }
    }
    if(_type == 1){ //chars!
      String m = "";
      //int charInd = (nexties)? 0 : index+1;
      int charInd = index+1;
      if(comment){
      println("charInd: "+charInd);
      }
      if(rseg){
        if(_wrd.length > charInd){
          m = currmatches.get(msize).get(mnum).getCluster2(_wrd, charInd, firstA, firstB); //gives the starting point
          if(m.length() == 0){
          }else{
          //check if correct distance from beg/end
          if(currmatches.get(msize).get(mnum).bn == 0 && currmatches.get(msize).get(mnum).en == 0 ){
            if(charInd != currmatches.get(msize).get(mnum).index_b ||  _wrd.length - 1 - charInd != currmatches.get(msize).get(mnum).index_e){
             m = ""; 
             if(comment){
            println("wrong dist1 " + charInd +" "+ currmatches.get(msize).get(mnum).index_b +" "+_wrd.length+ " "+currmatches.get(msize).get(mnum).index_e);
             }

            }
          }else if(currmatches.get(msize).get(mnum).bn == 0){
            if(charInd != currmatches.get(msize).get(mnum).index_b ||  (_wrd.length - 1) - charInd < currmatches.get(msize).get(mnum).index_e-currmatches.get(msize).get(mnum).en){
             m = ""; 
             if(comment){
             println("wrong dist2 " + charInd +" "+ currmatches.get(msize).get(mnum).index_b +" "+_wrd.length+ " "+currmatches.get(msize).get(mnum).index_e + " "+currmatches.get(msize).get(mnum).en);
             }  
          }
          }else if(currmatches.get(msize).get(mnum).en == 0){
            if((_wrd.length - 1) - charInd != currmatches.get(msize).get(mnum).index_e ||  charInd < currmatches.get(msize).get(mnum).index_b - currmatches.get(msize).get(mnum).bn){
             m = ""; 
             if(comment){
             println("wrong dist3m " + charInd +" "+currmatches.get(msize).get(mnum).index_e+" "+_wrd.length +" "+ currmatches.get(msize).get(mnum).index_b +" "+ currmatches.get(msize).get(mnum).bn);
             }  
          }
          }
          }
        }else{
        }
        if(m.length() == 0){
          //if match breaks, delete entire string.
          res.set(i, null);
        } else {
          res.set(i, res.get(i).substring(0,res.get(i).indexOf("("))+begMix+m+endMix+"("+(charInd+m.length()-1)+")");
        }
      }else{
        int ch2 = currmatches.get(msize).get(mnum).subtype.length()-1;
       //just advance.
       res.set(i, res.get(i).substring(0,res.get(i).indexOf("("))+"("+(charInd+ch2)+")");
      }
    }
   }
   }
   while(res.remove(null)); //inefficient - but removes deadends
   //println("again: "+res);
   return res;
  }
  
  
  public String sortAlpha(String subt){
    char[] p = subt.toCharArray();
    Arrays.sort(p);
    return new String(p);
  }
  
  
  public ArrayList<String> buildChar(int msize, int mnum, ArrayList<String> res, char[] _wrd){
   //iterate on res. 
   for(int i = 0; i < res.size(); i++){
    int _type =  matches.get(msize).get(mnum).type;
    boolean rseg = matches.get(msize).get(mnum).rhymeSeg;
    int index = Integer.parseInt(res.get(i).replaceAll(".*\\(|\\).*", "")); //for this it's syllable index
    res.set(i, res.get(i).substring(0,res.get(i).indexOf("("))); //delete index
    if(_type == 2){ //ellipse - iterate through entire word. 
     for(int j = index+1; j < _wrd.length; j++){
      if(rseg){  //in rhyme segment - add string
        if(j == index+1){
          res.set(i, res.get(i)+_wrd[j]+"("+j+")");
        }else{
          res.add(i+1,res.get(i)+_wrd[j]+"("+j+")");
         i++; //advance once array element (to avoid repeats)
        }
      }else{ //no in rhyme seg...just update index
        if(j == index+1){
          res.set(i, res.get(i)+"("+j+")");
        }else{
          res.add(i+1,res.get(i)+"("+j+")");
         i++; //advance once array element (to avoid repeats)
        }
      }
     }
    }
    if(_type == 1){ //chars! either mixed or nonmixes 
      /*String m = "";
      //check if in same syllable as last - else advance
      int charInd = index+1;
      if(rseg){
        if(_wrd.length > charInd){
          //now we're dealing with subtypes. 
          
          m = matches.get(msize).get(mnum).getCluster2(_wrd);
          //check if correct distance from beg/end
          if(matches.get(msize).get(mnum).bn == 0 && matches.get(msize).get(mnum).bn == 0 ){
            if(charInd != matches.get(msize).get(mnum).index_b ||  _wrd.length - 1 - charInd != matches.get(msize).get(mnum).index_e){
             m = ""; 
            }
          }else if(matches.get(msize).get(mnum).bn == 0){
            if(charInd != matches.get(msize).get(mnum).index_b ||  (_wrd.length - 1) - charInd < matches.get(msize).get(mnum).index_e-matches.get(msize).get(mnum).en){
             m = ""; 
            }
          }else if(matches.get(msize).get(mnum).en == 0){
            if(charInd != matches.get(msize).get(mnum).index_e ||  (_wrd.length - 1) - charInd < matches.get(msize).get(mnum).index_b - matches.get(msize).get(mnum).bn){
             m = ""; 
            }
          }
        }else{
        }
        if(m.length() == 0){
          //if match breaks, delete entire string.
          res.set(i, "");
        } else {
          res.set(i, res.get(i)+m+"("+charInd+")");
        }
      }else{
       //just advance.
       res.set(i, res.get(i)+"("+charInd+")");
      }*/
    }
   }
   while(res.remove("")); //inefficient - but removes deadends
   return res;
  }
  
  
  public void printRule3() {
   println(strRule);
    for (int i = 0; i < matches.size (); i++) {
      if(i > 0){
        matchingStr += " |";
      }
      for (int j = 0; j < matches.get (i).size(); j++) {
        matchingStr += " "+matches.get(i).get(j).subtype+"("+matches.get(i).get(j).rhymeSeg+")"+"("+matches.get(i).get(j).index_b+matches.get(i).get(j).bn+")"+"("+matches.get(i).get(j).index_e+matches.get(i).get(j).en+")w:"+matches.get(i).get(j).word;
      }
    }
    if (bimatch) {
      matchingStr += " & ";
      for (int i = 0; i < bimatches.size (); i++) {
        for (int j = 0; j < bimatches.get (i).size(); j++) {
          matchingStr += " "+bimatches.get(i).get(j).subtype+"("+bimatches.get(i).get(j).rhymeSeg+")"+"("+bimatches.get(i).get(j).index_b+bimatches.get(i).get(j).bn+")"+"("+bimatches.get(i).get(j).index_e+bimatches.get(i).get(j).en+")w:"+bimatches.get(i).get(j).word;
        }
      }
    }
    println("Matching String: "+matchingStr);
  }
  
  

public void printRule2() {
  if(comment)
   println(strRule);
    for (int i = 0; i < matches.size (); i++) {
      if(i > 0){
        matchingStr += " |";
      }
      for (int j = 0; j < matches.get (i).size(); j++) {
        matchingStr += " "+matches.get(i).get(j).subtype+"("+matches.get(i).get(j).rhymeSeg+")"+"("+matches.get(i).get(j).index_b+matches.get(i).get(j).bn+")"+"("+matches.get(i).get(j).index_e+matches.get(i).get(j).en+")w:"+matches.get(i).get(j).word;
      }
    }
    if (bimatch) {
      matchingStr += " & ";
      for (int i = 0; i < bimatches.size (); i++) {
        for (int j = 0; j < bimatches.get (i).size(); j++) {
          matchingStr += " "+bimatches.get(i).get(j).subtype+"("+bimatches.get(i).get(j).rhymeSeg+")"+"("+bimatches.get(i).get(j).index_b+bimatches.get(i).get(j).bn+")"+"("+bimatches.get(i).get(j).index_e+bimatches.get(i).get(j).en+")w:"+bimatches.get(i).get(j).word;
        }
      }
    }
    if(comment)
    println("Matching String: "+matchingStr);
  }

public void printRulei(int i) {
  if(comment)
   println(strRule);
   matchingStr = "";
      for (int j = 0; j < matches.get (i).size(); j++) {
        matchingStr += " "+matches.get(i).get(j).subtype+"("+matches.get(i).get(j).rhymeSeg+")"+"("+matches.get(i).get(j).index_b+matches.get(i).get(j).bn+")"+"("+matches.get(i).get(j).index_e+matches.get(i).get(j).en+")";
      }
    if (bimatch) {
      matchingStr += " & ";
        for (int j = 0; j < bimatches.get (i).size(); j++) {
          matchingStr += " "+bimatches.get(i).get(j).subtype+"("+bimatches.get(i).get(j).rhymeSeg+")"+"("+bimatches.get(i).get(j).index_b+bimatches.get(i).get(j).bn+")"+"("+bimatches.get(i).get(j).index_e+bimatches.get(i).get(j).en+")";
    }
    }
    if(comment)
    println("Matching String: "+matchingStr);
  }


  public void printRule() {
    println(strRule);
    for (int i = 0; i < matches.size (); i++) {
      for (int j = 0; j < matches.get (i).size(); j++) {
        if (j>0)
          matchingStr += " | ";
        matchingStr += " "+matches.get(i).get(j).bn + matches.get(i).get(j).index_b + matches.get(i).get(j).subtype +  matches.get(i).get(j).en + matches.get(i).get(j).index_e + "("+matches.get(i).get(j).stress+")";
      }
    }
    if (bimatch) {
      matchingStr += " & ";
      for (int i = 0; i < bimatches.size (); i++) {
        for (int j = 0; j < bimatches.get (i).size(); j++) {
          if (j>0)
            matchingStr += " | ";
          matchingStr += " "+bimatches.get(i).get(j).bn + bimatches.get(i).get(j).index_b + bimatches.get(i).get(j).subtype +  bimatches.get(i).get(j).en + bimatches.get(i).get(j).index_e + "("+bimatches.get(i).get(j).stress+")";
        }
      }
    }
    if(comment)
    println("Matching String: "+matchingStr);
  }
  //decode rule
  /*void processRule() {
    String[] rSplit = split(strRule, '-'); //split syllables
    boolean mOn = false;
    matchingStr = "";
    stresses = "";
    String ts = "";
    String ts1 = "";
    String ts2 = "";
    String leftOver = "";
    sylls.clear();
    syllsNoP.clear();
    phones.clear();
    ellipses.clear();

    //first pass, register ellipses. 
    for (int i = 0; i<rSplit.length; i++) {
      if (rSplit[i].indexOf("...") != -1) {
        ellipses.add(i);
      }
    }

    for (int i = 0; i<rSplit.length; i++) {  //loop through syllables
      ts = ts1 = ts2 = "";
      leftOver = "";
      if(comment)
      println(rSplit[i]);

      if (rSplit[i].indexOf('\'') != -1) {
        stressedSyll = i;
      }
      if (mOn) {
        ts = rSplit[i];
        if (rSplit[i].indexOf(']') != -1) {
          mOn = false; 
          ts = rSplit[i].substring(0, rSplit[i].indexOf(']')+1);
        }
        matchingStr += "-" + ts;
        sylls.add(i+"("+ts.replaceAll("[\\[\\]\\']", "")+")");
        //add to syllsNoP
        //ts = ts.replaceAll("[\\[\\]\\']", "");
        ts = ts.replaceAll("[\\[\\]]", "");
        while (ts.indexOf ('p') != -1) {
          ts1 = (ts.indexOf('p')-1 == 0) ? "" : ts.substring(0, ts.indexOf('p')-1);
          ts2 = (ts.indexOf('p')+1 > ts.length()-1) ? "" : ts.substring(ts.indexOf('p')+1);
          ts = ts1 + ts2;
        }
        if (ts.length() > 0) {
          String b_num = ""+i;
          String e_num = ""+(rSplit.length-i-1);

          for (int k = 0; k < ellipses.size (); k++) {
            if (ellipses.get(k) < i) {
              b_num += "n";
            } else if (ellipses.get(k) > i) {
              e_num += "n";
            }
          }
          syllsNoP.add(b_num+"("+ts+")"+e_num);
        }
      } else {
        if (rSplit[i].indexOf('[') != -1) {
          ts = rSplit[i].substring(rSplit[i].indexOf('['));
          mOn = true;
          if (rSplit[i].indexOf(']') != -1) {
            mOn = false;
            ts = ts.substring(0, ts.indexOf(']')+1);
          }
          matchingStr += "" + ts;
          sylls.add(i+"("+ts.replaceAll("[\\[\\]\\']", "")+")");

          //ts = ts.replaceAll("[\\[\\]\\']", "");
          ts = ts.replaceAll("[\\[\\]]", "");
          while (ts.indexOf ('p') != -1) {
            ts1 = (ts.indexOf('p')-1 == 0) ? "" : ts.substring(0, ts.indexOf('p')-1);
            ts2 = (ts.indexOf('p')+1 > ts.length()-1) ? "" : ts.substring(ts.indexOf('p')+1);
            ts = ts1 + ts2;
          }
          if (ts.length() > 0) {
            String b_num = ""+i;
            String e_num = ""+(rSplit.length-i-1);

            for (int k = 0; k < ellipses.size (); k++) {
              if (ellipses.get(k) < i) {
                b_num += "n";
              } else if (ellipses.get(k) > i) {
                e_num += "n";
              }
            }
            syllsNoP.add(b_num+"("+ts+")"+e_num);
            //matches.add(new matched(ts, b_num, e_num));
          }
        }
      }
    }
    for (int j = 0; j < sylls.size (); j++) {
      stresses += " "+sylls.get(j); 
      if (sylls.get(j).indexOf('p') != -1) {
        String tsyll = sylls.get(j);
        String tp = tsyll.substring(0, 2);
        while (tsyll.indexOf ('p') != -1) {
          tp += ""+tsyll.charAt(tsyll.indexOf('p')-1);
          tsyll = tsyll.replaceFirst("p", "");
          if(comment)
          println(tsyll);
        }
        tp += ")";
        phones.add(tp);
      }
    }
    if(comment){
    println("New Rule");  
    println("rhyme: "+matchingStr);
    println("stressed syllable: "+stressedSyll);
    println("matching sylls: "+syllsNoP);
    println("matching phones (mouth placement): "+phones);
    }
  }*/


  public String mString(int[] a) {
    String s = "";
    for (int i = 0; i < a.length; i++) {
      s += ""+a[i]+"+";
    }
    return s;
  }
};

int idCount = 0;

int[] pronNumbers;
String[] customPron;

  Word[] currWords1, currWords2; //for crossWords
  
  boolean comment = false;
  
  ArrayList<String> resRules = new ArrayList<String>();
class Poem {

  String _title;
  String _author;
  Line[] _lines;

  Poem( String title, String author, Line[] l ) {
    _title = title;
    _author = author;
    _lines = l;
  }

  public String getTitle() {
    return _title;
  }

  public String getAuthor() {
    return _author;
  }

  public Line getLine( int i ) {
    return _lines[i];
  }

  public Line[] getAllLines() {
    return _lines;
  }

  public int getNumLines() {
    return _lines.length;
  }
}


//---------------------//
//
class Line {
  Word[] _words;
  int lnum;

  Line( String[] words, int num ) {
    lnum = num;
    _words = new Word[words.length];
    for ( int i = 0; i < words.length; i++ ) {
      _words[i] = new Word( words[i], i, lnum);
    }
  }

  public Word[] getWords() {
    return _words;
  }

  public Word getWord( int i ) {
    return _words[i];
  }

  public int getNumWords() {
    return _words.length;
  }
}

//---------------------//
//
class Word {
  int _loc; //maybe not necessary
  int _line;
  String _word;
  String _displayWord;
  char[] _letters;
  float x, y, xw;    //for changing pronunciation
  boolean isWord = true;
  int wrdcount = 0;
  Syllable[] _syllables;
  int[] _stressedVowels;
  Syllable[][] _2DSyllables;    //maybe easier

  int _pronunciations;
  int pronNum;
  boolean _exists = true; 
  boolean _lts = false;
  int selected = -1;
  float _x;
  float _y;
  boolean hover = false;
  //String POS;
  Phoneme[] _phonemes;
  String _phonetics = "";
  ArrayList< ArrayList<Phoneme> > phonemeArray;
  ArrayList< ArrayList<Syllable> > syllableArray;
  ArrayList<String> currRes;
  ArrayList<String> currBiMatch;

  /*Word( String word) {
   _word = word;
   analyzePhonemes();
   }*/

  Word( String word, int loc, int line) {
    wrdcount = idCount;
    _loc = loc;
    _line = line;
    pronNum = pronNumbers[wrdcount];
    if (pronNum != 0) {
      if(comment)
      println(wrdcount+" "+word+" "+pronNum);
    }
    _displayWord = word; 
    if (Character.isWhitespace(word.charAt(0))) {
      isWord = false;
    }    //for speedup, only process ig isWord = true
    word = word.toLowerCase().replaceAll("[.,;:()?-]", "");
    _word = word;
    _loc = loc;
    _letters = word.toCharArray();
    phonemeArray = new ArrayList< ArrayList<Phoneme> >();
    syllableArray = new ArrayList< ArrayList<Syllable> >();
    processWord(word);
    idCount++;  //increment count
  }


  public void processWord(String word) {
    word = trim(word);
    String tmp = "";
    String ltsTmp = "";
    ArrayList<String> tmpArray = new ArrayList<String>();    //potential space sink
    //ArrayList<String> customProns = new ArrayList<String>(); 
    ArrayList<Syllable> tmpSylls = new ArrayList<Syllable>();

    //check if word exists
    tmp = _cmuMap.getFirstPhoneme(word).replaceAll("_", " ");
    if (tmp == "?" && (word.trim().length() == 0 || lts.syllabifiedPhones(word.trim()).equals("null"))) {    //memory suck! fixed this! calculates twice each time
      _exists = false;

      //println("using LTS on '"+word+"' : " + lts.syllabifiedPhones(word));
      //return;
    } else {                  //only proceed if word exists. loop through all pronunciations

      if (tmp == "?") {
        //tmpArray.clear();
        //tmpArray.add(ltsTmp);
        tmpArray.addAll(lts.LTSphones(word.trim()));
        _lts = true;
      } else {
        tmpArray.clear();
        //customProns.clear();
        tmpArray.addAll(_cmuMap.getPhonemes(word));
        //println(tmp);
        _pronunciations = tmpArray.size();
        //println(_pronunciations);
      }
      if (customPron[wrdcount] != null && customPron[wrdcount].length() > 0) {
        //check is valid
        //println("tmpArray: "+tmpArray+" "+_cmuMap.getPhonemes(word));
        //println("Custom Pron:"+customPron[wrdcount]);
        //Arrays.asList(customPron[wrdcount].split(":"));
        //customProns.addAll(Arrays.asList(customPron[wrdcount].split(":"));
        //tmpArray.addAll(customProns);
        tmpArray.addAll(Arrays.asList(customPron[wrdcount].split(":"))); 
        if(comment)
        println("tmpArray: "+tmpArray);
        //}
      }
      _2DSyllables = new Syllable[tmpArray.size()][];
      _stressedVowels = new int[tmpArray.size()];
      //processProns(tmpArray);
      for (int sz = 0; sz < tmpArray.size (); sz++) {

        try {
        tmp = tmpArray.get(sz).replaceAll("_", " ");
        String[] tmp0 = tmp.split(":");
        if (tmp0.length == 2) {
          _pronunciations = PApplet.parseInt(tmp0[1]);
        } else {              
          _pronunciations = 0;
        }
        String tmp1 = tmp0[0];
        int sv = 0; //if something like and - will use first syllable
        analyzePhonemes(trim(tmp1));
        String[] sylls = tmp1.split("-");
        _syllables = new Syllable[sylls.length];
        //tmpSylls.clear();
        syllableArray.add(new ArrayList<Syllable>());
        for (int i =0; i < sylls.length; i++) {
          //println("Syll" + i + ": ");
          Syllable _syll = new Syllable(trim(sylls[i]), _pMap, i);
          if (_syll._stress.equals("1")) {
            sv = i; 
            //find char in word.
          }
          _syllables[i] = _syll;
          syllableArray.get(syllableArray.size()-1).add(_syll);
          _syll.returnString(_syll.getFullSyll());  //what's this part? eek...
        }
        //syllableArray.add(tmpSylls);    //add pronunciation
        _stressedVowels[sz] = sv;
        _2DSyllables[sz] = _syllables;  //may not work...
        //println(tmp1);
        //println(_pronunciations);
        } /*catch(){ //catch null pointer exception and Not found...
          
        }*/finally {
         
         }
      }
    } //end of else
  }
  
  public Word getNext(int i){
   //println("getting next"); 
   if(_poem._lines[_line]._words.length > _loc+i){
    //println(_poem._lines[_line]._words[_loc+i]._displayWord); 
    return _poem._lines[_line]._words[_loc+i];
   } else {
    return null; 
   }
  }
  
  public Word getPrev(int i){
   if(_loc-i >=0){
    return _poem._lines[_line]._words[_loc-i];
   } else {
    return null; 
   }
  }

  /*void processProns(ArrayList<String> tmpArray){
   for (int sz = 0; sz < tmpArray.size(); sz++) {
   
   try {
   String tmp = tmpArray.get(sz).replaceAll("_", " ");
   String[] tmp0 = tmp.split(":");
   if (tmp0.length == 2) {
   _pronunciations = int(tmp0[1]);
   } 
   else {              
   _pronunciations = 0;
   }
   String tmp1 = tmp0[0];
   int sv = 0; //if something like and - will use first syllable
   analyzePhonemes(trim(tmp1));
   String[] sylls = tmp1.split("-");
   _syllables = new Syllable[sylls.length];
   //tmpSylls.clear();
   syllableArray.add(new ArrayList<Syllable>());
   for (int i =0; i < sylls.length; i++) {
   //println("Syll" + i + ": ");
   Syllable _syll = new Syllable(trim(sylls[i]), _pMap, i);
   if(_syll._stress.equals("1")){
   sv = i; 
   //find char in word.
   }
   _syllables[i] = _syll;
   syllableArray.get(syllableArray.size()-1).add(_syll);
   _syll.returnString(_syll.getFullSyll());  //what's this part? eek...
   }
   //syllableArray.add(tmpSylls);    //add pronunciation
   _stressedVowels[sz] = sv;
   _2DSyllables[sz] = _syllables;  //may not work...
   //println(tmp1);
   //println(_pronunciations);
   } finally {
   
   }
   }
   }*/

  /*ArrayList<String> isValid(String words){
   //check agrees with syllabified arphabet
   ArrayList<String> tmp = new ArrayList<String>(Arrays.asList(words.split(":"));
   return tmp;
   }*/

  public void analyzePhonemes(String word) {
    String s, stmp, punc;
    String[] p;
    //String Defs = "";

    if ( word.length() != 0 ) {
      /*if (_word.indexOf(".") == _word.length()-1 || _word.indexOf(",") == _word.length()-1 || _word.indexOf(";") == _word.length()-1
       || _word.indexOf(":") == _word.length()-1 || _word.indexOf("-") == _word.length()-1) {
       punc = _word.substring(_word.length()-1);
       s = _cmuMap.getFirstPhoneme( _word );
       } 
       else {
       s = _cmuMap.getFirstPhoneme( _word );
       }*/

      //s = RiTa.getPhonemes( _word );

      s = word;
      s = s.replaceAll("-", "");
      //println(s);
      p = splitTokens( s, " " );
      //println(p);
      _phonemes = new Phoneme[p.length];

      for ( int i = 0; i < p.length; i++ ) {
        //println(p[i]);
        _phonemes[i] = new Phoneme(p[i], _pMap);
        _phonetics += _phonemes[i]._ppv;
      }
    } else {
      _phonemes = null;
    }
  }

  public String getPhonetics(Phoneme[] tmp) {
    String tmpStr = "";
    for (int i = 0; i < tmp.length; i++) {
      tmpStr += tmp[i]._ppv;
    } 
    return tmpStr = "";
  }

  public String getWord() {
    return _word;
  }

  public String getDisplayWord() {
    return _displayWord;
  }

  public char[] getLetters() {
    return _letters;
  }

  public Syllable[] getSylls() {
    //return _syllables;
    if (pronNum < _2DSyllables.length) {
      return _2DSyllables[pronNum];
    } else { 
      return _2DSyllables[0];
    }
  }

  public int getStressedVowel() {
    if (pronNum < _stressedVowels.length) {
      return _stressedVowels[pronNum];
    } else { 
      return 0;
    }
  }

  public Syllable[] getSylls(int which) {
    //return _syllables;
    if (_2DSyllables.length > which) {
      return _2DSyllables[which-1];
    } else {
      return _2DSyllables[_2DSyllables.length - 1];
    }
  }

  public Syllable[] getSyllsFromArrayList(int which) {
    //return _syllables;
    if (syllableArray.size() > which) {
      return syllableArray.get(which-1).toArray(new Syllable[syllableArray.get(which-1).size()]);
    } else {
      return syllableArray.get(syllableArray.size()-1).toArray(new Syllable[syllableArray.get(syllableArray.size()-1).size()]);
    }
  }

  public int getPronunciations() {
    return _pronunciations;
  }

  public int getNumPhonemes() {
    return _phonemes.length;
  }

  public Phoneme getPhoneme( int i ) {
    return _phonemes[i];
  }

  public boolean doesPhonemeExistInWord( String p ) {
    for ( int i = 0; i < _phonemes.length; i++ ) {
      if ( _phonemes[i].getPhoneme().equalsIgnoreCase(p) ) return true;
    }
    return false;
  }


  public String printWrd() {
    String str = "";
    for (int i = 0; i < _syllables.length; i++) {
      if (i > 0)
        str += " - ";
      str += _syllables[i].returnString(_syllables[i].getFullSyll());
    }
    return str + " (" + _pronunciations + ") ";
  }

  public void hover() {
    if (mouseX >= (_x+31) && mouseX <= _x+textWidth(_displayWord+31) && mouseY >= (_y-20+35) && mouseY <= (_y+20+45)) {
      hover = true;
    } else {
      hover = false;
    }
  }

  public void select() {
    if (mouseX >= (_x+31) && mouseX <= _x+textWidth(_displayWord+31) && mouseY >= (_y-20+35) && mouseY <= (_y+20+45)) {
      selected = -selected;
    }
  }
}


//---------------------//
//
class Phoneme {
  char _type; //c: consonant, v: vowel 
  String _voice;
  String _place; //bilabial, labio-dental, lingua-dental, lingua-alveolar, lingua-palatal, lingua-velar, glottal 
  String _chars; //actual letters
  String _phone; //liquid, fricative, etc...
  String _stress; //0, 1, 2 (none, primary, secondary). only for vowell
  //add things like mouth placement, length, pitch, etc later... 
  String _vlength;
  String _phoneme;
  String _ppv = "";
  String _Pp = ""; //manner and place
  String _Pv = ""; //manner and voice
  String _pv = ""; //place and voice

  String[] mpv = new String[3];

  //String m = ""; //manner
  //String p = ""; //place
  //String v = ""; //voice



  /*Phoneme( String p) {
   _phoneme = p;
   }*/

  Phoneme(String _phoneme, pMap _pMap) { 
    //println("Constructing phoneme");
    if (_phoneme.indexOf("0") != -1 || _phoneme.indexOf("2") != -1 || _phoneme.indexOf("1") != -1 ) {
      _stress = _phoneme.substring(_phoneme.length() - 1);
      //println(_stress); 
      _phoneme = _phoneme.substring(0, _phoneme.length() - 1);
      //println(_phoneme);
    }

    _chars = _phoneme;
    //println("Phoneme:"+_phoneme);
    String[] tmp = split(_pMap.getPhone(_phoneme), ":");
    //_phone = _pMap.getPhone(_phoneme);
    _phone = tmp[0];

    //get type
    if ( _phone.equals("vowel") || _phone.equals("V")) {
      _type = 'v';
      _vlength = tmp[3];
    } else {
      _type = 'c';
    }

    if (tmp.length >= 3) {
      _voice = tmp[1];
      _place = tmp[2];
    }

    _ppv = _phone + _voice + _place;
    _Pp = _phone + _place;
    _Pv = _phone + _voice;
    _pv = _place + _voice;
    mpv[0] = _phone;
    mpv[1] = _place;
    mpv[2] = _voice;


    //println("chars: " + _chars);
    //println("phone: " + _phone);
    //println("type: " + _type);
    //println("stress: " + _stress);
  }

  public char getType() {
    return _type;
  }
  public String getChars() {
    return _chars;
  }
  public String getPhone() {
    return _phone;
  }
  public String getStress() {
    return _stress;
  }
  public String getPhoneme() {
    return _chars;
  }
}


//---------------------//
//syllable class
class Syllable {
  int _index;        //syll # in word
  String _stress;       //passed from nucleus
  int nIndex = 0;       //array index of the nucleus. 
  Phoneme[] _onset = new Phoneme[0];
  Phoneme _nucleus;
  Phoneme[] _coda = new Phoneme[0];
  Phoneme[] _fullSyll = new Phoneme[0];
  String _phonetics = "";
  String _codaPpv = "";
  String _onsetPpv = "";
  String _nucleusPpv = "";
  String _codaPv = "";
  String _onsetPv = "";
  String _nucleusPv = "";
  String _codaPp = "";
  String _onsetPp = "";
  String _nucleusPp = "";
  String _codapv = "";
  String _onsetpv = "";
  String _nucleuspv = "";
  String _syllString = "";

  //constructor
  Syllable(String _syllable, pMap _pMap, int _ind) {
    _syllString = _syllable;
    _index = _ind;
    String[] tmp = split(_syllable, " ");
    for (int i = 0; i < tmp.length; i++) {      //create and fill phoneme vec
      //_fullSyll = new phoneme[tmp.length];
      Phoneme _phoneme = new Phoneme(tmp[i], _pMap);
      _fullSyll = (Phoneme[])append(_fullSyll, _phoneme);
      if (nIndex == 1) {
        _coda = (Phoneme[])append(_coda, _phoneme);
        _codaPpv += _phoneme._ppv;
        _codaPp += _phoneme._Pp;
        _codaPv += _phoneme._Pv;
        _codapv += _phoneme._pv;

        //println("coda: "+ _phoneme.getChars());
      }
      if (_phoneme.getType() == 'v') {
        _nucleus = _phoneme;
        _nucleusPpv = _phoneme._ppv;
        _nucleusPv = _phoneme._Pv;
        _nucleusPp = _phoneme._Pp;
        _nucleuspv = _phoneme._pv;
        _stress = _phoneme.getStress();
        //println("nucleus: " + _phoneme.getChars());
        //println("stress: " + _stress);
        nIndex = 1;
      }
      if (nIndex == 0) {
        _onset = (Phoneme[])append(_onset, _phoneme);
        _onsetPpv += _phoneme._ppv;
        _onsetPv += _phoneme._Pv;
        _onsetPp += _phoneme._Pp;
        _onsetpv += _phoneme._pv;
        //println("Onset: " + _phoneme.getChars());
      }
    }
  }

  public Phoneme[] getFullSyll() {
    return _fullSyll;
  }
  public Phoneme[] getOnset() {
    return _onset;
  }

  public String getFullSyllStr() {
    return returnString(_fullSyll);
  }

  public String getOnsetStruct(String parts) {
    String res = "";
    for (int i = 0; i < _onset.length; i++) {
      for (int j = 0; j < parts.length (); j++) {
        int p = (parts.charAt(j) == 'm') ? 0 : (parts.charAt(j) == 'p') ? 1 : 2 ;
        res += ""+_onset[i].mpv[p];
      }
    }
    return res.replaceAll(" ", "");
  }

  public String getNucleusStruct(String parts) {
    String res = "";
    for (int j = 0; j < parts.length (); j++) {
      int p = (parts.charAt(j) == 'm') ? 0 : (parts.charAt(j) == 'p') ? 1 : 2 ;
      res += ""+_nucleus.mpv[p];
    }
    return res.replaceAll(" ", "");
  }

  public String getCodaStruct(String parts) {
    String res = "";
    for (int i = 0; i < _coda.length; i++) {
      for (int j = 0; j < parts.length (); j++) {
        int p = (parts.charAt(j) == 'm') ? 0 : (parts.charAt(j) == 'p') ? 1 : 2 ;
        res += ""+_coda[i].mpv[p];
      }
    }
    return res.replaceAll(" ", "");
  }

  public Phoneme getLeadingOnset() {
    return _onset[0];
  }

  public Phoneme[] getCoda() {
    return _coda;
  }
  public Phoneme getNucleus() {
    return _nucleus;
  }
  public String getStress() {
    return _stress;
  }
  public int getIndex() {
    return _index;
  }
  public String returnString(Phoneme[] _phonemeArray) {
    String str = "";
    for (int i = 0; i < _phonemeArray.length; i++) {
      str += _phonemeArray[i].getChars() + "";  //spacing between chars...
    }
    //println(str);
    return str;
  }

  public String returnStringsp(Phoneme[] _phonemeArray) {
    String str = "";
    for (int i = 0; i < _phonemeArray.length; i++) {
      if (i > 0) {
        str += " ";
      }
      str += _phonemeArray[i].getChars() + "";  //spacing between phonemes...
      if (_phonemeArray[i] == _nucleus) {
        str += _stress;
      }
    }
    //println(str);
    return str;
  }

  public String returnString(Phoneme _phoneme) {
    return ""+_phoneme.getChars();
  }
}

public ArrayList<String> getPermutations(ArrayList< ArrayList<String> > data){
 ArrayList<String> prev = new ArrayList<String>(); 
 ArrayList<String> res = new ArrayList<String>(); 
 ArrayList<String> res2 = new ArrayList<String>(); 
 if(data.size() == 0){
   return res;
 }
 prev = data.get(0);
 if(data.size() == 1){
   res2.clear();
 for(int i = 0; i < data.get(0).size(); i++){  
  String[] check = split(data.get(0).get(i), "_");
  int freq = Collections.frequency(Arrays.asList(check), "null");
  if((PApplet.parseFloat(freq)/PApplet.parseFloat(check.length)) >= 0.5f){
        //take out
  }else{
    res2.add(data.get(0).get(i));
  }
 }
 return res2;
 }
 for(int a = 0; a < data.size()-1; a++){ //through rows
 res.clear(); 
 //println(a+":"+prev);
      for(int b = 0; b < prev.size(); b++){ //through colums
        for(int c = 0; c < data.get(a+1).size(); c++){
          res.add(prev.get(b)+"_"+data.get(a+1).get(c));
          //println(res);
          //need to make sure not too many nulls
        }
      }
     //println(res);
     prev.clear();
     prev.addAll(res);
    }
    res2.clear();
    for(int i = 0; i < res.size(); i++){
      String[] check = split(res.get(i), "_");
      int freq = Collections.frequency(Arrays.asList(check), "null");
      if((PApplet.parseFloat(freq)/PApplet.parseFloat(check.length)) >= 0.5f){
        //take out
      }else{
        /*if(combineRules){
        res2.add(res.get(i));
        }else{
        res2.add(res.get(i).replaceAll("_",""));
        }*/
        res2.add(res.get(i).replaceAll("_",""));
      }
    }
   //println(res); 
 return res2; 
}

//////////////////////Rhyme with rules 2///////////////////////////////////////

public ArrayList<String> rhymePairRule2(Word _wrd1, Word _wrd2, rhymerule _rule, int w1num, int w2num, boolean isbimatch) {
  int comments = 1;

  Syllable[] syll1, syll2; 
  String onset1, nucleus1, coda1, onset2, nucleus2, coda2, stress1, stress2, next1, next2, nextOnset1, nextOnset2, combined1, combined2, leadingOnset1, leadingOnset2;
  //String[] rhyme = new String[0];
  
 ArrayList<String> rhyme = new ArrayList<String>();
 
 if(_rule.bimatch){ 
   if(_rule.crossWrd > 0){
     if(_wrd1.getNext(_rule.crossWrd) == null){
       println("nope");
        return rhyme;
      }
    }
    if(_rule.bcrossWrd > 0){
      if(_wrd2.getNext(_rule.bcrossWrd) == null){
        println("nope");
        return rhyme;
      }
    }
 }else{
   if(_rule.crossWrd > 0){
      if(_wrd1.getNext(_rule.crossWrd) == null || _wrd2.getNext(_rule.crossWrd) == null){
        println("nope");
        return rhyme;
      }
    }
 }
 
 //check for enough words
 /*if(isbimatch){
   if(_rule.crossWrd > 0){
     if(_wrd1.getNext(_rule.crossWrd) == null){
       println("nope");
        return rhyme;
      }
    }
    if(_rule.bcrossWrd > 0){
      if(_wrd2.getNext(_rule.bcrossWrd) == null){
        println("nope");
        return rhyme;
      }
    }
  }else{
    if(_rule.crossWrd > 0){
      if(_wrd1.getNext(_rule.crossWrd) == null || _wrd2.getNext(_rule.crossWrd) == null){
        println("nope");
        return rhyme;
      }
    }
  }*/
  ////////////

  String str1 = new String(_wrd1.getLetters());
  String str2 = new String(_wrd2.getLetters());

  char[] wrd1 = _wrd1.getLetters();
  char[] wrd2 = _wrd2.getLetters();
  
  syll1 = _wrd1.getSylls();
  syll2 = _wrd2.getSylls();

  int s1 = syll1.length;
  int s2 = syll2.length;
  int comLength = (s1 <= s2) ? s1 : s2;
  int loc1, loc2, num1, num2; //locations of syllable in words

  //println("to work with " + _rule.strRule);

  ArrayList< ArrayList<String>> matching1 = new ArrayList< ArrayList<String>>();
  ArrayList< ArrayList<String>> matching2 = new ArrayList< ArrayList<String>>();
  ArrayList< ArrayList<String>> matching1b = new ArrayList< ArrayList<String>>();
  ArrayList< ArrayList<String>> matching2b = new ArrayList< ArrayList<String>>();
  ArrayList< ArrayList<String>> perms = new ArrayList< ArrayList<String>>();
  ArrayList<String> permRes = new ArrayList<String>();
  ArrayList< ArrayList<String>> common = new ArrayList< ArrayList<String>>();
  ArrayList<String> tmp = new ArrayList<String>();
  ArrayList<String> tmp2 = new ArrayList<String>();
  ArrayList<String> tmp3 = new ArrayList<String>();
  ArrayList<String> tmp4 = new ArrayList<String>();
  
  ArrayList<String> commonRules = new ArrayList<String>();
  
  if(comment){
  println("checking "+str1+"/"+str2);
  }

     //println("match size "+_rule.matches.size());
     if(comment){
     println(str1);
     }
     tmp = _rule.getMatches(syll1,wrd1,1,w1num,isbimatch, _wrd1);
     for(int i = 0; i < tmp.size(); i++){
       tmp.set(i,tmp.get(i).replaceAll("_null_", ""));
     }
     
     if(isbimatch){
     ArrayList<String> res2 = rhymePairRuleSingle(_wrd1, _rule, w1num, true);
     //ArrayList<String> res1 = rhymePairRuleSingle(_wrd1, _rule, w1num, false);
     println("A: "+tmp);
     println("B: "+res2);
     }
     
     tmp3 = tmp;
     if(comment){
     println(str2);
     }
     tmp2 = _rule.getMatches(syll2,wrd2,2,w2num,isbimatch, _wrd2);
     for(int i = 0; i < tmp2.size(); i++){
       tmp2.set(i,tmp2.get(i).replaceAll("_null_", ""));
     }
     
     tmp4 = tmp2;
     
     tmp.retainAll(tmp2);
     
     tmp2.clear();
     for(int it = 0; it < tmp.size(); it++){
      if(tmp.get(it).length() > 0 && !tmp2.contains(tmp.get(it))){
       tmp2.add(tmp.get(it)); 
      }
     }
     if(comment){
     println("matches: "+tmp2 + _rule.noMatch);
     }
     //println("matches: "+tmp2 + _rule.noMatch);
     
     if(tmp2.size() == 0 && _rule.noMatch){
      tmp2.add("noMatch"); 
     }else if(tmp2.size() > 0 && _rule.noMatch){
      tmp2.clear(); 
     }
     
     if(tmp2.size() > 0){
       if(isbimatch){
      _wrd1.currBiMatch = tmp3;
      _wrd2.currBiMatch = tmp4;
       }else{
      _wrd1.currRes = tmp3;
      _wrd2.currRes = tmp4;
       } 
     }
     
    rhyme = tmp2;
  
  return rhyme;
}


public ArrayList<String> rhymePairRuleC(ArrayList<String> res, Word _wrd1, Word _wrd2, rhymerule _rule, int w1num, int w2num, boolean isbimatch) {
  

  int comments = 1;

  Syllable[] syll1, syll2; 
  String onset1, nucleus1, coda1, onset2, nucleus2, coda2, stress1, stress2, next1, next2, nextOnset1, nextOnset2, combined1, combined2, leadingOnset1, leadingOnset2;
  //String[] rhyme = new String[0];
  
 ArrayList<String> rhyme = new ArrayList<String>();

  String str1 = new String(_wrd1.getLetters());
  String str2 = new String(_wrd2.getLetters());

  char[] wrd1 = _wrd1.getLetters();
  char[] wrd2 = _wrd2.getLetters();
  
  syll1 = _wrd1.getSylls();
  syll2 = _wrd2.getSylls();

  int s1 = syll1.length;
  int s2 = syll2.length;
  int comLength = (s1 <= s2) ? s1 : s2;
  int loc1, loc2, num1, num2; //locations of syllable in words

  //println("to work with " + _rule.strRule);

  ArrayList< ArrayList<String>> matching1 = new ArrayList< ArrayList<String>>();
  ArrayList< ArrayList<String>> matching2 = new ArrayList< ArrayList<String>>();
  ArrayList< ArrayList<String>> matching1b = new ArrayList< ArrayList<String>>();
  ArrayList< ArrayList<String>> matching2b = new ArrayList< ArrayList<String>>();
  ArrayList< ArrayList<String>> perms = new ArrayList< ArrayList<String>>();
  ArrayList<String> permRes = new ArrayList<String>();
  ArrayList< ArrayList<String>> common = new ArrayList< ArrayList<String>>();
  ArrayList<String> tmp = new ArrayList<String>();
  ArrayList<String> tmp2 = new ArrayList<String>();
  ArrayList<String> tmp3 = new ArrayList<String>();
  ArrayList<String> tmp4 = new ArrayList<String>();
  
  ArrayList<String> commonRules = new ArrayList<String>();
  
  if(comment){
  println("checking "+str1+"/"+str2);
  }

     //println("match size "+_rule.matches.size());
     if(comment){
     println(str1);
     }
     
     //tmp = _rule.getMatches(syll1,wrd1,1,w1num,isbimatch, _wrd1);
     tmp = rhymePairRuleSingle(_wrd1, _rule, w1num, false);
     
     for(int i = 0; i < tmp.size(); i++){
       tmp.set(i,tmp.get(i).replaceAll("_null_", ""));
     }
     
     //ArrayList<String> res1 = rhymePairRuleSingle(_wrd1, _rule, w1num, false);
     //println("A: "+tmp);
     //println("B: "+res1);
     
     tmp3 = tmp;
     if(comment){
     println(str2);
     }
     tmp2 = _rule.getMatches(syll2,wrd2,2,w2num,isbimatch, _wrd2);
     for(int i = 0; i < tmp2.size(); i++){
       tmp2.set(i,tmp2.get(i).replaceAll("_null_", ""));
     }
     
     tmp4 = tmp2;
     
     tmp.retainAll(tmp2);
     
     tmp2.clear();
     for(int it = 0; it < tmp.size(); it++){
      if(tmp.get(it).length() > 0 && !tmp2.contains(tmp.get(it))){
       tmp2.add(tmp.get(it)); 
      }
     }
     if(comment){
     println("matches: "+tmp2 + _rule.noMatch);
     }
     if(tmp2.size() == 0 && _rule.noMatch){
      tmp2.add("noMatch"); 
     }else if(tmp2.size() > 0 && _rule.noMatch){
      tmp2.clear(); 
     }
     
     if(tmp2.size() > 0){
       if(isbimatch){
      _wrd1.currBiMatch = tmp3;
      _wrd2.currBiMatch = tmp4;
       }else{
      _wrd1.currRes = tmp3;
      _wrd2.currRes = tmp4;
       } 
     }
     
    rhyme = tmp2;
  
  return rhyme;
}


public ArrayList<String> rhymePairRuleB(ArrayList<String> res, Word _wrd1, Word _wrd2, rhymerule _rule, int w2num, boolean isbimatch) {
  int comments = 1;
  Syllable[] syll1, syll2; 

  ArrayList<String> rhyme = new ArrayList<String>();
  String str2 = new String(_wrd2.getLetters());
  char[] wrd2 = _wrd2.getLetters();
  syll2 = _wrd2.getSylls();
  int s2 = syll2.length;
  int loc1, loc2, num1, num2; //locations of syllable in words
  ArrayList<String> tmp2 = new ArrayList<String>();
  ArrayList<String> tmp3 = new ArrayList<String>();
  ArrayList<String> tmp4 = new ArrayList<String>();
  
  ArrayList<String> commonRules = new ArrayList<String>();
     
  tmp3.addAll(res);
  
  if(comment){
    println(str2);
  }
     if(isbimatch){
       tmp2 = _rule.getMatches(syll2,wrd2,1,w2num,isbimatch, _wrd2);
     }else{
       tmp2 = _rule.getMatches(syll2,wrd2,2,w2num,isbimatch, _wrd2);
     }
     for(int i = 0; i < tmp2.size(); i++){
       tmp2.set(i,tmp2.get(i).replaceAll("_null_", ""));
     }    
     
     /*if(res.size() > 0){
     println("1: "+res);
     println("2: "+tmp2);
     }*/
     
     tmp4 = tmp2; 
     tmp3.retainAll(tmp2); 
     tmp2.clear();
     for(int it = 0; it < tmp3.size(); it++){
      if(tmp3.get(it).length() > 0 && !tmp2.contains(tmp3.get(it))){
       tmp2.add(tmp3.get(it)); 
      }
     }
     if(comment){
     println("matches: "+tmp2 + _rule.noMatch);
     }
     if(tmp2.size() == 0 && _rule.noMatch){
      tmp2.add("noMatch"); 
     }else if(tmp2.size() > 0 && _rule.noMatch){
      tmp2.clear(); 
     }
     
     if(tmp2.size() > 0){
       if(isbimatch){
      _wrd1.currBiMatch = tmp3;
      _wrd2.currBiMatch = tmp4;
       }else{
      _wrd1.currRes = tmp3;
      _wrd2.currRes = tmp4;
       } 
     }
     
    rhyme = tmp2;
  return rhyme;
}

public ArrayList<String> rhymePairRuleSingle(Word _wrd1, rhymerule _rule, int w1num, boolean isbimatch) {
  int comments = 1;
  Syllable[] syll1, syll2;   
  ArrayList<String> rhyme = new ArrayList<String>();
  String str1 = new String(_wrd1.getLetters());
  char[] wrd1 = _wrd1.getLetters();
  syll1 = _wrd1.getSylls();

  int s1 = syll1.length;
  int loc1, loc2, num1, num2; //locations of syllable in words

  ArrayList<String> tmp = new ArrayList<String>();  
  if(comment){
  println("checking "+str1);
  }
  
     if(comment){
     println(str1);
     }
     if(isbimatch){
       tmp = _rule.getMatches(syll1,wrd1,2,w1num,isbimatch, _wrd1);
     }else{
       tmp = _rule.getMatches(syll1,wrd1,1,w1num,isbimatch, _wrd1);
     }
     for(int i = 0; i < tmp.size(); i++){
       tmp.set(i,tmp.get(i).replaceAll("_null_", ""));
     }
    rhyme = tmp;
  return rhyme;
}



//old material
///////////////////////////////RHYMING FUNCTIONS/////////////////////////////////

public String reverseString(String str) {
  char[] chars = new char[str.length()];
  for (int i = 0; i < str.length (); i++) {
    chars[i] = str.charAt(i);
  }
  chars = reverse(chars);
  String str2 = new String(chars);
  return str2;
}
class TextView {

  int _width, _height;
  int _title_author_y, _poem_y;
  int _phoneme_offset, _histogram_offset, _poem_width;
  int _view_offset;
  float longest_line;
  //int[] exp = new int[Experiments.length];
  int graphx = 800;
  int graphy = 20;
  int numNodes = 0;

  //lev distance
  //DamerauLevenshteinAlgorithm DLs;

  PFont _line_font, _line_fontb, _phoneme_line_font;

  //ArrayList< ArrayList<Set> > RhymeSets = new ArrayList< ArrayList<Set> >();  

  TextView() { 
    _line_font = _georgia_14;
    _line_fontb = _georgia_14b;
    _phoneme_line_font = _clairhand_14;

    _title_author_y = 0;
    _poem_y = 24 + 16 + 30;

    _view_offset = 40;

    /*Word test = new Word("end",1);
     Word test2 = new Word("bend",1);
     
     println(rhymePairStr(test2, test, 1));*/
    //println(charCluster(test2, test, 3));

    //compute title length
    textFont( _georgia_24b );
    int title_l = (int)textWidth(_poem.getTitle());

    // compute the length of the longest line (bad approximation!)
    textFont( _line_font );
    int c_l = (int)textWidth( "s" );

    //_phoneme_offset = c_l*_longest_line_length + _view_offset;
    _phoneme_offset = (c_l*_longest_line_length > title_l) ? c_l*_longest_line_length + _view_offset : title_l + _view_offset; 
    _poem_width = c_l*_longest_line_length + _view_offset;
    _histogram_offset = _phoneme_offset*2;
  }

  // this is called when the window size changes
  public void setDimensions( int w, int h ) {
    _width = w;
    _height = h;
  }


  public void findRhymes() {
    ArrayList<Set> combined = new ArrayList<Set>();
    RhymeSets.clear();
    if (combineRules) {
      RhymeSets.add(new ArrayList<Set>()); //add new array of rhyme sets
      //println("Ok...");
      renderCombinedRhymes();
    } else {
      for (int i = 0; i < rules.size (); i++) {
        RhymeSets.add(new ArrayList<Set>()); //add new array of rhyme sets
        renderRhymes(rules.get(i), i);
      }
    }
  }

  ////////////////////find rhymesets////////////////
  public void renderRhymes(rhymerule _rule, int ruleNum) {
    int start;
    boolean first;
    ArrayList<Integer> sets = new ArrayList<Integer>();
    ArrayList<String> res1;

    Line l, m;
    Word[] words, words2;

    for ( int k = 0; k < _poem.getNumLines (); k++ ) {  //looping through lines. 

      l = _poem.getLine(k);
      words = l.getWords();

      currWords1 = words; //for cross words

        for (int i = 0; i < words.length; i++) {
        if (words[i]._exists == false || words[i].isWord == false) {
          continue;
        }

        first = true;
        boolean duplicate = false;
        

        for ( int h = k; h < _poem.getNumLines (); h++ ) {      //looping through all other words after word[i]
          m = _poem.getLine(h);

          words2 = m.getWords();

          currWords2 = words2; //for crossWords

          if (h==k) {
            start = i+1;
          } else {
            start = 0;
          } 
          for (int j = start; j < words2.length; j++) { 
            if (words2[j]._exists == false || words2[j].isWord == false) {
              continue;
            }
            //detect rhyme
            /*if(combineRules){ //make more efficient
             int cont = 0;
             String seg = "";
             for (int ru = 0; ru < rules.size (); ru++) { //if any don't have matches, move to next...
             ArrayList<String> result2 = rhymePairRule(words[i], words2[j], rules.get(ru));
             if(result2.size() == 0){
             cont = 1; 
             } //fix this! make combined sets...
             }
             if(cont == 1){
             continue;
             } 
             }*/

            ArrayList<String> result = rhymePairRule2(words[i], words2[j], _rule, i, j, false);
            //println("res: "+result);
            if (_rule.bimatch) {
              result.addAll(rhymePairRule2(words2[j],words[i], _rule, i, j, true));
              //result.addAll(rhymePairRule2(words2[j], words[i], _rule, j, i, true)); //if bimatch - try other direction - may need to do this regardless
            }
            if (result.size() == 0) { //no match - move to next word
              continue;
            }
            //println("what we're working with... "+result);
            //println(result);
            for (int ii = 0; ii < result.size (); ii++) { //loop through all poss matches
              duplicate = false;
              int set = 100000;
              //check to see if rhyme alread exists, in which case, add to existing. Otherwise...
              for (int n = 0; n < RhymeSets.get (ruleNum).size(); n++) {
                if (result.get(ii).equals(RhymeSets.get(ruleNum).get(n)._rhymeId)) {
                  //println("yep!");
                  //&& RhymeSets.get(ruleNum).get(n)._wrds.get(0) == words[i]
                  //check each rhyme independently
                  int f = 0;
                  /*ArrayList<String> res4 = new ArrayList<String>();
                  for (int mm = 0; mm < RhymeSets.get (ruleNum).get(n)._wrds.size(); mm++) {
                  res4.clear();
                  res4.addAll(words[i].currRes);
                  res4.retainAll(RhymeSets.get(ruleNum).get(n)._wrds.get(mm).currRes); //this wont quite work
                  if(res4.size() == 0 && _rule.bimatch){
                    res4.clear();
                    res4.addAll(words[i].currRes);
                    res4.retainAll(RhymeSets.get(ruleNum).get(n)._wrds.get(mm).currRes); //this wont quite work
                    }
                    
                    if((res4.size() > 0 && !_rule.noMatch) || (res4.size() == 0 && _rule.noMatch)){
                      
                    }else{
                      f++;
                    }  
                    
                  }*/
                  if(_rule.bimatch || _rule.noMatch){
                  ArrayList<String> result2 = new ArrayList<String>();
                  ArrayList<String> result3 = new ArrayList<String>();
                  for (int mm = 0; mm < RhymeSets.get (ruleNum).get(n)._wrds.size(); mm++) {
                    //println(mm);
                    if(words[i] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                    result2.add("equals");
                    result3 = rhymePairRule2(words2[j], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    //println("res3: "+result3);
                    }else if(words2[j] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                    result3.add("equals");  
                    result2 = rhymePairRule2(words[i], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    //println("res2: "+result2);
                    }else{
                      result2 = rhymePairRule2(words[i], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                      result3 = rhymePairRule2(words2[j], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    }
                    if (_rule.bimatch) {
                      if(words[i] != RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                      result2.addAll(rhymePairRule2(RhymeSets.get(ruleNum).get(n)._wrds.get(mm), words[i], _rule, j, i, true)); //if bimatch - try other direction - may need to do this regardless
                      }
                      if(words2[j] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                      result3.addAll(rhymePairRule2(RhymeSets.get(ruleNum).get(n)._wrds.get(mm), words2[j], _rule, j, i, true));  
                      }
                    }
                    if (result2.size() == 0 || result3.size() == 0) {
                      //println("rs: "+result2.size()+" r3: "+result3.size());
                      f++;
                    }
                    result2.clear();
                    result3.clear();
                    //println("f: "+f);
                  }
                  }
                  if(f > 0){
                    duplicate = false; 
                  }else{
                    duplicate = true;
                    set = n; 
                  }
                }
              }
              //duplicate = false;
              if (duplicate == false) {  //create new rhyme set
                //println("new set!");
                Set _set = new Set(ruleNum);
                _set._setIds.add(words[i].wrdcount);
                _set._setIds.add(words2[j].wrdcount);
                _set._wrds.add(words[i]);
                _set._wrds.add(words2[j]);
                ///*":"+words[i].pronNum+*//*":"+words2[j].pronNum+*/
                _set._words.add(words[i].getDisplayWord()+"("+words[i].wrdcount+")");
                _set._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                _set._rhymeId = result.get(ii);
                _set._crossWrd = _rule.crossWrd;
                RhymeSets.get(ruleNum).add(_set);
              } else if (duplicate == true && set != 100000) {
                boolean dup1 = false;
                boolean dup2 = false;
                int num = 10000;
                for (int it = 0; it < RhymeSets.get (ruleNum).get(set)._setIds.size(); it++) {
                  if (words[i].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup1 = true;
                  } else if (words2[j].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup2 = true; 
                    num = it;
                  }
                  //num = it;
                  //println("duplicate!");
                }
                if (dup1 == false && num != 10000) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(num, words[i].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(num, words[i].getDisplayWord()+"("+words[i].wrdcount+")"); 
                  RhymeSets.get(ruleNum).get(set)._wrds.add(num, words[i]);
                }
                if (dup2 ==  false) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(words2[j].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                  RhymeSets.get(ruleNum).get(set)._wrds.add(words2[j]);
                }
              }
            }//for (ii)
          }
        }
      }
    }
   // combineSets(ruleNum);
  }
  
  public void renderRhymesB(rhymerule _rule, int ruleNum) {
    int start;
    boolean first;
    ArrayList<Integer> sets = new ArrayList<Integer>();
    ArrayList<String> res1 = new ArrayList<String>();
    ArrayList<String> resB = new ArrayList<String>();

    Line l, m;
    Word[] words, words2;

    for ( int k = 0; k < _poem.getNumLines (); k++ ) {  //looping through lines. 

      l = _poem.getLine(k);
      words = l.getWords();

      currWords1 = words; //for cross words

        for (int i = 0; i < words.length; i++) {
        if (words[i]._exists == false || words[i].isWord == false) {
          continue;
        }

        first = true;
        boolean duplicate = false;
        res1 = rhymePairRuleSingle(words[i], _rule, i, false);
        if(_rule.bimatch){
        resB = rhymePairRuleSingle(words[i], _rule, i, true);
        }

        for ( int h = k; h < _poem.getNumLines (); h++ ) {      //looping through all other words after word[i]
          m = _poem.getLine(h);

          words2 = m.getWords();

          currWords2 = words2; //for crossWords

          if (h==k) {
            start = i+1;
          } else {
            start = 0;
          } 
          
          for (int j = start; j < words2.length; j++) { 
            if (words2[j]._exists == false || words2[j].isWord == false) {
              continue;
            }
            
            
            res1 = rhymePairRuleSingle(words[i], _rule, i, false);
            //ArrayList<String> result = rhymePairRuleC(res1, words[i], words2[j], _rule, i, j, false);
            //res1 = rhymePairRuleSingle(words[i], _rule, i, false);  
            ArrayList<String> result = rhymePairRuleB(res1, words[i], words2[j], _rule, j, false);
            if (_rule.bimatch) {
              result.addAll(rhymePairRule2(words2[j], words[i], _rule, j, i, true));
             // result.addAll(rhymePairRuleB(resB, words[i], words2[j], _rule, j, true)); //if bimatch - try other direction - may need to do this regardless
            }
            if (result.size() == 0) { //no match - move to next word
              continue;
            }
            //println("what we're working with... "+result);
            //println(result);
            for (int ii = 0; ii < result.size (); ii++) { //loop through all poss matches
              duplicate = false;
              int set = 100000;
              //check to see if rhyme alread exists, in which case, add to existing. Otherwise...
              for (int n = 0; n < RhymeSets.get (ruleNum).size(); n++) {
                if (result.get(ii).equals(RhymeSets.get(ruleNum).get(n)._rhymeId)) {
                  //println("yep!");
                  //&& RhymeSets.get(ruleNum).get(n)._wrds.get(0) == words[i]
                  //check each rhyme independently
                  int f = 0;
                  /*ArrayList<String> res4 = new ArrayList<String>();
                  for (int mm = 0; mm < RhymeSets.get (ruleNum).get(n)._wrds.size(); mm++) {
                  res4.clear();
                  res4.addAll(words[i].currRes);
                  res4.retainAll(RhymeSets.get(ruleNum).get(n)._wrds.get(mm).currRes); //this wont quite work
                  if(res4.size() == 0 && _rule.bimatch){
                    res4.clear();
                    res4.addAll(words[i].currRes);
                    res4.retainAll(RhymeSets.get(ruleNum).get(n)._wrds.get(mm).currRes); //this wont quite work
                    }
                    
                    if((res4.size() > 0 && !_rule.noMatch) || (res4.size() == 0 && _rule.noMatch)){
                      
                    }else{
                      f++;
                    }  
                    
                  }*/
                  if(_rule.bimatch || _rule.noMatch){
                  ArrayList<String> result2 = new ArrayList<String>();
                  ArrayList<String> result3 = new ArrayList<String>();
                  for (int mm = 0; mm < RhymeSets.get (ruleNum).get(n)._wrds.size(); mm++) {
                    //println(mm);
                    if(words[i] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                    result2.add("equals");
                    result3 = rhymePairRule2(words2[j], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    //println("res3: "+result3);
                    }else if(words2[j] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                    result3.add("equals");  
                    result2 = rhymePairRule2(words[i], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    //println("res2: "+result2);
                    }else{
                      result2 = rhymePairRule2(words[i], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                      result3 = rhymePairRule2(words2[j], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    }
                    if (_rule.bimatch) {
                      if(words[i] != RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                      result2.addAll(rhymePairRule2(RhymeSets.get(ruleNum).get(n)._wrds.get(mm), words[i], _rule, j, i, true)); //if bimatch - try other direction - may need to do this regardless
                      }
                      if(words2[j] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                      result3.addAll(rhymePairRule2(RhymeSets.get(ruleNum).get(n)._wrds.get(mm), words2[j], _rule, j, i, true));  
                      }
                    }
                    if (result2.size() == 0 || result3.size() == 0) {
                      //println("rs: "+result2.size()+" r3: "+result3.size());
                      f++;
                    }
                    result2.clear();
                    result3.clear();
                    //println("f: "+f);
                  }
                  }
                  if(f > 0){
                    duplicate = false; 
                  }else{
                    duplicate = true;
                    set = n; 
                  }
                }
              }
              //duplicate = false;
              if (duplicate == false) {  //create new rhyme set
                //println("new set!");
                Set _set = new Set(ruleNum);
                _set._setIds.add(words[i].wrdcount);
                _set._setIds.add(words2[j].wrdcount);
                _set._wrds.add(words[i]);
                _set._wrds.add(words2[j]);
                ///*":"+words[i].pronNum+*//*":"+words2[j].pronNum+*/
                _set._words.add(words[i].getDisplayWord()+"("+words[i].wrdcount+")");
                _set._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                _set._rhymeId = result.get(ii);
                _set._crossWrd = _rule.crossWrd;
                RhymeSets.get(ruleNum).add(_set);
              } else if (duplicate == true && set != 100000) {
                boolean dup1 = false;
                boolean dup2 = false;
                int num = 10000;
                for (int it = 0; it < RhymeSets.get (ruleNum).get(set)._setIds.size(); it++) {
                  if (words[i].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup1 = true;
                  } else if (words2[j].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup2 = true; 
                    num = it;
                  }
                  //num = it;
                  //println("duplicate!");
                }
                if (dup1 == false && num != 10000) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(num, words[i].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(num, words[i].getDisplayWord()+"("+words[i].wrdcount+")"); 
                  RhymeSets.get(ruleNum).get(set)._wrds.add(num, words[i]);
                }
                if (dup2 ==  false) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(words2[j].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                  RhymeSets.get(ruleNum).get(set)._wrds.add(words2[j]);
                }
              }
            }//for (ii)
          }
        }
      }
    }
   // combineSets(ruleNum);
  }
  
  public void combineSets(int rNum){
   //sort alphabetically
   Collections.sort(RhymeSets.get(rNum), new setComparable2());
   /*for(int i = 0; i < RhymeSets.get(rNum).size(); i++){
    Set tmp = RhymeSets.get(rNum).get(i);
    while(tmp._rhymeId.equals(RhymeSets.get(rNum).get(i)._rhymeId) && i < RhymeSets.get(rNum).size()){
    i++;  
    Set tmp2 = RhymeSets.get(rNum).get(i);
      for(int i = 0; i < RhymeSets.get(rNum).get(i)._words.size()){
         
      }
    }*/
    /*i++;
    while(tmp._rhymeId.equals(RhymeSets.get(rNum).get(i)._rhymeId) && i < RhymeSets.get(rNum).size()){
      i++;
    }
    println(RhymeSets.get(rNum).get(i)._rhymeId+" : "+RhymeSets.get(rNum).get(i)._words);
    //COME BACK TO THIS!!!
    //sort alpabetically
    //combine sets (two at a time) add [night, bogan] to [night, lake] iff [bogan, lake] exists with same rhyme_id.
    
   }*/
  }
  
  public void renderCombinedRhymes() {
    int ruleNum = 0;
    int start;
    boolean first;
    ArrayList<Integer> sets = new ArrayList<Integer>();
    ArrayList<String> res1;

    Line l, m;
    Word[] words, words2;

    for ( int k = 0; k < _poem.getNumLines (); k++ ) {  //looping through lines. 

      l = _poem.getLine(k);
      words = l.getWords();

      currWords1 = words; //for cross words

        for (int i = 0; i < words.length; i++) {
        if (words[i]._exists == false || words[i].isWord == false) {
          continue;
        }

        first = true;
        boolean duplicate = false;
        

        for ( int h = k; h < _poem.getNumLines (); h++ ) {      //looping through all other words after word[i]
          m = _poem.getLine(h);

          words2 = m.getWords();

          currWords2 = words2; //for crossWords

          if (h==k) {
            start = i+1;
          } else {
            start = 0;
          } 
          for (int j = start; j < words2.length; j++) { 
            if (words2[j]._exists == false || words2[j].isWord == false) {
              continue;
            }
            
            ArrayList< ArrayList<String> > resultCombined = new ArrayList< ArrayList<String> >();
            
            if (combineRules) { //make more efficient
              int cont = 0;
              for (int ru = 0; ru < rules.size (); ru++) { //if any don't have matches, move to next...
                ArrayList<String> result2 = rhymePairRule2(words[i], words2[j], rules.get(ru), i, j, false);
                if (rules.get(ru).bimatch) {
                  result2.addAll(rhymePairRule2(words2[j], words[i], rules.get(ru), j, i, true));
                }
                if (result2.size() == 0) {
                  cont = 1;
                } else {
                  resultCombined.add(result2);
                }
              }
              if (cont == 1) {
                continue;
              }
            }
            
            

            /*ArrayList<String> result = rhymePairRule2(words[i], words2[j], _rule, i, j, false);
            if (_rule.bimatch) {
              result.addAll(rhymePairRule2(words2[j],words[i], _rule, i, j, true));
              //result.addAll(rhymePairRule2(words2[j], words[i], _rule, j, i, true)); //if bimatch - try other direction - may need to do this regardless
            }
            if (result.size() == 0) { //no match - move to next word
              continue;
            }*/
            
             ArrayList<String> result = getPermutations(resultCombined);
            
            for (int ii = 0; ii < result.size (); ii++) { //loop through all poss matches
              duplicate = false;
              int set = 100000;
              //check to see if rhyme alread exists, in which case, add to existing. Otherwise...
              for (int n = 0; n < RhymeSets.get (ruleNum).size(); n++) {
                if (result.get(ii).equals(RhymeSets.get(ruleNum).get(n)._rhymeId)) {
                  int f = 0;
                  /*if(_rule.bimatch || _rule.noMatch){
                  ArrayList<String> result2 = new ArrayList<String>();
                  ArrayList<String> result3 = new ArrayList<String>();
                  for (int mm = 0; mm < RhymeSets.get (ruleNum).get(n)._wrds.size(); mm++) {
                    //println(mm);
                    if(words[i] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                    result2.add("equals");
                    result3 = rhymePairRule2(words2[j], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    //println("res3: "+result3);
                    }else if(words2[j] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                    result3.add("equals");  
                    result2 = rhymePairRule2(words[i], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    //println("res2: "+result2);
                    }else{
                      result2 = rhymePairRule2(words[i], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                      result3 = rhymePairRule2(words2[j], RhymeSets.get(ruleNum).get(n)._wrds.get(mm), _rule, i, j, false);
                    }
                    if (_rule.bimatch) {
                      if(words[i] != RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                      result2.addAll(rhymePairRule2(RhymeSets.get(ruleNum).get(n)._wrds.get(mm), words[i], _rule, j, i, true)); //if bimatch - try other direction - may need to do this regardless
                      }
                      if(words2[j] == RhymeSets.get(ruleNum).get(n)._wrds.get(mm)){
                      result3.addAll(rhymePairRule2(RhymeSets.get(ruleNum).get(n)._wrds.get(mm), words2[j], _rule, j, i, true));  
                      }
                    }
                    if (result2.size() == 0 || result3.size() == 0) {
                      //println("rs: "+result2.size()+" r3: "+result3.size());
                      f++;
                    }
                    result2.clear();
                    result3.clear();
                    //println("f: "+f);
                  }
                  }*/
                  if(f > 0){
                    duplicate = false; 
                  }else{
                    duplicate = true;
                    set = n; 
                  }
                }
              }
              //duplicate = false;
              if (duplicate == false) {  //create new rhyme set
                //println("new set!");
                Set _set = new Set(ruleNum);
                _set._setIds.add(words[i].wrdcount);
                _set._setIds.add(words2[j].wrdcount);
                _set._wrds.add(words[i]);
                _set._wrds.add(words2[j]);
                ///*":"+words[i].pronNum+*//*":"+words2[j].pronNum+*/
                _set._words.add(words[i].getDisplayWord()+"("+words[i].wrdcount+")");
                _set._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                _set._rhymeId = result.get(ii);
                _set._crossWrd = 0;//_rule.crossWrd;
                RhymeSets.get(ruleNum).add(_set);
              } else if (duplicate == true && set != 100000) {
                boolean dup1 = false;
                boolean dup2 = false;
                int num = 10000;
                for (int it = 0; it < RhymeSets.get (ruleNum).get(set)._setIds.size(); it++) {
                  if (words[i].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup1 = true;
                  } else if (words2[j].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup2 = true; 
                    num = it;
                  }
                  //num = it;
                  //println("duplicate!");
                }
                if (dup1 == false && num != 10000) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(num, words[i].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(num, words[i].getDisplayWord()+"("+words[i].wrdcount+")"); 
                  RhymeSets.get(ruleNum).get(set)._wrds.add(num, words[i]);
                }
                if (dup2 ==  false) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(words2[j].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                  RhymeSets.get(ruleNum).get(set)._wrds.add(words2[j]);
                }
              }
            }//for (ii)
          }
        }
      }
    }
  }

  public void renderCombinedRhymes2() {
    int ruleNum = 0;
    int start;
    boolean first;
    ArrayList<Integer> sets = new ArrayList<Integer>();

    Line l, m;
    Word[] words, words2;

    for ( int k = 0; k < _poem.getNumLines (); k++ ) {  //looping through lines. 

      l = _poem.getLine(k);
      words = l.getWords();

      currWords1 = words;

      for (int i = 0; i < words.length; i++) {
        if (words[i]._exists == false || words[i].isWord == false) {
          continue;
        }

        first = true;
        boolean duplicate = false;

        for ( int h = k; h < _poem.getNumLines (); h++ ) {      //looping through all other words after word[i]
          m = _poem.getLine(h);
          words2 = m.getWords();

          currWords2 = words2;

          if (h==k) {
            start = i+1;
          } else {
            start = 0;
          } 
          for (int j = start; j < words2.length; j++) { 
            if (words2[j]._exists == false || words2[j].isWord == false) {
              continue;
            }
            //detect rhyme
            ArrayList< ArrayList<String> > resultCombined = new ArrayList< ArrayList<String> >();
            if (comment)
              println("Combined: "+resultCombined);
            if (combineRules) { //make more efficient
              int cont = 0;
              for (int ru = 0; ru < rules.size (); ru++) { //if any don't have matches, move to next...
                ArrayList<String> result2 = rhymePairRule2(words[i], words2[j], rules.get(ru), i, j, false);
                if (rules.get(ru).bimatch) {
                  result2.addAll(rhymePairRule2(words2[j], words[i], rules.get(ru), j, i, true));
                }
                if (result2.size() == 0) {
                  cont = 1;
                } else {
                  resultCombined.add(result2);
                }
              }
              if (cont == 1) {
                continue;
              }
            }


            ArrayList<String> result = getPermutations(resultCombined);


            if (result.size() == 0) { //no match - move to next word
              continue;
            }
            if (comment)
              println("Permutations: "+result);


            //println("what we're working with... "+result);
            for (int ii = 0; ii < result.size (); ii++) { //loop through all poss matches
              duplicate = false;
              int set = 100000;
              //check to see if rhyme alread exists, in which case, add to existing. Otherwise...
              for (int n = 0; n < RhymeSets.get (ruleNum).size(); n++) {
                if (result.get(ii).equals(RhymeSets.get(ruleNum).get(n)._rhymeId)) {
                  duplicate = true;
                  set = n;
                }
              }
              if (duplicate == false) {  //create new rhyme set
                if (comment) {
                  println("new set!");
                }
                Set _set = new Set(ruleNum);
                _set._setIds.add(words[i].wrdcount);
                _set._setIds.add(words2[j].wrdcount);
                _set._wrds.add(words[i]);
                _set._wrds.add(words2[j]);

                _set._words.add(words[i].getDisplayWord()+"("+words[i].wrdcount+")");
                _set._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                _set._rhymeId = result.get(ii);
                RhymeSets.get(ruleNum).add(_set);
              } else if (duplicate == true && set != 100000) {
                boolean dup1 = false;
                boolean dup2 = false;
                int num = 10000;
                for (int it = 0; it < RhymeSets.get (ruleNum).get(set)._setIds.size(); it++) {
                  if (words[i].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup1 = true;
                  } else if (words2[j].wrdcount == RhymeSets.get(ruleNum).get(set)._setIds.get(it)) {
                    dup2 = true; 
                    num = it;
                  }
                  //num = it;
                  //println("duplicate!");
                }
                if (dup1 == false && num != 10000) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(num, words[i].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(num, words[i].getDisplayWord()+"("+words[i].wrdcount+")"); 
                  RhymeSets.get(ruleNum).get(set)._wrds.add(num, words[i]);
                }
                if (dup2 ==  false) {
                  RhymeSets.get(ruleNum).get(set)._setIds.add(words2[j].wrdcount); 
                  RhymeSets.get(ruleNum).get(set)._words.add(words2[j].getDisplayWord()+"("+words2[j].wrdcount+")");
                  RhymeSets.get(ruleNum).get(set)._wrds.add(words2[j]);
                }
              }
            }//for (ii)
          }
        }
      }
    }
  }


  public void printRhymeSets(PrintWriter output) {
    output.println("IMPORTANT: please make sure to close file before rerunning program");
    if (combineRules) {
      output.println("\nCombined Rules:");
      for (int i = 0; i < rules.size (); i++) {
        output.println("Rule "+i+": "+rules.get(i).strRule);
      }
      output.println("\nDetected Rhymes:\n");
      for (int j = 0; j < RhymeSets.get (0).size(); j++) {
        output.println(RhymeSets.get(0).get(j)._rhymeId + ": "+RhymeSets.get(0).get(j).printWrds());
        println();
      }
      output.println("\n");
    } else {
      output.println("\nDetected Rhymes\n");
      for (int i = 0; i < rules.size (); i++) {
        output.println("Rule "+i+": "+rules.get(i).strRule);
        for (int j = 0; j < RhymeSets.get (i).size(); j++) {
          output.println(RhymeSets.get(i).get(j)._rhymeId + ": "+RhymeSets.get(i).get(j).printWrds());
        }
        output.println("\n");
      }
    }
  }  

  public void printPoemWithIDs(PrintWriter output, PrintWriter uncertainty, String filename) {
    output.println("\n\nPoem with word IDs:\n");
    int count  = 0;
    Line l;
    Word[] words;
    String multis = "";
    String multis2 = "";
    String Lts = "";
    String Lts2 = "";
    for ( int k = 0; k < _poem.getNumLines (); k++ ) {  //looping through lines.
      l = _poem.getLine(k);
      words = l.getWords();
      for (int i = 0; i < words.length; i++) {
        output.print(words[i].getDisplayWord() + "("+words[i].wrdcount+") ");
        if (words[i]._2DSyllables != null && words[i]._2DSyllables.length > 1 && !words[i]._lts) {  //add to list of words with possible modifications
          multis += "\n"+words[i].getDisplayWord();
          multis2 += "\n%"+words[i].getDisplayWord();
          for (int n = 0; n < words[i]._2DSyllables.length; n++) {
            String syll = "";
            for (int m = 0; m < words[i]._2DSyllables[n].length; m++) {
              if (m > 0) {
                syll += " - ";
              }
              syll += words[i]._2DSyllables[n][m].returnStringsp(words[i]._2DSyllables[n][m]._fullSyll);//+words[i]._2DSyllables[n][m]._stress;
            }
            multis += " ("+words[i].wrdcount+":"+n+") "+syll;
            multis2 += " ("+words[i].wrdcount+":"+n+") "+syll;
          }
          multis2 += "\n"+words[i].wrdcount+":"+words[i].pronNum;
          if (customPron[words[i].wrdcount]!= null) {
            multis2 += ":"+customPron[words[i].wrdcount].replaceAll("_", " ").trim();
          }
        }
        if (words[i]._lts) {
          Lts += "\n"+words[i].getDisplayWord();
          Lts2 += "\n%"+words[i].getDisplayWord();
          for (int n = 0; n < words[i]._2DSyllables.length; n++) {
            String syll = "";
            for (int m = 0; m < words[i]._2DSyllables[n].length; m++) {
              if (m > 0) {
                syll += "-";
              }
              syll += " "+words[i]._2DSyllables[n][m].returnStringsp(words[i]._2DSyllables[n][m]._fullSyll);//+words[i]._2DSyllables[n][m]._stress;
            }
            Lts += " ("+words[i].wrdcount+":"+n+") "+syll;
            Lts2 += " ("+words[i].wrdcount+":"+n+") "+syll;
          }
          Lts2 += "\n"+words[i].wrdcount+":"+words[i].pronNum;
          if (customPron[words[i].wrdcount]!= null) {
            Lts2 += ":"+customPron[words[i].wrdcount].replaceAll("_", " ").trim();
          }
        }
      }
      output.println();
      //uncertainty.println();
    }
    output.println("\n\nWords with multiple pronunciations: (word ID: pronunciation number)\nTo change any of the current pronunciations, please see "+filename+"_uncertainty.txt in the Poems directory");
    output.println(multis);
    output.println("\n\nOut-of-dictionary words & pronunciations: (word ID: pronunciation number)\nTo change any of the current pronunciations, please see "+filename+"_uncertainty.txt in the Poems directory");
    output.println(Lts);
    uncertainty.println("IMPORTANT: please make sure to save and close file before rerunning program");
    uncertainty.println("\n\nWords with multiple pronunciations: (word ID: pronunciation number)\nTo change any of the current pronunciations, replace the \"pronunciation number\" (in the uncommented line) the number of your choice");
    uncertainty.println("********Modifications******");
    uncertainty.println(multis2);
    uncertainty.println("********End******");
    uncertainty.println("\n\nOut-of-dictionary words: (word ID: pronunciation number)\nTo change any of the current pronunciations, replace the \"pronunciation number\" (in the uncommented line) the number of your choice");
    uncertainty.println("********Modifications******");
    uncertainty.println(Lts2);
    uncertainty.println("********End******");
  }

  /*void printUncertaintyFile(PrintWriter output) {
   output.println("\n\nPronunciations:\n");
   Line l;
   Word[] words;
   String multis = "";
   for ( int k = 0; k < _poem.getNumLines(); k++ ) {  //looping through lines.
   l = _poem.getLine(k);
   words = l.getWords();
   for (int i = 0; i < words.length; i++) {
   count++;
   if(words[i]._2DSyllables.length > 1){  //add to list of words with possible modifications
   multis += "\n"+words[i].getDisplayWord();
   for (int n = 0; n < words[i]._2DSyllables.length; n++) {
   String syll = "";
   for (int m = 0; m < words[i]._2DSyllables[n].length; m++) {
   if(m > 0){
   syll += "-";
   }
   syll += words[i]._2DSyllables[n][m].returnString(words[i]._2DSyllables[n][m]._fullSyll);
   }
   multis += " ("+words[i].wrdcount+":"+n+") "+syll;
   } 
   }
   }
   output.println();
   }
   output.println("\n\nWords with multiple pronunciations: (word ID: pronunciation number)\nTo change any of the current pronunciations, please see Uncertainty.txt in the Poems directory");
   output.println(multis);
   }*/


  ///////////////////////////detect rhymes//////////////////////////////////



  /////////////////////////// Rhyme Detector //////////////////////////////
  public void detectRhyme(String _rhymeRule) {

    //String rule = RhymeRule;  

    rhymerule rule = new rhymerule(_rhymeRule);

    float x = 0;
    float x1 = 0;
    int y = _poem_y;
    int y1 = _poem_y;
    int line_spacing = 5;
    int start;
    boolean first;

    float x1b, y1b, x2b, y2b, x3b, y3b, x4b, y4b;
    x1b = y1b = x2b = y2b = x3b = y3b = x4b = y4b = 0;

    Line l, l2;
    Word[] words, words2;

    //without storing location, etc...
    for ( int k = startRow; k < _poem.getNumLines (); k++ ) {  //looping through lines.
      l = _poem.getLine(k);
      words = l.getWords();   

      for (int i = 0; i < words.length; i++) {

        //skip if not a word
        if (words[i].isWord == false || words[i]._exists == false ) {
          continue;
        }

        first = true;
        boolean duplicate = false;

        for ( int h = k; h < _poem.getNumLines (); h++ ) {
          l2 = _poem.getLine(h);
          words2 = l2.getWords();


          if (h==k) {
            x1 = x+textWidth( words[i].getDisplayWord() + " " );
            start = i+1;
          } else {
            x1 = 0;
            start = 0;
          }

          for (int j = start; j < words2.length; j++) {

            if (words2[j].isWord == false || words2[i]._exists == false) {
              continue;
            }

            //String result = rhymePairRule(words[i], words2[j], rule);
          }//end loop through second words
        } //end second word loop
      }
    }
  } //detect rhyme
}



//Load existing rules
public void addExistingRules() {
  existingRules.add(new rhymerule("Identical Rhyme/Rhyme Riche", "[... - O N C^ - ...]"));
  existingRules.add(new rhymerule("Perfect Masculine", "... - O [N C]'"));
  existingRules.add(new rhymerule("Perfect Feminine", "... - O [N C' - O N C]"));
  existingRules.add(new rhymerule("Perfect Dactylic", "... - O [N C' - O N C - O N C]"));
  existingRules.add(new rhymerule("Semirhyme", "... - O [N C]' & ... - O [N][C]' - [O] N C"));
  existingRules.add(new rhymerule("Syllabic Rhyme", "... - O [N C]' & ... - O [N C]"));
  existingRules.add(new rhymerule("Consonant Slant Rhyme", "... - O N [C`]' - ..."));
  existingRules.add(new rhymerule("Vowel Slant Rhyme", "... - O [N] C' - ..."));
  existingRules.add(new rhymerule("Pararhyme", "... - [O`] N [C`]' - ..."));
  existingRules.add(new rhymerule("Syllabic 2 Rhyme", "O [N C]' - ..."));
  //existingRules.add(new rhymerule("Imperfect consonant slant", "... - O N ~[C]' - ..."));
  existingRules.add(new rhymerule("Alliteration", "...-[O`] N C'-..."));
  existingRules.add(new rhymerule("Assonance", "...-O [N] C^-..."));
  existingRules.add(new rhymerule("Consonance", "...-[O`]|[C`]^-..."));
  existingRules.add(new rhymerule("Forced Rhyme", "...-O [N C_{mv}]'-..."));
  existingRules.add(new rhymerule("Char cluster 2", "...[YY]..."));
  existingRules.add(new rhymerule("Char cluster 2 mixed", "...[YY]*..."));
  existingRules.add(new rhymerule("Anagram", "[...YY...]*"));
  existingRules.add(new rhymerule("Eye rhyme", "!O[NC^-...]"));
}

//class for indivdual rhyme elements

class matchU {
  int type; //0 = syllable; 1 = character; 2 ellipse
  int index_b; //syllable/character index from begining of word
  int bn;
  int en; //0/1 means no/yes preceeding/trailing ellipses;
  int index_e; //syllable/character index from end of word
  int word; //for ':' 0 equals current rules > '0' means proceeding words - not this might run into issues when proceeding word is rhyming word.  
  String subtype; //for syllables O N C; for chars A B or Y
  int stress;  //either 0,1,2 for syllable (2 - either); null for chars
  int mix; //either 0/1 for no/yes for chars; null for sylls. 
  int nellipses;
  boolean struct; //true means phonetic rule for sylls; true means structural (vowel, consonant) for chars
  //ArrayList<String> structStr = new ArrayList<String>(); //to store the struct info
  boolean tilde; //for ~ (both sylls and letters).
  String[] structArray;
  int[] wArray;
  int last;  //distance from last object
  boolean ellipseOn, ellipseOutOn;  //to the right... handle the last after 
  int next;  //distance from last object
  boolean ellipseOnR, ellipseOutOnR;  //to the right... handle the last after 
  boolean rhymeSeg;
  int wrdNum;
  boolean req;
  boolean crossSubt = false;
  
  matchU(matchU m){
    type = m.type; 
    index_b = m.index_b; 
    bn = m.bn;
    index_e = m.index_e; 
    en = m.en;
    nellipses = m.nellipses;
    subtype = m.subtype;
    stress = m.stress;
    mix = m.mix;
    tilde = m.tilde;
    struct = m.struct;
    rhymeSeg = m.rhymeSeg;
    word = m.word;
    //process struct info
    structArray = new String[subtype.length()];
    //hopefully this can transfer too...
    //structArray = new String[subtype.length()]; //this will def be long enough 
    processStruct();
    
  }
  
  //Using this one!
  
  matchU(int t, int ind_b, int ind_e, int _bn, int _en, int numEs, String subt, int _stress, int _mix, boolean _struct, boolean _tilde, boolean _rhymeSeg, int _word, boolean _req) {
    //println("new match "+subt);
    type = t; 
    index_b = ind_b; 
    bn = _bn;
    index_e = ind_e; 
    en = _en;
    nellipses = numEs;
    subtype = subt;
    stress = _stress;
    mix = _mix;
    tilde = _tilde;
    struct = _struct;
    rhymeSeg = _rhymeSeg;
    word = _word;
    req = _req;
    //process struct info
    structArray = new String[subtype.length()]; //this will def be long enough 
    processStruct();
    if(t == 1 && subt.indexOf(":") != -1){
      processWStruct();
    }
  }
  
  
  //Used for "or" functions
  matchU(int t, int ind_b, int ind_e, int _bn, int _en, String subt, int _stress, int _mix, int numEs, boolean struct, boolean _tilde, int _last, boolean _ellipseOn, boolean _ellipseOutOn ) {
    type = t; 
    index_b = ind_b; 
    bn = _bn;
    index_e = ind_e; 
    en = _en;
    subtype = subt;
    stress = _stress;
    mix = _mix;
    nellipses = numEs;
    tilde = _tilde;
    last = _last;
    ellipseOn = _ellipseOn;
    ellipseOutOn = _ellipseOutOn;
    //next = _next;
    //ellipseOnr = _ellipseOnr;
    //ellipseOnOutr = _ellipseOnOutr;
    //process struct info
    structArray = new String[subtype.length()]; //this will def be long enough 
    processStruct();
  }
  
  public void processWStruct(){
    wArray = new int[subtype.length()];
    crossSubt = true; 
  }
  
  public void processStruct(){
    int ind = 0;
    String tmpStr = "";
    String checkStr = "";
    int ch = 0;
    int ad = 0;
    while(subtype.indexOf("_") != -1){ //struct info
     ad = 0;
     if(type == 1 && ch == 0){ //check if not first
     ch = subtype.indexOf("_")-1;
     }
     if(subtype.indexOf('{') != -1 && subtype.indexOf('}') != -1 && subtype.indexOf('{') < subtype.indexOf('}')){
         tmpStr = subtype.substring(subtype.indexOf('{')+1, subtype.indexOf('}')).toLowerCase();
         //println(tmpStr);
         //check if anything other than mvp - then illegal
         if(type == 0){ //only mvp allowed
         checkStr = tmpStr.replaceAll("[mvp]","");
         }else if(type == 1){ //only s (struct) allow
         checkStr = tmpStr.replaceAll("s","");
         }
         if(checkStr.length() > 0){
          println("Illegal Rule: "+ subtype);
         }else{
         //structStr.add(ch+"_"+tmpStr);
         structArray[ch] = tmpStr;
         }
         int last = subtype.indexOf('}');
         int next = subtype.indexOf('_',last);
         if(next != -1){
           ad = next-last-1;
         }
         subtype = subtype.replaceFirst("_\\{"+tmpStr+"\\}","");
       }else{
        break; 
       }
      ch+=ad;
    }
   if(comment)
   println(structArray);
  }

  public ArrayList<String> getMatch(Syllable[] _syll, char[] _wrd) {
    ArrayList<String> res = new ArrayList<String>();
    Syllable tmp;
    String phTmp = "";
    //println("syll length "+_syll.length);
    if (type == 0) { //syllables!
      if ((index_b-nellipses) > _syll.length-1 || (index_e-nellipses) > _syll.length-1) {  //doesn't fit word. This should probably also be checked a step earlier
        println("too short!");
        return res;
      }
      if (en == 0 && bn == 0) {//no ellipses - either side (check that syllable is in correct location
      if(!getONC(_syll[index_b]).equals(getONC(_syll[_syll.length-1-index_e]))){
        println("syll locations do not coincide");
        return res;
      }else{
        phTmp = getONC(_syll[index_b]);
        if (phTmp.length() > 0) {
          res.add(phTmp);
        }
      }
        //}
        return res;
      } else if (bn == 0) { //no ellipses from beg - real val
        //println("from beg");
        //O[NC']-ONC-... -> check that syll is at least one in from the end...
        if(((_syll.length-1)-index_b)< (index_e-en)){
          println("Not far enough from end");
          return res;
        }
        
        phTmp = getONC(_syll[index_b]);
        
        if (phTmp.length() > 0) {
          res.add(phTmp);
        }
        return res;
      } else if (en == 0) { //no ellipse from end
        //println("from end");
        //println(index_e);
        if(((_syll.length-1)-index_e)<(index_b-bn)){
          println("Not far enough from beg");
          return res;
        }
        phTmp = getONC(_syll[_syll.length-1-index_e]);
        if (phTmp.length() > 0) {
          res.add(phTmp);
        }
        return res;
      } else {
        //println("ellipse on either side");
        //ellipse on either side
        if (stress == 1) { //find stressed syllable
          for (int j = 0; j < _syll.length; j++) {
            if (_syll[j]._stress.equals("1"))
              phTmp = getONC(_syll[j]);
          }
          if (phTmp.length() > 0) {
            res.add(phTmp);
          }
          return res;
        } else { //will have many different options - like with consonance/assonance
          for (int j = 0; j < _syll.length; j++) { //check each syllable for possibility
            //println(_syll[j].returnString(_syll[j].getFullSyll()));
            phTmp = getONC(_syll[j]);
            if (phTmp.length() > 0) {
              res.add(phTmp);
            }
          }
          return res;
        }
      }
    } else if (type == 1) { //chars!!!
      if(subtype.length() > _wrd.length){
       //println("word too short");
       return res; 
      }
      if(bn == 0 && en == 0){ //FINISH THIS PART!
        
      }else if(bn == 0){
        
      }else if(en == 0){
        
      }else{
      res = getCluster(_wrd);
      return res;//work on this next
      }
    } 
    return res;
  }
  
  
  //need to take mix into account
  //see if in finite location - if not, then include all possibilities - work location into this...
  public ArrayList<String> getCluster(char[] _wrd){
   ArrayList<String> cluster = new ArrayList<String>();
   //ABcAY
   char tmp;
   String tmpMatch;
   
   if(mix == 0){
   for(int i = 0; i <= _wrd.length-subtype.length(); i++){
     //println("length: "+(_wrd.length-subtype.length()));
     tmpMatch = "";
     for(int j = 0; j < subtype.length(); j++){
       tmp = subtype.charAt(j);
       if(Character.isLowerCase(tmp)){ //check if actual character
         if(tmp == _wrd[i+j]){ //char match!
           tmpMatch += "" + _wrd[i+j];
         }else{
          break; //move to next loop 
         }
        } else if(tmp == 'A'){    //check if vowel
           if(isVowel(_wrd[i+j]) || Character.toUpperCase(_wrd[i+j]) == 'Y'){
            if(structArray[j] != null && structArray[j].equals("s")){
              tmpMatch += "V";
            }else{
            tmpMatch += "" + _wrd[i+j];
            }
           }else{
            break; 
           }
         } else if(tmp == 'B'){  //check if consonant
           if(!isVowel(_wrd[i+j])){
            if(structArray[j] != null && structArray[j].equals("s")){
              tmpMatch += "C";
            }else{
            tmpMatch += "" + _wrd[i+j];
            }
           }else{
            break; 
           }
         } else if(tmp == 'Y'){ //takes anything
           if(structArray[j] != null && structArray[j].equals("s")){
              String tt = (isVowel(_wrd[i+j])) ? "V" : "C";
              tmpMatch += "" + tt;
            }else{
            tmpMatch += "" + _wrd[i+j];
            }
         }
       }
       //println("let's see: "+tmpMatch);
       if(tmpMatch.length() == subtype.length()){
       cluster.add(tmpMatch);
       }
     }
   } else if(mix == 1){ //mix
   //println("Mix!");
     String wrdStr = new String(_wrd);
     for(int i = 0; i <= _wrd.length-subtype.length(); i++){
       tmpMatch =  wrdStr.substring(i,i+subtype.length());
       //println(tmpMatch);
       String res = "";
       String delete = tmpMatch;
       //println("tmp: "+tmpMatch);
       //loop through and delete each...do chars, A/B, Y
       String sSubtype = sortMix(subtype); 
       for(int j = 0; j < sSubtype.length(); j++){
       tmp = sSubtype.charAt(j);
       if(Character.isLowerCase(tmp)){ //check if actual character
         //println(tmp + " " + delete);
         //println("index of tmp "+ delete.indexOf(""+tmp));
         if(delete.indexOf(""+tmp) != -1){ //char match!
           delete = delete.replace(""+tmp,""); //removes first match
           res += tmp;
         }else{
          //println("breaking");
          break; //move to next loop 
         }
        } else if(tmp == 'A'){    //check if vowel
          int exists = 0;
           for(int k = 0; k < delete.length(); k++){
             if(isVowel(delete.charAt(k)) || Character.toUpperCase(delete.charAt(k)) == 'Y'){
              exists = 1;
              if(structArray[j] != null && structArray[j].equals("s")){
                res += "V";
              }else{
              res += ""+delete.charAt(k);
              }
              delete = delete.replace(""+delete.charAt(k),"");
              break;  
             }
           }
           if(exists == 0){
             break;
           }
         } else if(tmp == 'B'){  //check if consonant
           int exists = 0;
           for(int k = 0; k < delete.length(); k++){
             if(!isVowel(delete.charAt(k))){
              exists = 1;
              if(structArray[j] != null && structArray[j].equals("s")){
                res += "C";
              }else{
              res += ""+delete.charAt(k);
              }
              delete = delete.replace(""+delete.charAt(k),"");
              break;  
             }
           }
           if(exists == 0){
             break;
           }
         } else if(tmp == 'Y'){ //takes anything
           if(delete.length() > 0){
             if(structArray[j] != null && structArray[j].equals("s")){
               String tt = (isVowel(delete.charAt(0))) ? "V" : "C"; 
               res += tt;
              }else{
              res += ""+delete.charAt(0);
              }
           delete = delete.replace(""+delete.charAt(0),"");
           }else{
            break; 
           }
         } 
       }
       //if it makes it here, then it should be a match
       if (delete.equals("")){
        //alpahbetically sort tmpMatch
        //char[] chars = tmpMatch.toCharArray();
        char[] chars = res.toCharArray();
        Arrays.sort(chars);
        String match = new String(chars);
       cluster.add(match); 
       }
     }
   }
     return cluster;
  }
  
  public String sortMix(String subt){
   //sort - lowercase chars, A/B, Y
   String lower = "";
   String lowers = "";
   String AB = "";
   String ABs = "";
   String Y = "";
   String Ys = "";
  for(int i = 0; i < subt.length(); i++){
    if(Character.isLowerCase(subt.charAt(i))){
      lower += ""+subt.charAt(i);
      if(structArray[i] != null && structArray[i].equals("s")){
        lowers += "s";
      }else{
        lowers += "N";
      }
    }else if(subt.charAt(i) == 'A' || subt.charAt(i) == 'B'){
      AB += ""+subt.charAt(i); 
      if(structArray[i] != null && structArray[i].equals("s")){
        ABs += "s";
      }else{
        ABs += "N";
      }
      
    }else if(subt.charAt(i) == 'Y'){
     Y += ""+subt.charAt(i); 
     if(structArray[i] != null && structArray[i].equals("s")){
        Ys += "s";
      }else{
        Ys += "N";
      }
    }
  } 
   
  String f = lower+AB+Y+"_"+lowers+ABs+Ys; //this add the structure
   return f; 
  }
  
  public boolean isVowel(char ch){
    String aeiou = "AEIOUaeiou";
   return  aeiou.indexOf(ch) != -1;
  }

  public String getONC(Syllable _syll) { 
    String res = "";
    if (stress == 0 || stress == 1) { //make sure stress coincides (if stress == 2, then either is fine)
      //println("syllStress "+_syll._stress+" , req stress"+stress);
      if (!_syll._stress.equals(""+stress))
        return res;
    }
    //println("type: "+subtype);
    
    if (subtype.charAt(0)=='O') {    //could write this more efficiently but wouldn't speed up time. 
    //check if _{mvp}
      if(structArray[0] != null){
        res = _syll.getOnsetStruct(structArray[0]); //for this, make sure all match. 
      }else{ 
        res = _syll.returnString(_syll._onset);
      }
    } else if (subtype.charAt(0)=='N') {
      if(structArray[0] != null){
        res = _syll.getNucleusStruct(structArray[0]);
      }else{
      res = _syll.returnString(_syll._nucleus);
      }
    } else if (subtype.charAt(0)=='C') {
       if(structArray[0] != null){
         res = _syll.getCodaStruct(structArray[0]);
         if(comment)
         println("coda struct: "+res);
       }else{
        res = _syll.returnString(_syll._coda);
       }
    } 
    if (res.length() == 0) {    //not all have onset, coda, etc...
    if((subtype.charAt(0)=='C' || subtype.charAt(0)=='O') && req){
        //check for required O or C
    }else{
      res = "_null_";
    }
    }
    return res;
  }
  
  
  public String getCluster2(char[] _wrd, int start, int firstA, int firstB){ //add stressed vowel
   String cluster = "";
   //ABcAY
   char tmp;
   String tmpMatch;
   if(comment)
   println(String.valueOf(_wrd)+" "+start);
   //first check if too short
   if(_wrd.length - start < subtype.length()){
       return cluster;
   }

   if(mix == 0){
   for(int i = start; i <= start; i++){
     //println("length: "+(_wrd.length-subtype.length()));
     tmpMatch = "";
     for(int j = 0; j < subtype.length(); j++){
       
       if(subtype.charAt(j) == '\''){
        continue; //will get picked up in the next round 
       }
       tmp = subtype.charAt(j);
       if(Character.isLowerCase(tmp)){ //check if actual character
         if(tmp == _wrd[i+j]){ //char match!
           tmpMatch += "" + _wrd[i+j];
         }else{
          break; //move to next loop 
         }
        } else if(tmp == 'A'){    //check if vowel
           if(isVowel(_wrd[i+j]) || Character.toUpperCase(_wrd[i+j]) == 'Y'){
             if(subtype.length() > j+1 && subtype.charAt(j+1) == '\''){ //first vowel
            //check if first vowel...
            //println(firstA+" : "+(i+j)+" "+subtype.charAt(j+1));
            if(firstA != i+j){
              break;
              }
             }
             
            if(structArray[j] != null && structArray[j].equals("s")){
              tmpMatch += "V";
            }else{
            tmpMatch += "" + _wrd[i+j];
            }
           }else{
            break; 
           }
         } else if(tmp == 'B'){  //check if consonant
         if(subtype.length() > j+1 && subtype.charAt(j+1) == '\''){ //first vowel
            //check if first vowel...
            if(firstB != i+j){
              break;
            }
           }
           if(!isVowel(_wrd[i+j])){
            if(structArray[j] != null && structArray[j].equals("s")){
              tmpMatch += "C";
            }else{
            tmpMatch += "" + _wrd[i+j];
            }
           }else{
            break; 
           }
         } else if(tmp == 'Y'){ //takes anything
         
           if(structArray[j] != null && structArray[j].equals("s")){
              String tt = (isVowel(_wrd[i+j])) ? "V" : "C";
              tmpMatch += "" + tt;
            }else{
            tmpMatch += "" + _wrd[i+j];
            if(comment)
            println("tmpmatch: "+tmpMatch);
            }
         }
       }
       if(tmpMatch.length() == subtype.replaceAll("'","").length()){
       cluster = tmpMatch;
       }
     }
     //println("cluster:"+cluster);
   } else if(mix == 1){ //mix
   //println("Mix!");
     String wrdStr = new String(_wrd);
     for(int i = start; i <= start; i++){
       tmpMatch =  wrdStr.substring(i,i+subtype.length());
       if(comment){
       println("tmpMatch: "+tmpMatch);
       }
       String res = "";
       String delete = tmpMatch;
       //println("tmp: "+tmpMatch);
       //loop through and delete each...do chars, A/B, Y
       String[] ssSubtype = split(sortMix(subtype),"_"); 
       String sSubtype = ssSubtype[0];
       String sstruct = ssSubtype[1];
       //println(sSubtype);
       for(int j = 0; j < sSubtype.length(); j++){
       tmp = sSubtype.charAt(j);
       if(Character.isLowerCase(tmp)){ //check if actual character
         //println(tmp + " " + delete);
         //println("index of tmp "+ delete.indexOf(""+tmp));
         if(delete.indexOf(""+tmp) != -1){ //char match!
           res += tmp;
           delete = delete.replaceFirst(""+tmp,""); //removes first match
           //println("del: "+delete);
         }else{
          //println("breaking");
          break; //move to next loop 
         }
        } else if(tmp == 'A'){    //check if vowel
          int exists = 0;
           for(int k = 0; k < delete.length(); k++){
             if(isVowel(delete.charAt(k)) || Character.toUpperCase(delete.charAt(k)) == 'Y'){
              exists = 1;
              if(sstruct.charAt(j) == 's'){
                res += "V";
              }else{
              res += ""+delete.charAt(k);
              }
              delete = delete.replace(""+delete.charAt(k),"");
              break;  
             }
           }
           if(exists == 0){
             break;
           }
         } else if(tmp == 'B'){  //check if consonant
           int exists = 0;
           for(int k = 0; k < delete.length(); k++){
             if(!isVowel(delete.charAt(k))){
              exists = 1;
              if(sstruct.charAt(j) == 's'){
                res += "C";
              }else{
              res += ""+delete.charAt(k);
              }
              delete = delete.replace(""+delete.charAt(k),"");
              break;  
             }
           }
           if(exists == 0){
             break;
           }
         } else if(tmp == 'Y'){ //takes anything
           if(delete.length() > 0){
             if(sstruct.charAt(j) == 's'){
               String tt = (isVowel(delete.charAt(0))) ? "V" : "C"; 
               res += tt;
              }else{
              res += ""+delete.charAt(0);
              }
           delete = delete.replace(""+delete.charAt(0),"");
           }else{
            break; 
           }
         } 
       }
       //if it makes it here, then it should be a match
       if (delete.equals("")){
        //alpahbetically sort tmpMatch
        //char[] chars = tmpMatch.toCharArray();
        char[] chars = res.toCharArray();
        Arrays.sort(chars);
        String match = new String(chars);
       cluster = match; 
       }
     }
   }
     return cluster;
  }
};



public class PFrame extends Frame {
    public PFrame() {
        setBounds(0,0,350,700);
        setLocation(980,0);
        s = new secondApplet();
        add(s);
        s.init();
        setTitle("Notation Guide");
        show();
    }
}

public class secondApplet extends PApplet {
    public void setup() {
        size(350, 700);
        noLoop();
    }

    public void draw() {
      textFont( _helvetica_12 );
      textSize(11);
      background(220);
      fill(240);
      noStroke();
      rect(10,42,width-20,230);
      fill(250);
      rect(10,42,width-20,42);
      rect(10,125,width-20,42);
      rect(10,192,width-20,38);
      fill(50);
      pushMatrix();
      translate(10,15);
      text("Rhyme Notation", 0, 0);
      drawNotation();
      popMatrix();
    }
    
    public void drawNotation(){
      int t = 40;
      fill(100);
      textLeading(10);
      String gen = "indicates the matching portion of the rhyming pair (the rhyming segment)\nindicates that additional syllables may or may not exist\nindicates an imperfect match in the rhyme segment\ndistinguishes between the rhyming pair words\nindicates the occurrence of \u201cone or both\u201d\n ";
      textSize(11);
      translate(5,15);
      text("General Rhyme Notation:", -5, 10);
      //textSize(11);
      text("[brackets]",0,30);
      text("indicates the matching portion of the rhyming pair (the rhyming segment)",80,20,230,800);
      translate(0,t);
      textSize(13);
      text("\u2026",0,30);
      textSize(11);
      text("indicates that additional syllables/characters may or may not exist",80,20,230,800);
      //translate(0,t);
      /*textSize(15);
      text("\u02dc",0,30);
      textSize(11);
      text("[brackets]",10,30);
      text("indicates an imperfect match in the rhyme segment (NOT IMPLEMENTED YET)",80,20,230,800);*/ 
      translate(0,t);
      text("&",0,30);
      text("distinguishes between the rhyming pair words",80,20,230,800);
      translate(0,t);
      text("|",0,30);
      text("indicates the occurrence of \"one or both\"",80,20,230,800);
      translate(0,t-15);
      textSize(13);
      text(":",0,30);
      textSize(11);
      text("indicates a word break (e.g. for cross-word rhymes)",80,20,230,800);
      translate(0,t);
      textSize(13);
      text("!",0,30);
      textSize(11);
      text("indicates no match (must be placed at beginning of rule)",80,20,230,800);
      //text(gen,80,20,230,800);
      //text("indicates the matching portion of the rhyming pair (the rhyming segment)\nindicates that additional syllables may or may not exist\nindicates an imperfect match in the rhyme segment\n",40,30);
      
      translate(0,80);
      fill(245);
      rect(-5,0,width-20,180);
      fill(100);
      textLeading(20);
      text("Sonic Rhyme Notation:",-5,0);
      text("O :  Onset (leading consonant phonemes) ; O`: req. Onset\nN :  Nucleus (vowel phoneme)\nC : Coda (ending consonant phonemes) ; C` : req. Coda\n - : Indicates syllable break\n' :  Indicates primary stress\n^ :  Indicates \"stressed or unstressed\"", 0, 5,300,400);
      translate(0,150);
      text("Ext. Phonetic Rhyme Notation:", 0, 0);
      text("_{mpv} : Match Manner, Place, Voice", 0, 10,300,400);
      translate(0, 55);
      fill(245);
      rect(-5,0,width-20,150);
      fill(100);
      text("Visual Rhyme Notation:", -5, 0);
      text("A :  Vowel ; A' : First Vowel\nB :  Consonant ; B' : First Consonant\nY :  Vowel or Consonant\n* : Mixed Character Clusters e.g. \"est/tes\"\nLowercase character : Specific character ", 0, 20);
      translate(0,120);
      text("Ext. Structural Rhyme Notation:", 0, 0);
      text("_{s} :  Match structure (e.g. A_{s} : A/O (vowel/vowel) match)", 0, 20);
      translate(0,45);
      textSize(9);
      text("Link to paper", -5, 0);
      textSize(11);
      
    }
    
    public void mousePressed(){
      if(mouseX < 10 && mouseY < 10){
     f.dispose(); 
      }
    }
} 
class Set {
  float sz; //size of the circle - depends on size of set
  int _id;
  int _setSize;
  int _type;
  String _rhymeId;
  int var;
  PFont _line_font = _georgia_14;
  PFont _title_font = _georgia_16;
  int order = 0;
  int orderNum;
  int _rulenum;
  int _crossWrd;


  //ArrayList<Float> _x = new ArrayList<Float>();
  //ArrayList<Integer> _y = new ArrayList<Integer>();
  ArrayList<setWrd> _setWrds = new ArrayList<setWrd>();
  ArrayList<Integer> _setIds = new ArrayList<Integer>();
  ArrayList<Word> _wrds = new ArrayList<Word>();
  ArrayList<String> _words = new ArrayList<String>();
  ArrayList<String> _allWords = new ArrayList<String>();
  ArrayList<String> _phonetics = new ArrayList<String>();

  Set(int rulenum) {
    _rulenum = rulenum;
  }
  
  public ArrayList<String> printWrds(){
   if(_crossWrd == 0){ 
   return _words; 
   }else{
     _allWords.clear();
    for(int i = 0; i < _wrds.size(); i++){
     String g = _wrds.get(i)._displayWord;
     for(int j = 1; j < _crossWrd+1; j++){
       if(_wrds.get(i).getNext(j) != null){
        g = g+" "+_wrds.get(i).getNext(j)._displayWord; 
       }else{
       }
     }
     _allWords.add(g);
    } 
    return _allWords;
   }
  }

  /*void genSetWrds() {
    for (int i = 0; i < _x.size (); i++) {
      setWrd swTmp = new setWrd(_x.get(i), _y.get(i), _words.get(i), "", "");
      _setWrds.add(swTmp);
    }
    Collections.sort(_setWrds, new setWrdComparable());
    for (int i = 0; i < _x.size (); i++) {
      _x.set(i, _setWrds.get(i)._x);
      _y.set(i, _setWrds.get(i)._y);
      _words.set(i, _setWrds.get(i)._word);
    }
  }*/
}



public class setWrdComparable implements Comparator<setWrd> {

  @Override
    public int compare(setWrd a, setWrd b) {
    return (a._y<b._y ? -1 : (a._y==b._y ? (a._x<b._x ? -1 : 1) : 1));
    //return a.sz
  }
}

public class setComparable2 implements Comparator<Set> {
  
  @Override
    public int compare(Set a, Set b) {
    return a._rhymeId.compareTo(b._rhymeId);
    //return a.sz
  }
}

class setWrd {
  float _x;
  int _y;
  int _selected;
  String _word;
  String _phonetics;
  String _chars;

  setWrd(float x, int y, String word, String phonetics, String chars) {
    _x = x;
    _y = y;
    _word = word;
    _phonetics = phonetics;
    _chars = chars;
  }
};
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "RhymeDesign" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
